---
(4.2.8p18) 2024/05/25 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 3918] Tweak openssl header/library handling. <stenn@ntp.org>
* [Bug 3914] Spurious "Unexpected origin timestamp" logged after time
             stepped. <hart@ntp.org>
* [Bug 3913] Avoid duplicate IPv6 link-local manycast associations.
             <hart@ntp.org>
* [Bug 3912] Avoid rare math errors in ntptrace.  <brian.utterback@oracle.com>
* [Bug 3910] Memory leak using openssl-3 <hart@ntp.org>
* [Bug 3909] Do not select multicast local address for unicast peer.
             <hart@ntp.org>
* [Bug 3903] lib/isc/win32/strerror.c NTstrerror() is not thread-safe.
             <hart@ntp.org>
* [Bug 3901] LIB_GETBUF isn't thread-safe. <hart@ntp.org>
* [Bug 3900] fast_xmit() selects wrong local addr responding to mcast on
             Windows. <hart@ntp.org>
* [Bug 3888] ntpd with multiple same-subnet IPs using manycastclient creates
             duplicate associations. <hart@ntp.org>
* [Bug 3872] Ignore restrict mask for hostname. <hart@ntp.org>
* [Bug 3871] 4.2.8p17 build without hopf6021 refclock enabled fails.
             Reported by Hans Mayer.  Moved NONEMPTY_TRANSLATION_UNIT
             declaration from ntp_types.h to config.h.  <hart@ntp.org>
* [Bug 3870] Server drops client packets with ppoll < 4.  <stenn@ntp.org>
* [Bug 3869] Remove long-gone "calldelay" & "crypto sign" from docs.
             Reported by PoolMUC@web.de. <hart@ntp.org>
* [Bug 3868] Cannot restrict a pool peer. <hart@ntp.org>  Thanks to
             Edward McGuire for tracking down the deficiency.
* [Bug 3864] ntpd IPv6 refid different for big-endian and little-endian.
             <hart@ntp.org>
* [Bug 3859] Use NotifyIpInterfaceChange on Windows ntpd. <hart@ntp.org>
* [Bug 3856] Enable Edit & Continue debugging with Visual Studio.
             <hart@ntp.org>
* [Bug 3855] ntpq lacks an equivalent to ntpdc's delrestrict. <hart@ntp.org>
* [Bug 3854] ntpd 4.2.8p17 corrupts rawstats file with space in refid.
             <hart@ntp.org>
* [Bug 3853] Clean up warnings with modern compilers. <hart@ntp.org>
* [Bug 3852] check-libntp.mf and friends are not triggering rebuilds as
             intended. <hart@ntp.org>
* [Bug 3851] Drop pool server when no local address can reach it.
             <hart@ntp.org>
* [Bug 3850] ntpq -c apeers breaks column formatting s2 w/refclock refid.
             <hart@ntp.org>
* [Bug 3849] ntpd --wait-sync times out. <hart@ntp.org>
* [Bug 3847] SSL detection in configure should run-test if runpath is needed.
             <hart@ntp.org>
* [Bug 3846] Use -Wno-format-truncation by default. <hart@ntp.org>
* [Bug 3845] accelerate pool clock_sync when IPv6 has only link-local access.
             <hart@ntp.org>
* [Bug 3842] Windows ntpd PPSAPI DLL load failure crashes. <hart@ntp.org>
* [Bug 3841] 4.2.8p17 build break w/ gcc 12 -Wformat-security without -Wformat
             Need to remove --Wformat-security when removing -Wformat to
             silence numerous libopts warnings.  <hart@ntp.org>
* [Bug 3837] NULL pointer deref crash when ntpd deletes last interface.
             Reported by renmingshuai.  Correct UNLINK_EXPR_SLIST() when the
             list is empty. <hart@ntp.org>
* [Bug 3835] NTP_HARD_*FLAGS not used by libevent tearoff. <hart@ntp.org>
* [Bug 3831] pollskewlist zeroed on runtime configuration. <hart@ntp.org>
* [Bug 3830] configure libevent check intersperses output with answer. <stenn@>
* [Bug 3828] BK should ignore a git repo in the same directory.
             <burnicki@ntp.org>
* [Bug 3827] Fix build in case CLOCK_HOPF6021 or CLOCK_WHARTON_400A
             is disabled.  <burnicki@ntp.org>
* [Bug 3825] Don't touch HTML files unless building inside a BK repo.
             Fix the script checkHtmlFileDates.  <burnicki@ntp.org>
* [Bug 3756] Improve OpenSSL library/header detection.
* [Bug 3753] ntpd fails to start with FIPS-enabled OpenSSL 3. <hart@ntp.org>
* [Bug 2734] TEST3 prevents initial interleave sync.  Fix from <PoolMUC@web.de>
* Log failures to allocate receive buffers.  <hart@ntp.org>
* Remove extraneous */ from libparse/ieee754io.c
* Fix .datecheck target line in Makefile.am.  <stenn@ntp.org>
* Update the copyright year.  <stenn@ntp.org>
* Update ntp.conf documentation to add "delrestrict" and correct information
  about KoD rate limiting.  <hart@ntp.org>
* html/clockopt.html cleanup.  <stenn@ntp.org>
* util/lsf-times - added.  <stenn@ntp.org>
* Add DSA, DSA-SHA, and SHA to tests/libntp/digests.c. <hart@ntp.org>
* Provide ntpd thread names to debugger on Windows. <hart@ntp.org>
* Remove dead code libntp/numtohost.c and its unit tests. <hart@ntp.org>
* Remove class A, B, C IPv4 distinctions in netof(). <hart@ntp.org>
* Use @configure_input@ in various *.in files to include a comment that
  the file is generated from another pointing to the *.in. <hart@ntp.org>
* Correct underquoting, indents in ntp_facilitynames.m4. <hart@ntp.org>
* Clean up a few warnings seen building with older gcc. <hart@ntp.org>
* Fix build on older FreeBSD lacking sys/procctl.h. <hart@ntp.org>
* Disable [Bug 3627] workaround on newer FreeBSD which has the kernel fix
  that makes it unnecessary, re-enabling ASLR stack gap. <hart@ntp.org>
* Use NONEMPTY_COMPILATION_UNIT in more conditionally-compiled files.
* Remove useless pointer to Windows Help from system error messages.
* Avoid newlines within Windows error messages. <hart@ntp.org>
* Ensure unique association IDs if wrapped. <hart@ntp.org>
* Simplify calc_addr_distance(). <hart@ntp.org>
* Clamp min/maxpoll in edge cases in newpeer(). <hart@ntp.org>
* Quiet local addr change logging when unpeering. <hart@ntp.org>
* Correct missing arg for %s printf specifier in 
  send_blocking_resp_internal(). <hart@ntp.org>
* Suppress OpenSSL 3 deprecation warning clutter. <hart@ntp.org>
* Correct OpenSSL usage in Autokey code to avoid warnings about
  discarding const qualifiers with OpenSSL 3. <hart@ntp.org>
* Display KoD refid as text in recently added message. <hart@ntp.org>
* Avoid running checkHtmlFileDates script repeatedly when no html/*.html
    files have changed. <hart@ntp.org>
* Abort configure if --enable-crypto-rand given & unavailable. <hart@ntp.org>
* Add configure --enable-verbose-ssl to trace SSL detection. <hart@ntp.org>
* Add build test coverage for --disable-saveconfig to flock-build script.
  <hart@ntp.org>
* Remove deprecated configure --with-arlib option. <hart@ntp.org>
* Remove configure support for ISC UNIX ca. 1998. <hart@ntp.org>
* Move NTP_OPENSSL and NTP_CRYPTO_RAND invocations from configure.ac files
  to NTP_LIBNTP. <hart@ntp.org>
* Remove dead code: HAVE_U_INT32_ONLY_WITH_DNS. <hart@ntp.org>
* Eliminate [v]snprintf redefinition warnings on macOS. <hart@ntp.org>
* Fix clang 14 cast increases alignment warning on Linux. <hart@ntp.org>
* Move ENABLE_CMAC to ntp_openssl.m4, reviving sntp/tests CMAC unit tests.
  <hart@ntp.org>
* Use NTP_HARD_CPPFLAGS in libopts tearoff. <hart@ntp.org>
* wire in --enable-build-framework-help

---
(4.2.8p17) 2023/06/06 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 3824] Spurious "ntpd: daemon failed to notify parent!" logged at
             event_sync.  Reported by Edward McGuire.  <hart@ntp.org>
* [Bug 3822] ntpd significantly delays first poll of servers specified by name.
             <hart@ntp.org>  Miroslav Lichvar identified regression in 4.2.8p16.
* [Bug 3821] 4.2.8p16 misreads hex authentication keys, won't interop with
             4.2.8p15 or earlier.  Reported by Matt Nordhoff, thanks to
	     Miroslav Lichvar and Matt for rapid testing and identifying the
	     problem. <hart@ntp.org>
* Add tests/libntp/digests.c to catch regressions reading keys file or with
  symmetric authentication digest output. <hart@ntp.org>

---
(4.2.8p16) 2023/05/31 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3808] Assertion failure in ntpq on malformed RT-11 date <perlinger@ntp.org>
* [Sec 3807] praecis_parse() in the Palisade refclock driver has a
             hypothetical input buffer overflow. Reported by ... stenn@
* [Sec 3806] libntp/mstolfp.c needs bounds checking <perlinger@ntp.org>
  - solved numerically instead of using string manipulation
* [Sec 3767] An OOB KoD RATE value triggers an assertion when debug is enabled.
             <stenn@ntp.org>
* [Bug 3819] Updated libopts/Makefile.am was missing NTP_HARD_* values. <stenn@>
* [Bug 3817] Bounds-check "tos floor" configuration. <hart@ntp.org>
* [Bug 3814] First poll delay of new or cleared associations miscalculated.
             <hart@ntp.org>
* [Bug 3802] ntp-keygen -I default identity modulus bits too small for
             OpenSSL 3.  Reported by rmsh1216@163.com <hart@ntp.org>
* [Bug 3801] gpsdjson refclock gps_open() device name mishandled. <hart@ntp.org>
* [Bug 3800] libopts-42.1.17 does not compile with Microsoft C. <hart@ntp.org>
* [Bug 3799] Enable libopts noreturn compiler advice for MSC. <hart@ntp.org>
* [Bug 3797] Windows getaddrinfo w/AI_ADDRCONFIG fails for localhost when 
             disconnected, breaking ntpq and ntpdc. <hart@ntp.org>
* [Bug 3795] pollskewlist documentation uses | when it shouldn't.
  - ntp.conf manual page and miscopt.html corrections. <hart@ntp.org>
* [Bug 3793] Wrong variable type passed to record_raw_stats(). <hart@ntp.org>
  - Report and patch by Yuezhen LUAN <wei6410@sina.com>.
* [Bug 3786] Timer starvation on high-load Windows ntpd. <hart@ntp.org>
* [Bug 3784] high-load ntpd on Windows deaf after enough ICMP TTL exceeded.
             <hart@ntp.org>
* [Bug 3781] log "Unable to listen for broadcasts" for IPv4 <hart@ntp.org>
* [Bug 3774] mode 6 packets corrupted in rawstats file <hart@ntp.org>
  - Reported by Edward McGuire, fix identified by <wei6410@sina.com>.
* [Bug 3758] Provide a 'device' config statement for refclocks <perlinger@ntp.org> 
* [Bug 3757] Improve handling of Linux-PPS in NTPD <perlinger@ntp.org>
* [Bug 3741] 4.2.8p15 can't build with glibc 2.34 <perlinger@ntp.org>
* [Bug 3725] Make copyright of clk_wharton.c compatible with Debian.
             Philippe De Muyter <phdm@macqel.be>
* [Bug 3724] ntp-keygen with openSSL 1.1.1 fails on Windows <perlinger@ntp.org>
  - openssl applink needed again for openSSL-1.1.1
* [Bug 3719] configure.ac checks for closefrom() and getdtablesize() missing.
             Reported by Brian Utterback, broken in 2010 by <hart@ntp.org>
* [Bug 3699] Problems handling drift file and restoring previous drifts <perlinger@ntp.org>
  - command line options override config statements where applicable
  - make initial frequency settings idempotent and reversible
  - make sure kernel PLL gets a recovered drift componsation
* [Bug 3695] Fix memory leak with ntpq on Windows Server 2019 <perlinger@ntp.org>
* [Bug 3694] NMEA refclock seems to unnecessarily require location in messages
  - misleading title; essentially a request to ignore the receiver status.
    Added a mode bit for this. <perlinger@ntp.org>
* [Bug 3693] Improvement of error handling key lengths <perlinger@ntp.org>
  - original patch by Richard Schmidt, with mods & unit test fixes
* [Bug 3692] /dev/gpsN requirement prevents KPPS <perlinger@ntp.org>
  - implement/wrap 'realpath()' to resolve symlinks in device names
* [Bug 3691] Buffer Overflow reading GPSD output
  - original patch by matt<ntpbr@mattcorallo.com>
  - increased max PDU size to 4k to avoid truncation
* [Bug 3690] newline in ntp clock variable (parse) <perlinger@ntp.org>
  - patch by Frank Kardel
* [Bug 3689] Extension for MD5, SHA-1 and other keys <perlinger@ntp.org>
  - ntp{q,dc} now use the same password processing as ntpd does in the key
    file, so having a binary secret >= 11 bytes is possible for all keys.
    (This is a different approach to the problem than suggested)
* [Bug 3688] GCC 10 build errors in testsuite <perlinger@ntp.org>
* [Bug 3687] ntp_crypto_rand RNG status not known <perlinger@ntp.org>
  - patch by Gerry Garvey
* [Bug 3682] Fixes for warnings when compiled without OpenSSL <perlinger@ntp.org>
  - original patch by Gerry Garvey
* [Bug 3677] additional peer events not decoded in associations listing <perlinger@ntp.org>
  - original patch by Gerry Garvey
* [Bug 3676] compiler warnings (CMAC, interrupt_buf, typo, fallthrough)
  - applied patches by Gerry Garvey
* [Bug 3675] ntpq ccmds[] stores pointer to non-persistent storage
* [Bug 3674] ntpq command 'execute only' using '~' prefix <perlinger@ntp.org>
  - idea+patch by Gerry Garvey
* [Bug 3672] fix biased selection in median cut <perlinger@ntp.org>
* [Bug 3666] avoid unlimited receive buffer allocation <perlinger@ntp.org>
  - follow-up: fix inverted sense in check, reset shortfall counter
* [Bug 3660] Revert 4.2.8p15 change to manycast. <hart@ntp.org>
* [Bug 3640] document "discard monitor" and fix the code. <hart@ntp.org>
  - fixed bug identified by Edward McGuire <perlinger@ntp.org>
* [Bug 3626] (SNTP) UTC offset calculation needs dst flag <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3428] ntpd spinning consuming CPU on Linux router with full table.
             Reported by Israel G. Lugo. <hart@ntp.org>
* [Bug 3103] libopts zsave_warn format string too few arguments <bkorb@gnu.org>
* [Bug 2990] multicastclient incorrectly causes bind to broadcast address.
             Integrated patch from Brian Utterback. <hart@ntp.org>
* [Bug 2525] Turn on automake subdir-objects across the project. <hart@ntp.org>
* [Bug 2410] syslog an error message on panic exceeded. <brian.utterback@oracle.com>
* Use correct rounding in mstolfp(). perlinger/hart
* M_ADDF should use u_int32.  <hart@ntp.org>
* Only define tv_fmt_libbuf() if we will use it. <stenn@ntp.org>
* Use recv_buffer instead of the longer recv_space.X_recv_buffer. hart/stenn
* Make sure the value returned by refid_str() prints cleanly. <stenn@ntp.org>
* If DEBUG is enabled, the startup banner now says that debug assertions
  are in force and that ntpd will abort if any are violated. <stenn@ntp.org>
* syslog valid incoming KoDs.  <stenn@ntp.org>
* Rename a poorly-named variable.  <stenn@ntp.org>
* Disable "embedded NUL in string" messages in libopts, when we can. <stenn@>
* Use https in the AC_INIT URLs in configure.ac.  <stenn@ntp.org>
* Implement NTP_FUNC_REALPATH.  <stenn@ntp.org>
* Lose a gmake construct in ntpd/Makefile.am.  <stenn@ntp.org>
* upgrade to: autogen-5.18.16
* upgrade to: libopts-42.1.17
* upgrade to: autoconf-2.71
* upgrade to: automake-1.16.15
* Upgrade to libevent-2.1.12-stable <stenn@ntp.org>
* Support OpenSSL-3.0

---
(4.2.8p15) 2020/06/23 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3661] memory leak with AES128CMAC keys <perlinger@ntp.org>
* [Bug 3670] Regression from bad merge of 3592 and 3596 <perlinger@ntp.org>
  - fixed a bad merge that happened before 4.2.8-p14. Thanks to
    Sylar Tao for noticing this!
* [Bug 3667] decodenetnum fails with numeric port <perlinger@ntp.org>
  - rewrite 'decodenetnum()' in terms of inet_pton
* [Bug 3666] avoid unlimited receive buffer allocation <perlinger@ntp.org>
  - limit number of receive buffers, with an iron reserve for refclocks
* [Bug 3664] Enable openSSL CMAC support on Windows <burnicki@ntp.org>
* [Bug 3662] Fix build errors on Windows with VS2008 <burnicki@ntp.org>
* [Bug 3660] Manycast orphan mode startup discovery problem. <stenn@ntp.org>
  - integrated patch from Charles Claggett
* [Bug 3659] Move definition of psl[] from ntp_config.h to ntp_config.c <perlinger@ntp.org>
* [Bug 3657] Wrong "Autokey group mismatch" debug message <perlinger@ntp.org>
* [Bug 3655] ntpdc memstats hash counts <perlinger@ntp.org>
  - fix by Gerry garvey
* [Bug 3653] Refclock jitter RMS calculation <perlinger@ntp.org>
  - thanks to Gerry Garvey
* [Bug 3646] Avoid sync with unsync orphan <perlinger@ntp.org>
  - patch by Gerry Garvey
* [Bug 3644] Unsynchronized server [...] selected as candidate <perlinger@ntp.org>
* [Bug 3639] refclock_jjy: TS-JJY0x can skip time sync depending on the STUS reply. <abe@ntp.org>
  - applied patch by Takao Abe
* [Bug 3432] refclocks that 'write()' should check the result <perlinger@ntp.org>
  - plus some more work on warnings for unchecked results

---
(4.2.8p14) 2020/03/03 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3610] process_control() should bail earlier on short packets. stenn@
  - Reported by Philippe Antoine
* [Sec 3596] Highly predictable timestamp attack. <stenn@ntp.org>
  - Reported by Miroslav Lichvar
* [Sec 3592] DoS attack on client ntpd <perlinger@ntp.org>
  - Reported by Miroslav Lichvar
* [Bug 3637] Emit the version of ntpd in saveconfig.  stenn@
* [Bug 3636] NMEA: combine time/date from multiple sentences <perlinger@ntp.org>
* [Bug 3635] Make leapsecond file hash check optional <perlinger@ntp.org>
* [Bug 3634] Typo in discipline.html, reported by Jason Harrison.  stenn@
* [Bug 3628] raw DCF decoding - improve robustness with Zeller's congruence
  - implement Zeller's congruence in libparse and libntp <perlinger@ntp.org>
* [Bug 3627] SIGSEGV on FreeBSD-12 with stack limit and stack gap <perlinger@ntp.org>
  - integrated patch by Cy Schubert
* [Bug 3620] memory leak in ntpq sysinfo <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3619] Honour drefid setting in cooked mode and sysinfo <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3617] Add support for ACE III and Copernicus II receivers <perlinger@ntp.org>
  - integrated patch by Richard Steedman
* [Bug 3615] accelerate refclock startup <perlinger@ntp.org>
* [Bug 3613] Propagate noselect to mobilized pool servers <stenn@ntp.org>
  - Reported by Martin Burnicki
* [Bug 3612] Use-of-uninitialized-value in receive function <perlinger@ntp.org>
  - Reported by Philippe Antoine
* [Bug 3611] NMEA time interpreted incorrectly <perlinger@ntp.org>
  - officially document new "trust date" mode bit for NMEA driver
  - restore the (previously undocumented) "trust date" feature lost with [bug 3577] 
* [Bug 3609] Fixing wrong falseticker in case of non-statistic jitter <perlinger@ntp.org>
  - mostly based on a patch by Michael Haardt, implementing 'fudge minjitter'
* [Bug 3608] libparse fails to compile on S11.4SRU13 and later <perlinger@ntp.org>
  - removed ffs() and fls() prototypes as per Brian Utterback
* [Bug 3604] Wrong param byte order passing into record_raw_stats() in
	ntp_io.c <perlinger@ntp.org>
  - fixed byte and paramter order as suggested by wei6410@sina.com 
* [Bug 3601] Tests fail to link on platforms with ntp_cv_gc_sections_runs=no <perlinger@ntp.org>
* [Bug 3599] Build fails on linux-m68k due to alignment issues <perlinger@ntp.org>
  - added padding as suggested by John Paul Adrian Glaubitz 
* [Bug 3594] ntpd discards messages coming through nmead <perlinger@ntp.org>
* [Bug 3593] ntpd discards silently nmea messages after the 5th string <perlinger@ntp.org>
* [Bug 3590] Update refclock_oncore.c to the new GPS date API <perlinger@ntp.org>
* [Bug 3585] Unity tests mix buffered and unbuffered output <perlinger@ntp.org>
  - stdout+stderr are set to line buffered during test setup now
* [Bug 3583] synchronization error <perlinger@ntp.org>
  - set clock to base date if system time is before that limit
* [Bug 3582] gpsdjson refclock fudgetime1 adjustment is doubled <perlinger@ntp.org>
* [Bug 3580] Possible bug ntpq-subs (NULL dereference in dogetassoc) <perlinger@ntp.org>
  - Reported by Paulo Neves
* [Bug 3577] Update refclock_zyfer.c to the new GPS date API <perlinger@ntp.org>
  - also updates for refclock_nmea.c and refclock_jupiter.c
* [Bug 3576] New GPS date function API <perlinger@ntp.org>
* [Bug 3573] nptdate: missleading error message <perlinger@ntp.org>
* [Bug 3570] NMEA driver docs: talker ID not mentioned, typo <perlinger@ntp.org>
* [Bug 3569] cleanup MOD_NANO/STA_NANO handling for 'ntpadjtimex()' <perlinger@ntp.org>
  - sidekick: service port resolution in 'ntpdate'
* [Bug 3550] Reproducible build: Respect SOURCE_DATE_EPOCH <perlinger@ntp.org>
  - applied patch by Douglas Royds
* [Bug 3542] ntpdc monlist parameters cannot be set <perlinger@ntp.org>
* [Bug 3533] ntpdc peer_info ipv6 issues <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3531] make check: test-decodenetnum fails <perlinger@ntp.org>
  - try to harden 'decodenetnum()' against 'getaddrinfo()' errors
  - fix wrong cond-compile tests in unit tests
* [Bug 3517] Reducing build noise <perlinger@ntp.org>
* [Bug 3516] Require tooling from this decade <perlinger@ntp.org>
  - patch by Philipp Prindeville
* [Bug 3515] Refactor ntpdmain() dispatcher loop and group common code <perlinger@ntp.org>
  - patch by Philipp Prindeville
* [Bug 3511] Get rid of AC_LANG_SOURCE() warnings <perlinger@ntp.org>
  - patch by Philipp Prindeville
* [Bug 3510] Flatten out the #ifdef nesting in ntpdmain() <perlinger@ntp.org>
  - partial application of patch by Philipp Prindeville
* [Bug 3491] Signed values of LFP datatypes should always display a sign
  - applied patch by Gerry Garvey & fixed unit tests <perlinger@ntp.org>
* [Bug 3490] Patch to support Trimble Resolution Receivers <perlinger@ntp.org>
  - applied (modified) patch by Richard Steedman
* [Bug 3473] RefID of refclocks should always be text format <perlinger@ntp.org>
  - applied patch by Gerry Garvey (with minor formatting changes)
* [Bug 3132] Building 4.2.8p8 with disabled local libopts fails <perlinger@ntp.org>
  - applied patch by Miroslav Lichvar
* [Bug 3094] ntpd trying to listen for broadcasts on a completely ipv6 network
  <perlinger@ntp.org>
* [Bug 2420] ntpd doesn't run and exits with retval 0 when invalid user
             is specified with -u <perlinger@ntp.org>
  - monitor daemon child startup & propagate exit codes
* [Bug 1433] runtime check whether the kernel really supports capabilities
  - (modified) patch by Kurt Roeckx <perlinger@ntp.org>
* Clean up sntp/networking.c:sendpkt() error message.  <stenn@ntp.org>
* Provide more detail on unrecognized config file parser tokens. <stenn@ntp.org>
* Startup log improvements. <stenn@ntp.org>
* Update the copyright year.
* html/confopt.html: cleanup. <stenn@ntp.org>

---
(4.2.8p13) 2019/03/07 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3565] Crafted null dereference attack in authenticated
	     mode 6 packet <perlinger@ntp.org>
  - reported by Magnus Stubman
* [Bug 3560] Fix build when HAVE_DROPROOT is not defined <perlinger@ntp.org>
  - applied patch by Ian Lepore
* [Bug 3558] Crash and integer size bug <perlinger@ntp.org>
  - isolate and fix linux/windows specific code issue
* [Bug 3556] ntp_loopfilter.c snprintf compilation warnings <perlinger@ntp.org>
  - provide better function for incremental string formatting
* [Bug 3555] Tidy up print alignment of debug output from ntpdate <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3554] config revoke stores incorrect value <perlinger@ntp.org>
  - original finding by Gerry Garvey, additional cleanup needed
* [Bug 3549] Spurious initgroups() error message <perlinger@ntp.org>
  - patch by Christous Zoulas
* [Bug 3548] Signature not verified on windows system <perlinger@ntp.org>
  - finding by Chen Jiabin, plus another one by me
* [Bug 3541] patch to fix STA_NANO struct timex units <perlinger@ntp.org>
  - applied patch by Maciej Szmigiero
* [Bug 3540] Cannot set minsane to 0 anymore <perlinger@ntp.org>
  - applied patch by Andre Charbonneau
* [Bug 3539] work_fork build fails when droproot is not supported <perlinger@ntp.org>
  - applied patch by Baruch Siach
* [Bug 3538] Build fails for no-MMU targets <perlinger@ntp.org>
  - applied patch by Baruch Siach
* [Bug 3535] libparse won't handle GPS week rollover <perlinger@ntp.org>
  - refactored handling of GPS era based on 'tos basedate' for
    parse (TSIP) and JUPITER clocks
* [Bug 3529] Build failures on Mac OS X 10.13 (High Sierra) <perlinger@ntp.org>
  - patch by Daniel J. Luke; this does not fix a potential linker
    regression issue on MacOS.
* [Bug 3527 - Backward Incompatible] mode7 clockinfo fudgeval2 packet
  anomaly <perlinger@ntp.org>, reported by GGarvey.
  - --enable-bug3527-fix support by HStenn
* [Bug 3526] Incorrect poll interval in packet <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3471] Check for openssl/[ch]mac.h.  <perlinger@ntp.org>
  - added missing check, reported by Reinhard Max <perlinger@ntp.org>
* [Bug 1674] runtime crashes and sync problems affecting both x86 and x86_64
  - this is a variant of [bug 3558] and should be fixed with it
* Implement --disable-signalled-io

---
(4.2.8p12) 2018/08/14 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3505] CVE-2018-12327 - Arbitrary Code Execution Vulnerability
  - fixed stack buffer overflow in the openhost() command-line call
    of NTPQ/NTPDC <perlinger@ntp.org>
* [Sec 3012] noepeer tweaks.  <stenn@ntp.org>
* [Bug 3521] Fix a logic bug in the INVALIDNAK checks.  <stenn@ntp.org>
* [Bug 3509] Add support for running as non-root on FreeBSD, Darwin,
             other TrustedBSD platforms
  - applied patch by Ian Lepore <perlinger@ntp.org>
* [Bug 3506] Service Control Manager interacts poorly with NTPD <perlinger@ntp.org>
  - changed interaction with SCM to signal pending startup
* [Bug 3486] Buffer overflow in ntpq/ntpq.c:tstflags() <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3485] Undefined sockaddr used in error messages in ntp_config.c <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3484] ntpq response from ntpd is incorrect when REFID is null <perlinger@ntp.org>
  - rework of ntpq 'nextvar()' key/value parsing
* [Bug 3482] Fixes for compilation warnings (ntp_io.c & ntpq-subs.c) <perlinger@ntp.org>
  - applied patch by Gerry Garvey (with mods)
* [Bug 3480] Refclock sample filter not cleared on clock STEP <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3479] ctl_putrefid() allows unsafe characters through to ntpq <perlinger@ntp.org>
  - applied patch by Gerry Garvey (with mods)
* [Bug 3476]ctl_putstr() sends empty unquoted string [...] <perlinger@ntp.org>
  - applied patch by Gerry Garvey (with mods); not sure if that's bug or feature, though
* [Bug 3475] modify prettydate() to suppress output of zero time <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3474] Missing pmode in mode7 peer info response <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3471] Check for openssl/[ch]mac.h.  HStenn.
  - add #define ENABLE_CMAC support in configure.  HStenn.
* [Bug 3470] ntpd4.2.8p11 fails to compile without OpenSSL <perlinger@ntp.org>
* [Bug 3469] Incomplete string compare [...] in is_refclk_addr <perlinger@ntp.org>
  - patch by Stephen Friedl
* [Bug 3467] Potential memory fault in ntpq [...] <perlinger@ntp.org>
  - fixed IO redirection and CTRL-C handling in ntq and ntpdc
* [Bug 3465] Default TTL values cannot be used <perlinger@ntp.org>
* [Bug 3461] refclock_shm.c: clear error status on clock recovery <perlinger@ntp.org>
  - initial patch by Hal Murray; also fixed refclock_report() trouble
* [Bug 3460] Fix typo in ntpq.texi, reported by Kenyon Ralph.  <stenn@ntp.org>
* [Bug 3456] Use uintptr_t rather than size_t to store an integer in a pointer
  - According to Brooks Davis, there was only one location <perlinger@ntp.org>
* [Bug 3449] ntpq - display "loop" instead of refid [...] <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3445] Symmetric peer won't sync on startup <perlinger@ntp.org>
  - applied patch by Gerry Garvey
* [Bug 3442] Fixes for ntpdate as suggested by Gerry Garvey,
  with modifications
  New macro REFID_ISTEXT() which is also used in ntpd/ntp_control.c.
* [Bug 3434] ntpd clears STA_UNSYNC on start <perlinger@ntp.org>
  - applied patch by Miroslav Lichvar
* [Bug 3426] ntpdate.html -t default is 2 seconds.  Leonid Evdokimov.
* [Bug 3121] Drop root privileges for the forked DNS worker <perlinger@ntp.org>
  - integrated patch by  Reinhard Max
* [Bug 2821] minor build issues <perlinger@ntp.org>
  - applied patches by Christos Zoulas, including real bug fixes
* html/authopt.html: cleanup, from <stenn@ntp.org>
* ntpd/ntpd.c: DROPROOT cleanup.  <stenn@ntp.org>
* Symmetric key range is 1-65535.  Update docs.  <stenn@ntp.org>
* html/authentic.html: cleanup, from <stenn@ntp.org>

---
(4.2.8p11) 2018/02/27 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3454] Unauthenticated packet can reset authenticated interleave
  associations.  HStenn.
* [Sec 3453] Interleaved symmetric mode cannot recover from bad state.  HStenn.
* [Sec 3415] Permit blocking authenticated symmetric/passive associations.
  Implement ippeerlimit.  HStenn, JPerlinger.
* [Sec 3414] ntpq: decodearr() can write beyond its 'buf' limits
  - initial patch by <stenn@ntp.org>, extended by <perlinger@ntp.org>
* [Sec 3412] ctl_getitem(): Don't compare names past NUL. <perlinger@ntp.org>
* [Sec 3012] Sybil vulnerability: noepeer support.  HStenn, JPerlinger.
* [Bug 3457] OpenSSL FIPS mode regression <perlinger@ntp.org>
* [Bug 3455] ntpd doesn't use scope id when binding multicast <perlinger@ntp.org>
 - applied patch by Sean Haugh 
* [Bug 3452] PARSE driver prints uninitialized memory. <perlinger@ntp.org>
* [Bug 3450] Dubious error messages from plausibility checks in get_systime()
  - removed error log caused by rounding/slew, ensured postcondition <perlinger@ntp.org>
* [Bug 3447] AES-128-CMAC (fixes) <perlinger@ntp.org>
  - refactoring the MAC code, too
* [Bug 3441] Validate the assumption that AF_UNSPEC is 0.  stenn@ntp.org
* [Bug 3439] When running multiple commands / hosts in ntpq... <perlinger@ntp.org>
  - applied patch by ggarvey
* [Bug 3438] Negative values and values > 999 days in... <perlinger@ntp.org>
  - applied patch by ggarvey (with minor mods)
* [Bug 3437] ntpd tries to open socket with AF_UNSPEC domain
  - applied patch (with mods) by Miroslav Lichvar <perlinger@ntp.org>
* [Bug 3435] anchor NTP era alignment <perlinger@ntp.org>
* [Bug 3433] sntp crashes when run with -a.  <stenn@ntp.org>
* [Bug 3430] ntpq dumps core (SIGSEGV) for "keytype md2"
  - fixed several issues with hash algos in ntpd, sntp, ntpq,
    ntpdc and the test suites <perlinger@ntp.org>
* [Bug 3424] Trimble Thunderbolt 1024 week millenium bug <perlinger@ntp.org>
  - initial patch by Daniel Pouzzner
* [Bug 3423] QNX adjtime() implementation error checking is
  wrong <perlinger@ntp.org>
* [Bug 3417] ntpq ifstats packet counters can be negative
  made IFSTATS counter quantities unsigned <perlinger@ntp.org>
* [Bug 3411] problem about SIGN(6) packet handling for ntp-4.2.8p10
  - raised receive buffer size to 1200 <perlinger@ntp.org>
* [Bug 3408] refclock_jjy.c: Avoid a wrong report of the coverity static
  analysis tool. <abe@ntp.org>
* [Bug 3405] update-leap.in: general cleanup, HTTPS support.  Paul McMath.
* [Bug 3404] Fix openSSL DLL usage under Windows <perlinger@ntp.org>
  - fix/drop assumptions on OpenSSL libs directory layout
* [Bug 3399] NTP: linker error in 4.2.8p10 during Linux cross-compilation
  - initial patch by timeflies@mail2tor.com  <perlinger@ntp.org>
* [Bug 3398] tests fail with core dump <perlinger@ntp.org>
  - patch contributed by Alexander Bluhm
* [Bug 3397] ctl_putstr() asserts that data fits in its buffer
  rework of formatting & data transfer stuff in 'ntp_control.c'
  avoids unecessary buffers and size limitations. <perlinger@ntp.org>
* [Bug 3394] Leap second deletion does not work on ntpd clients
  - fixed handling of dynamic deletion w/o leap file <perlinger@ntp.org>
* [Bug 3391] ntpd segfaults on startup due to small warmup thread stack size
  - increased mimimum stack size to 32kB <perlinger@ntp.org>
* [Bug 3367] Faulty LinuxPPS NMEA clock support in 4.2.8 <perlinger@ntp.org>
  - reverted handling of PPS kernel consumer to 4.2.6 behavior
* [Bug 3365] Updates driver40(-ja).html and miscopt.html <abe@ntp.org>
* [Bug 3358] Spurious KoD log messages in .INIT. phase.  HStenn.
* [Bug 3016] wrong error position reported for bad ":config pool"
  - fixed location counter & ntpq output <perlinger@ntp.org>
* [Bug 2900] libntp build order problem.  HStenn.
* [Bug 2878] Tests are cluttering up syslog <perlinger@ntp.org>
* [Bug 2737] Wrong phone number listed for USNO. ntp-bugs@bodosom.net,
  perlinger@ntp.org
* [Bug 2557] Fix Thunderbolt init. ntp-bugs@bodosom.net, perlinger@ntp.
* [Bug 948] Trustedkey config directive leaks memory. <perlinger@ntp.org>
* Use strlcpy() to copy strings, not memcpy().  HStenn.
* Typos.  HStenn.
* test_ntp_scanner_LDADD needs ntpd/ntp_io.o.  HStenn.
* refclock_jjy.c: Add missing "%s" to an msyslog() call.  HStenn.
* Build ntpq and libntpq.a with NTP_HARD_*FLAGS.  perlinger@ntp.org
* Fix trivial warnings from 'make check'. perlinger@ntp.org
* Fix bug in the override portion of the compiler hardening macro. HStenn.
* record_raw_stats(): Log entire packet.  Log writes.  HStenn.
* AES-128-CMAC support.  BInglis, HStenn, JPerlinger.
* sntp: tweak key file logging.  HStenn.
* sntp: pkt_output(): Improve debug output.  HStenn.
* update-leap: updates from Paul McMath.
* When using pkg-config, report --modversion.  HStenn.
* Clean up libevent configure checks.  HStenn.
* sntp: show the IP of who sent us a crypto-NAK.  HStenn.
* Allow .../N to specify subnet bits for IPs in ntp.keys.  HStenn, JPerlinger.
* authistrustedip() - use it in more places.  HStenn, JPerlinger.
* New sysstats: sys_lamport, sys_tsrounding.  HStenn.
* Update ntp.keys .../N documentation.  HStenn.
* Distribute testconf.yml.  HStenn.
* Add DPRINTF(2,...) lines to receive() for packet drops.  HStenn.
* Rename the configuration flag fifo variables.  HStenn.
* Improve saveconfig output.  HStenn.
* Decode restrict flags on receive() debug output.  HStenn.
* Decode interface flags on receive() debug output.  HStenn.
* Warn the user if deprecated "driftfile name WanderThreshold" is used.  HStenn.
* Update the documentation in ntp.conf.def .  HStenn.
* restrictions() must return restrict flags and ippeerlimit.  HStenn.
* Update ntpq peer documentation to describe the 'p' type.  HStenn.
* Rename restrict 'flags' to 'rflags.  Use an enum for the values.  HStenn.
* Provide dump_restricts() for debugging.  HStenn.
* Use consistent 4th arg type for [gs]etsockopt.  JPerlinger.
* Some tests might need LIBM.  HStenn.
* update-leap: Allow -h/--help early.  HStenn.

---
(4.2.8p10) 2017/03/21 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3389] NTP-01-016: Denial of Service via Malformed Config
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3388] NTP-01-014: Buffer Overflow in DPTS Clock
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3387] NTP-01-012: Authenticated DoS via Malicious Config Option
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3386] NTP-01-011: ntpq_stripquotes() returns incorrect Value
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3385] NTP-01-010: ereallocarray()/eallocarray() underused. HStenn
* [Sec 3384] NTP-01-009: Privileged execution of User Library code
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3383] NTP-01-008: Stack Buffer Overflow from Command Line
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3382] NTP-01-007: Data Structure terminated insufficiently
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3380] NTP-01-005: Off-by-one in Oncore GPS Receiver
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3379] NTP-01-004: Potential Overflows in ctl_put() functions
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3378] NTP-01-003: Improper use of snprintf() in mx4200_send()
  (Pentest report 01.2017) <perlinger@ntp.org>
* [Sec 3377] NTP-01-002: Buffer Overflow in ntpq when fetching reslist
  (Pentest report 01.2017) <perlinger@ntp.org
* [Sec 3376] Support build "hardening" flags.  stenn@ntp.org
* [Sec 3361] 0rigin (zero origin) DoS.  HStenn.
* [Bug 3393] clang scan-build findings <perlinger@ntp.org>
* [Bug 3363] Support for openssl-1.1.0 without compatibility modes
  - rework of patch set from <ntp.org@eroen.eu>. <perlinger@ntp.org>
* [Bug 3356] Bugfix 3072 breaks multicastclient <perlinger@ntp.org>
* [Bug 3216] libntp audio ioctl() args incorrectly cast to int
  on 4.4BSD-Lite derived platforms <perlinger@ntp.org>
  - original patch by Majdi S. Abbas
* [Bug 3215] 'make distcheck' fails with new BK repo format <perlinger@ntp.org>
* [Bug 3173] forking async worker: interrupted pipe I/O <perlinger@ntp.org>
  - initial patch by Christos Zoulas
* [Bug 3139] (...) time_pps_create: Exec format error <perlinger@ntp.org>
  - move loader API from 'inline' to proper source
  - augment pathless dlls with absolute path to NTPD
  - use 'msyslog()' instead of 'printf() 'for reporting trouble
* [Bug 3107] Incorrect Logic for Peer Event Limiting <perlinger@ntp.org>
  - applied patch by Matthew Van Gundy
* [Bug 3065] Quiet warnings on NetBSD <perlinger@ntp.org>
  - applied some of the patches provided by Havard. Not all of them
    still match the current code base, and I did not touch libopt.
* [Bug 3062] Change the process name of forked DNS worker <perlinger@ntp.org>
  - applied patch by Reinhard Max. See bugzilla for limitations.
* [Bug 2923] Trap Configuration Fail <perlinger@ntp.org>
  - fixed dependency inversion from [Bug 2837]
* [Bug 2896] Nothing happens if minsane < maxclock < minclock
  - produce ERROR log message about dysfunctional daemon. <perlinger@ntp.org>
* [Bug 2851] allow -4/-6 on restrict line with mask <perlinger@ntp.org>
  - applied patch by Miroslav Lichvar for ntp4.2.6 compat
* [Bug 2645] out-of-bound pointers in ctl_putsys and decode_bitflags
  - Fixed these and some more locations of this pattern.
    Probably din't get them all, though. <perlinger@ntp.org>
* Update copyright year.
* bk-7 trigger updates

---
(4.2.8p9-win) 2017/02/01 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 3144] NTP does not build without openSSL. <perlinger@ntp.org>
  - added missed changeset for automatic openssl lib detection
  - fixed some minor warning issues
* [Bug 3095]  More compatibility with openssl 1.1. <perlinger@ntp.org>
* configure.ac cleanup.  stenn@ntp.org
* openssl configure cleanup.  stenn@ntp.org

---
(4.2.8p9) 2016/11/21 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3119] Trap crash <perlinger@ntp.org>
* [Sec 3118] Mode 6 information disclosure and DDoS vector <perlinger@ntp.org>
  - TRAP config via mode 6 packet requires AUTH now.
* [Sec 3114] Broadcast Mode Replay Prevention DoS
  - applied patches by Matthew Van Gundy. <perlinger@ntp.org>
  - with bcpollbstep, tweaks and cleanup by stenn@ntp.org
* [Sec 3113] Broadcast Mode Poll Interval Enforcement DoS <perlinger@ntp.org>
  - applied fix as suggested by Matthew Van Gundy
* [Sec 3110] Windows: ntpd DoS by oversized UDP packet
  - fixed error handling for truncated UDP packets. <perlinger@ntp.org>
* [Sec 3102] Zero origin issues.  HStenn.
* [Sec 3082] null pointer dereference in _IO_str_init_static_internal()
  - more hardening to read_mru_list(). perlinger@ntp.org
* [Sec 3072] Attack on interface selection <perlinger@ntp.org>
  - implemented Miroslav Lichvars <mlichvar@redhat.com> suggestion
    to skip interface updates based on incoming packets
* [Bug 3142] bug in netmask prefix length detection <perlinger@ntp.org>
* [Bug 3138] gpsdjson refclock should honor fudgetime1. stenn@ntp.org
* [Bug 3129] Unknown hosts can put resolver thread into a hard loop
  - moved retry decision where it belongs. <perlinger@ntp.org>
* [Bug 3125] NTPD doesn't fully start when ntp.conf entries are out of order
  using the loopback-ppsapi-provider.dll <perlinger@ntp.org>
* [Bug 3116] unit tests for NTP time stamp expansion. <perlinger@ntp.org>
* [Bug 3100] ntpq can't retrieve daemon_version <perlinger@ntp.org>
  - fixed extended sysvar lookup (bug introduced with bug 3008 fix)
* [Bug 3095] Compatibility with openssl 1.1 <perlinger@ntp.org>
  - applied patches by Kurt Roeckx <kurt@roeckx.be> to source
  - added shim layer for SSL API calls with issues (both directions)
* [Bug 3089] Serial Parser does not work anymore for hopfser like device
  - simplified / refactored hex-decoding in driver. <perlinger@ntp.org>
* [Bug 3084] update-leap mis-parses the leapfile name.  HStenn.
* [Bug 3068] Linker warnings when building on Solaris. perlinger@ntp.org
  - applied patch thanks to Andrew Stormont <andyjstormont@gmail.com>
* [Bug 3067] Root distance calculation needs improvement.  HStenn.
* [Bug 3066] NMEA clock ignores pps. perlinger@ntp.org
  - PPS-HACK works again.
* [Bug 3059] Potential buffer overrun from oversized hash <perlinger@ntp.org>
  - applied patch by Brian Utterback <brian.utterback@oracle.com>
* [Bug 3053] ntp_loopfilter.c frequency calc precedence error.  Sarah White.
* [Bug 3050]  Fix for bug #2960 causes [...] spurious error message.
  <perlinger@ntp.org>
  - patches by Reinhard Max <max@suse.com> and Havard Eidnes <he@uninett.no>
* [Bug 3047] Fix refclock_jjy C-DEX JST2000. abe@ntp.org
  - Patch provided by Kuramatsu.
* [Bug 3021] unity_fixture.c needs pragma weak <perlinger@ntp.org>
  - removed unnecessary & harmful decls of 'setUp()' & 'tearDown()'
* [Bug 3019] Windows: ERROR_HOST_UNREACHABLE block packet processing.
  DMayer and JPerlinger.
* [Bug 2998] sntp/tests/packetProcessing.c broken without openssl. JPerlinger
* [Bug 2961] sntp/tests/packetProcessing.c assumes AUTOKEY.  HStenn.
* [Bug 2959] refclock_jupiter: gps week correction <perlinger@ntp.org>
  - fixed GPS week expansion to work based on build date. Special thanks
    to Craig Leres for initial patch and testing.
* [Bug 2951] ntpd tests fail: multiple definition of `send_via_ntp_signd'
  - fixed Makefile.am <perlinger@ntp.org>
* [Bug 2689] ATOM driver processes last PPS pulse at startup,
             even if it is very old <perlinger@ntp.org>
  - make sure PPS source is alive before processing samples
  - improve stability close to the 500ms phase jump (phase gate)
* Fix typos in include/ntp.h.
* Shim X509_get_signature_nid() if needed.
* git author attribution cleanup
* bk ignore file cleanup
* remove locks in Windows IO, use rpc-like thread synchronisation instead

---
(4.2.8p8) 2016/06/02 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 3042] Broadcast Interleave.  HStenn.
* [Sec 3043] Autokey association reset.  perlinger@ntp.org, stenn@ntp.org
  - validate origin timestamps on bad MACs, too.  stenn@ntp.org
* [Sec 3044] Spoofed server packets are partially processed.  HStenn.
* [Sec 3045] Bad authentication demobilizes ephemeral associations. JPerlinger.
* [Sec 3046] CRYPTO_NAK crash.  stenn@ntp.org
* [Bug 3038] NTP fails to build in VS2015. perlinger@ntp.org
  - provide build environment
  - 'wint_t' and 'struct timespec' defined by VS2015
  - fixed print()/scanf() format issues
* [Bug 3052] Add a .gitignore file.  Edmund Wong.
* [Bug 3054] miscopt.html documents the allan intercept in seconds. SWhite.
* [Bug 3058] fetch_timestamp() mishandles 64-bit alignment. Brian Utterback,
  JPerlinger, HStenn.
* Update the NEWS file for 4.2.8p8.  HStenn.
* Fix typo in ntp-wait and plot_summary.  HStenn.
* Make sure we have an "author" file for git imports.  HStenn.
* Update the sntp problem tests for MacOS.  HStenn.

---
(4.2.8p7) 2016/04/26 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 2901] KoD packets must have non-zero transmit timestamps.  HStenn.
* [Sec 2936] Skeleton Key: Any system knowing the trusted key can serve
  time. Include passive servers in this check. HStenn.
* [Sec 2945] Additional KoD packet checks.  HStenn.
* [Sec 2978] Interleave can be partially triggered.  HStenn.
* [Sec 3007] Validate crypto-NAKs.  Danny Mayer.
* [Sec 3008] Always check the return value of ctl_getitem().
  - initial work by HStenn
  - Additional cleanup of ctl_getitem by perlinger@ntp.org
* [Sec 3009] Crafted addpeer with hmode > 7 causes OOB error. perlinger@ntp.org
   - added more stringent checks on packet content
* [Sec 3010] remote configuration trustedkey/requestkey values
  are not properly validated. perlinger@ntp.org
  - sidekick: Ignore keys that have an unsupported MAC algorithm
    but are otherwise well-formed
* [Sec 3011] Duplicate IPs on unconfig directives will cause an assertion botch
  - graciously accept the same IP multiple times. perlinger@ntp.org
* [Sec 3020] Refclock impersonation.  HStenn.
* [Bug 2831]  Segmentation Fault in DNS lookup during startup. perlinger@ntp.org
  - fixed yet another race condition in the threaded resolver code.
* [Bug 2858] bool support.  Use stdbool.h when available.  HStenn.
* [Bug 2879] Improve NTP security against timing attacks. perlinger@ntp.org
  - integrated patches by Loganaden Velvidron <logan@ntp.org>
    with some modifications & unit tests
* [Bug 2952] Symmetric active/passive mode is broken.  HStenn.
* [Bug 2960] async name resolution fixes for chroot() environments.
  Reinhard Max.
* [Bug 2994] Systems with HAVE_SIGNALED_IO fail to compile. perlinger@ntp.org
* [Bug 2995] Fixes to compile on Windows
* [Bug 2999] out-of-bounds access in 'is_safe_filename()'. perlinger@ntp.org
* [Bug 3013] Fix for ssl_init.c SHA1 test. perlinger@ntp.org
  - Patch provided by Ch. Weisgerber
* [Bug 3015] ntpq: config-from-file: "request contains an unprintable character"
  - A change related to [Bug 2853] forbids trailing white space in
    remote config commands. perlinger@ntp.org
* [Bug 3019] NTPD stops processing packets after ERROR_HOST_UNREACHABLE
  - report and patch from Aleksandr Kostikov.
  - Overhaul of Windows IO completion port handling. perlinger@ntp.org
* [Bug 3022] authkeys.c should be refactored. perlinger@ntp.org
  - fixed memory leak in access list (auth[read]keys.c)
  - refactored handling of key access lists (auth[read]keys.c)
  - reduced number of error branches (authreadkeys.c)
* [Bug 3023] ntpdate cannot correct dates in the future. perlinger@ntp.org
* [Bug 3030] ntpq needs a general way to specify refid output format.  HStenn.
* [Bug 3031] ntp broadcastclient unable to synchronize to an server
             when the time of server changed. perlinger@ntp.org
  - Check the initial delay calculation and reject/unpeer the broadcast
    server if the delay exceeds 50ms. Retry again after the next
    broadcast packet.
* [Bug 3036] autokey trips an INSIST in authistrustedip().  Harlan Stenn.
* Document ntp.key's optional IP list in authenetic.html.  Harlan Stenn.
* Update html/xleave.html documentation.  Harlan Stenn.
* Update ntp.conf documentation.  Harlan Stenn.
* Fix some Credit: attributions in the NEWS file.  Harlan Stenn.
* Fix typo in html/monopt.html.  Harlan Stenn.
* Add README.pullrequests.  Harlan Stenn.
* Cleanup to include/ntp.h.  Harlan Stenn.

---
(4.2.8p6) 2016/01/20 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 2935] Deja Vu: Replay attack on authenticated broadcast mode. HStenn.
* [Sec 2936] Skeleton Key: Any trusted key system can serve time. HStenn.
* [Sec 2937] ntpq: nextvar() missing length check. perlinger@ntp.org
* [Sec 2938] ntpq saveconfig command allows dangerous characters
  in filenames. perlinger@ntp.org
* [Sec 2939] reslist NULL pointer dereference.  perlinger@ntp.org
* [Sec 2940] Stack exhaustion in recursive traversal of restriction
  list. perlinger@ntp.org
* [Sec 2942]: Off-path DoS attack on auth broadcast mode.  HStenn.
* [Sec 2945] Zero Origin Timestamp Bypass. perlinger@ntp.org
* [Sec 2948] Potential Infinite Loop in ntpq ( and ntpdc) perlinger@ntp.org
* [Bug 2772] adj_systime overflows tv_usec. perlinger@ntp.org
* [Bug 2814] msyslog deadlock when signaled. perlinger@ntp.org
  - applied patch by shenpeng11@huawei.com with minor adjustments
* [Bug 2882] Look at ntp_request.c:list_peers_sum(). perlinger@ntp.org
* [Bug 2891] Deadlock in deferred DNS lookup framework. perlinger@ntp.org
* [Bug 2892] Several test cases assume IPv6 capabilities even when
             IPv6 is disabled in the build. perlinger@ntp.org
  - Found this already fixed, but validation led to cleanup actions.
* [Bug 2905] DNS lookups broken. perlinger@ntp.org
  - added limits to stack consumption, fixed some return code handling
* [Bug 2971] ntpq bails on ^C: select fails: Interrupted system call
  - changed stacked/nested handling of CTRL-C. perlinger@ntp.org
  - make CTRL-C work for retrieval and printing od MRU list. perlinger@ntp.org
* [Bug 2980] reduce number of warnings. perlinger@ntp.org
  - integrated several patches from Havard Eidnes (he@uninett.no)
* [Bug 2985] bogus calculation in authkeys.c perlinger@ntp.org
  - implement 'auth_log2()' using integer bithack instead of float calculation
* Make leapsec_query debug messages less verbose.  Harlan Stenn.
* Disable incomplete t-ntp_signd.c test.  Harlan Stenn.

---
(4.2.8p5) 2016/01/07 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 2956] small-step/big-step.  Close the panic gate earlier.  HStenn.
* CID 1339955: Free allocated memory in caljulian test.  HStenn.
* CID 1339962: Explicitly initialize variable in caljulian test.  HStenn.
* CID 1341527: Quiet a CHECKED_RETURN in sntp/tests/t-log.c.  HStenn.
* CID 1341533: Missing assertion in sntp/tests/t-log.c.  HStenn.
* CID 1341534: Resource leak in tests/ntpd/t-ntp_signd.c.  HStenn.
* CID 1341535: Resource leak in tests/ntpd/t-ntp_signd.c.  HStenn.
* CID 1341536: Resource leak in tests/ntpd/t-ntp_signd.c.  HStenn.
* CID 1341537: Resource leak in tests/ntpd/t-ntp_signd.c.  HStenn.
* CID 1341538: Memory leak in tests/ntpd/ntp_prio_q.c:262.  HStenn.
* CID 1341677: Nits in sntp/tests/keyFile.c.  HStenn.
* CID 1341678: Nits in sntp/tests/keyFile.c.  HStenn.
* CID 1341679: Nits in sntp/tests/keyFile.c.  HStenn.
* CID 1341680: Nits in sntp/tests/keyFile.c.  HStenn.
* CID 1341681: Nits in sntp/tests/keyFile.c.  HStenn.
* CID 1341682: Nit in libntp/authreadkeys.c.  HStenn.
* CID 1341684: Nit in tests/ntpd/t-ntp_signd.c.  HStenn.
* [Bug 2829] Look at pipe_fds in ntpd.c  (did so. perlinger@ntp.org)
* [Bug 2887] stratum -1 config results as showing value 99
  - fudge stratum should only accept values [0..16]. perlinger@ntp.org
* [Bug 2932] Update leapsecond file info in miscopt.html.  CWoodbury, HStenn.
* [Bug 2934] tests/ntpd/t-ntp_scanner.c has a magic constant wired in.  HMurray
* [Bug 2944] errno is not preserved properly in ntpdate after sendto call.
  - applied patch by Christos Zoulas.  perlinger@ntp.org
* [Bug 2952] Symmetric active/passive mode is broken.  HStenn.
* [Bug 2954] Version 4.2.8p4 crashes on startup with sig fault
  - fixed data race conditions in threaded DNS worker. perlinger@ntp.org
  - limit threading warm-up to linux; FreeBSD bombs on it. perlinger@ntp.org
* [Bug 2957] 'unsigned int' vs 'size_t' format clash. perlinger@ntp.org
  - accept key file only if there are no parsing errors
  - fixed size_t/u_int format clash
  - fixed wrong use of 'strlcpy'
* [Bug 2958] ntpq: fatal error messages need a final newline. Craig Leres.
* [Bug 2962] truncation of size_t/ptrdiff_t on 64bit targets. perlinger@ntp.org
  - fixed several other warnings (cast-alignment, missing const, missing prototypes)
  - promote use of 'size_t' for values that express a size
  - use ptr-to-const for read-only arguments
  - make sure SOCKET values are not truncated (win32-specific)
  - format string fixes
* [Bug 2965] Local clock didn't work since 4.2.8p4.  Martin Burnicki.
* [Bug 2967] ntpdate command suffers an assertion failure
  - fixed ntp_rfc2553.c to return proper address length. perlinger@ntp.org
* [Bug 2969]  Seg fault from ntpq/mrulist when looking at server with
              lots of clients. perlinger@ntp.org
* [Bug 2971] ntpq bails on ^C: select fails: Interrupted system call
  - changed stacked/nested handling of CTRL-C. perlinger@ntp.org
  - make CTRL-C work for retrieval and printing od MRU list. perlinger@ntp.org
* Unity cleanup for FreeBSD-6.4.  Harlan Stenn.
* Unity test cleanup.  Harlan Stenn.
* Libevent autoconf pthread fixes for FreeBSD-10.  Harlan Stenn.
* Header cleanup in tests/sandbox/uglydate.c.  Harlan Stenn.
* Header cleanup in tests/libntp/sfptostr.c.  Harlan Stenn.
* Quiet a warning from clang.  Harlan Stenn.
* Update the NEWS file.  Harlan Stenn.
* Update scripts/calc_tickadj/Makefile.am.  Harlan Stenn.

---
(4.2.8p4) 2015/10/21 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 2899] CVE-2014-9297  perlinger@ntp.org
* [Sec 2901] Drop invalid packet before checking KoD. Check for all KoD's.
  Danny Mayer.  Log incoming packets that fail TEST2.  Harlan Stenn.
* [Sec 2902] configuration directives "pidfile" and "driftfile"
  should be local-only. perlinger@ntp.org (patch by Miroslav Lichvar)
* [Sec 2909] added missing call to 'free()' in ntp_crypto.c. perlinger@ntp.org
* [Sec 2913] TALOS-CAN-0052: crash by loop counter underrun. perlinger@ntp.org
* [Sec 2916] TALOS-CAN-0054: memory corruption in password store. JPerlinger
* [Sec 2917] TALOS-CAN-0055: Infinite loop if extended logging enabled and
  the logfile and keyfile are the same. perlinger@ntp.org
* [Sec 1918] TALOS-CAN-0062: prevent directory traversal for VMS, too, when
  using 'saveconfig' command.  perlinger@ntp.org
* [Bug 2919] TALOS-CAN-0063: avoid buffer overrun in ntpq. perlinger@ntp.org
* [Sec 2020] TALOS-CAN-0064: signed/unsiged clash could lead to buffer overun
  and memory corruption. perlinger@ntp.org
* [Sec 2921] TALOS-CAN-0065: password length memory corruption. JPerlinger.
* [Sec 2922] decodenetnum() will ASSERT botch instead of returning FAIL
  on some bogus values.  Harlan Stenn.
* [Sec 2941] NAK to the Future: Symmetric association authentication
  bypass via crypto-NAK. Patch applied. perlinger@ntp.org
* [Bug 2332] (reopened) Exercise thread cancellation once before dropping
  privileges and limiting resources in NTPD removes the need to link
  forcefully against 'libgcc_s' which does not always work. J.Perlinger
* [Bug 2595] ntpdate man page quirks.  Hal Murray, Harlan Stenn.
* [Bug 2625] Deprecate flag1 in local refclock.  Hal Murray, Harlan Stenn.
* [Bug 2817] Stop locking ntpd into memory by default under Linux.  H.Stenn.
* [Bug 2821] minor build issues: fixed refclock_gpsdjson.c.  perlinger@ntp.org
* [Bug 2823] ntpsweep with recursive peers option doesn't work.  H.Stenn.
* [Bug 2849] Systems with more than one default route may never
  synchronize.  Brian Utterback.  Note that this patch might need to
  be reverted once Bug 2043 has been fixed.
* [Bug 2864] 4.2.8p3 fails to compile on Windows. Juergen Perlinger
* [Bug 2866] segmentation fault at initgroups().  Harlan Stenn.
* [Bug 2867] ntpd with autokey active crashed by 'ntpq -crv'. J.Perlinger
* [Bug 2873] libevent should not include .deps/ in the tarball.  H.Stenn
* [Bug 2874] Don't distribute generated sntp/tests/fileHandlingTest.h. H.Stenn
* [Bug 2875] sntp/Makefile.am: Get rid of DIST_SUBDIRS.  libevent must
  be configured for the distribution targets.  Harlan Stenn.
* [Bug 2883] ntpd crashes on exit with empty driftfile.  Miroslav Lichvar.
* [Bug 2886] Mis-spelling: "outlyer" should be "outlier".  dave@horsfall.org
* [Bug 2888] streamline calendar functions.  perlinger@ntp.org
* [Bug 2889] ntp-dev-4.3.67 does not build on Windows.  perlinger@ntp.org
* [Bug 2890] Ignore ENOBUFS on routing netlink socket.  Konstantin Khlebnikov.
* [Bug 2906] make check needs better support for pthreads.  Harlan Stenn.
* [Bug 2907] dist* build targets require our libevent/ to be enabled.  HStenn.
* [Bug 2912] no munlockall() under Windows.  David Taylor, Harlan Stenn.
* libntp/emalloc.c: Remove explicit include of stdint.h.  Harlan Stenn.
* Put Unity CPPFLAGS items in unity_config.h.  Harlan Stenn.
* tests/ntpd/g_leapsec.cpp typo fix.  Harlan Stenn.
* Phase 1 deprecation of google test in sntp/tests/.  Harlan Stenn.
* On some versions of HP-UX, inttypes.h does not include stdint.h.  H.Stenn.
* top_srcdir can change based on ntp v. sntp.  Harlan Stenn.
* sntp/tests/ function parameter list cleanup.  Damir Tomić.
* tests/libntp/ function parameter list cleanup.  Damir Tomić.
* tests/ntpd/ function parameter list cleanup.  Damir Tomić.
* sntp/unity/unity_config.h: handle stdint.h.  Harlan Stenn.
* sntp/unity/unity_internals.h: handle *INTPTR_MAX on old Solaris.  H.Stenn.
* tests/libntp/timevalops.c and timespecops.c fixed error printing.  D.Tomić.
* tests/libntp/ improvements in code and fixed error printing.  Damir Tomić.
* tests/libntp: a_md5encrypt.c, authkeys.c, buftvtots.c, calendar.c, caljulian.c,
  caltontp.c, clocktime.c, humandate.c, hextolfp.c, decodenetnum.c - fixed
  formatting; first declaration, then code (C90); deleted unnecessary comments;
  changed from sprintf to snprintf; fixed order of includes. Tomasz Flendrich
* tests/libntp/lfpfunc.c remove unnecessary include, remove old comments,
  fix formatting, cleanup. Tomasz Flendrich
* tests/libntp/lfptostr.c remove unnecessary include, add consts, fix formatting.
  Tomasz Flendrich
* tests/libntp/statestr.c remove empty functions, remove unnecessary include,
  fix formatting. Tomasz Flendrich
* tests/libntp/modetoa.c fixed formatting. Tomasz Flendrich
* tests/libntp/msyslog.c fixed formatting. Tomasz Flendrich
* tests/libntp/numtoa.c deleted unnecessary empty functions, fixed formatting.
  Tomasz Flendrich
* tests/libntp/numtohost.c added const, fixed formatting. Tomasz Flendrich
* tests/libntp/refnumtoa.c fixed formatting. Tomasz Flendrich
* tests/libntp/ssl_init.c fixed formatting. Tomasz Flendrich
* tests/libntp/tvtots.c fixed a bug, fixed formatting. Tomasz Flendrich
* tests/libntp/uglydate.c removed an unnecessary include. Tomasz Flendrich
* tests/libntp/vi64ops.c removed an unnecessary comment, fixed formatting.
* tests/libntp/ymd3yd.c removed an empty function and an unnecessary include,
fixed formatting. Tomasz Flendrich
* tests/libntp/timespecops.c fixed formatting, fixed the order of includes,
  removed unnecessary comments, cleanup. Tomasz Flendrich
* tests/libntp/timevalops.c fixed the order of includes, deleted unnecessary
  comments, cleanup. Tomasz Flendrich
* tests/libntp/sockaddrtest.h making it agree to NTP's conventions of formatting.
  Tomasz Flendrich
* tests/libntp/lfptest.h cleanup. Tomasz Flendrich
* tests/libntp/test-libntp.c fix formatting. Tomasz Flendrich
* sntp/tests/crypto.c is now using proper Unity's assertions, fixed formatting.
  Tomasz Flendrich
* sntp/tests/kodDatabase.c added consts, deleted empty function,
  fixed formatting. Tomasz Flendrich
* sntp/tests/kodFile.c cleanup, fixed formatting. Tomasz Flendrich
* sntp/tests/packetHandling.c is now using proper Unity's assertions,
  fixed formatting, deleted unused variable. Tomasz Flendrich
* sntp/tests/keyFile.c is now using proper Unity's assertions, fixed formatting.
  Tomasz Flendrich
* sntp/tests/packetProcessing.c changed from sprintf to snprintf,
  fixed formatting. Tomasz Flendrich
* sntp/tests/utilities.c is now using proper Unity's assertions, changed
  the order of includes, fixed formatting, removed unnecessary comments.
  Tomasz Flendrich
* sntp/tests/sntptest.h fixed formatting. Tomasz Flendrich
* sntp/tests/fileHandlingTest.h.in fixed a possible buffer overflow problem,
  made one function do its job, deleted unnecessary prints, fixed formatting.
  Tomasz Flendrich
* sntp/unity/Makefile.am added a missing header. Tomasz Flendrich
* sntp/unity/unity_config.h: Distribute it.  Harlan Stenn.
* sntp/libevent/evconfig-private.h: remove generated filefrom SCM.  H.Stenn.
* sntp/unity/Makefile.am: fix some broken paths.  Harlan Stenn.
* sntp/unity/unity.c: Clean up a printf().  Harlan Stenn.
* Phase 1 deprecation of google test in tests/libntp/.  Harlan Stenn.
* Don't build sntp/libevent/sample/.  Harlan Stenn.
* tests/libntp/test_caltontp needs -lpthread.  Harlan Stenn.
* br-flock: --enable-local-libevent.  Harlan Stenn.
* Wrote tests for ntpd/ntp_prio_q.c. Tomasz Flendrich
* scripts/lib/NTP/Util.pm: stratum output is version-dependent.  Harlan Stenn.
* Get rid of the NTP_ prefix on our assertion macros.  Harlan Stenn.
* Code cleanup.  Harlan Stenn.
* libntp/icom.c: Typo fix.  Harlan Stenn.
* util/ntptime.c: initialization nit.  Harlan Stenn.
* ntpd/ntp_peer.c:newpeer(): added a DEBUG_REQUIRE(srcadr).  Harlan Stenn.
* Add std_unity_tests to various Makefile.am files.  Harlan Stenn.
* ntpd/ntp_restrict.c: added a few assertions, created tests for this file.
  Tomasz Flendrich
* Changed progname to be const in many files - now it's consistent. Tomasz
  Flendrich
* Typo fix for GCC warning suppression.  Harlan Stenn.
* Added tests/ntpd/ntp_scanner.c test. Damir Tomić.
* Added declarations to all Unity tests, and did minor fixes to them.
  Reduced the number of warnings by half. Damir Tomić.
* Updated generate_test_runner.rb and updated the sntp/unity/auto directory
  with the latest Unity updates from Mark. Damir Tomić.
* Retire google test - phase I.  Harlan Stenn.
* Unity test cleanup: move declaration of 'initializing'.  Harlan Stenn.
* Update the NEWS file.  Harlan Stenn.
* Autoconf cleanup.  Harlan Stenn.
* Unit test dist cleanup. Harlan Stenn.
* Cleanup various test Makefile.am files.  Harlan Stenn.
* Pthread autoconf macro cleanup.  Harlan Stenn.
* Fix progname definition in unity runner scripts.  Harlan Stenn.
* Clean trailing whitespace in tests/ntpd/Makefile.am.  Harlan Stenn.
* Update the patch for bug 2817.  Harlan Stenn.
* More updates for bug 2817.  Harlan Stenn.
* Fix bugs in tests/ntpd/ntp_prio_q.c.  Harlan Stenn.
* gcc on older HPUX may need +allowdups.  Harlan Stenn.
* Adding missing MCAST protection.  Harlan Stenn.
* Disable certain test programs on certain platforms.  Harlan Stenn.
* Implement --enable-problem-tests (on by default).  Harlan Stenn.
* build system tweaks.  Harlan Stenn.
---
(4.2.8p3) 2015/06/29 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 2853] Crafted remote config packet can crash some versions of
  ntpd.  Aleksis Kauppinen, Juergen Perlinger, Harlan Stenn.
* [Sec 2853] Initial work on tests/sec-2853/.  Harlan Stenn.
* [Bug 1060] Buffer overruns in libparse/clk_rawdcf.c.  Helge Oldach.
* [Bug 2846] Report 'unsynchronized' status during the leap second.
  Fixed in Martin's changes to Bug 2855.  Martin Burnicki.
* [Bug 2859] Improve raw DCF77 robustness deconding.  Frank Kardel.
* [Bug 2860] ntpq ifstats sanity check is too stringent.  Frank Kardel.
* README.leapsmear added.  Martin Burnicki.
* README.leapsmear edited.  Harlan Stenn.
* tests/libntp/msyslog.c: fixed a gcc warning. Tomasz Flendrich.
* ntpd/ntp.conf.def: Document DSCP and leapsmearinterval.  Harlan Stenn.
* html/miscopt.html: Document leapsmearinterval, other cleanup.  Harlan Stenn.
---
(4.2.8p3-RC3) 2015/06/27 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2855] Parser fix for conditional leap smear code.  Harlan Stenn.
* [Bug 2855] Report leap smear in the REFID.  Harlan Stenn.
* [Bug 2856] ntpd should wait() on terminated child processes.  Paul Green.
* [Bug 2857] Stratus VOS does not support SIGIO.  Paul Green.
* html/drivers/driver22.html: typo fix.  Harlan Stenn.
* refidsmear test cleanup.  Tomasz Flendrich.
* refidsmear function support and tests.  Harlan Stenn.
* sntp/tests/Makefile.am: remove g_nameresolution.cpp as it tested
  something that was only in the 4.2.6 sntp.  Harlan Stenn.
* Modified tests/bug-2803/Makefile.am so it builds Unity framework tests.
  Damir Tomić
* Modified tests/libtnp/Makefile.am so it builds Unity framework tests.
  Damir Tomić
* Modified sntp/tests/Makefile.am so it builds Unity framework tests.
  Damir Tomić
* tests/sandbox/smeartest.c: Harlan Stenn, Damir Tomic, Juergen Perlinger.
* Converted from gtest to Unity: tests/bug-2803/. Damir Tomić
* Converted from gtest to Unity: tests/libntp/ a_md5encrypt, atoint.c,
  atouint.c, authkeys.c, buftvtots.c, calendar.c, caljulian.c,
  calyearstart.c, clocktime.c, hextoint.c, lfpfunc.c, modetoa.c,
  numtoa.c, numtohost.c, refnumtoa.c, ssl_init.c, statestr.c,
  timespecops.c, timevalops.c, uglydate.c, vi64ops.c, ymd2yd.c.
  Damir Tomić
* Converted from gtest to Unity: sntp/tests/ kodDatabase.c, kodFile.c,
  networking.c, keyFile.c, utilities.cpp, sntptest.h,
  fileHandlingTest.h. Damir Tomić
* Converted from gtest to Unity: sntp/tests/ caltontp.c, humandate.c,
  msyslog.c, prettydate.c, recvbuff.c, sfptostr.c, tstotv.c, tvtots.c,
  sntp/tests/packetProcessing.c. Tomasz Flendrich
---
(4.2.8p3-RC2) 2015/06/24 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2778] Implement "apeers"  ntpq command to include associd.
* [Bug 2805] ntpd fails to join multicast group.
* [Bug 2824] Convert update-leap to perl. (also see 2769)
* [Bug 2830] ntpd doesn't always transfer the correct TAI offset via autokey
   NTPD transfers the current TAI (instead of an announcement) now.
   This might still needed improvement.
   Update autokey data ASAP when 'sys_tai' changes.
   Fix unit test that was broken by changes for autokey update.
   Avoid potential signature length issue and use DPRINTF where possible
     in ntp_crypto.c.
* [Bug 2832] refclock_jjy.c supports the TDC-300.
* [Bug 2834] Correct a broken html tag in html/refclock.html
* [Bug 2836] DFC77 patches from Frank Kardel to make decoding more
  robust, and require 2 consecutive timestamps to be consistent.
* [Bug 2837] Allow a configurable DSCP value.
* [Bug 2837] add test for DSCP to ntpd/complete.conf.in
* [Bug 2842] Glitch in ntp.conf.def documentation stanza.
* [Bug 2842] Bug in mdoc2man.
* [Bug 2843] make check fails on 4.3.36
   Fixed compiler warnings about numeric range overflow
   (The original topic was fixed in a byplay to bug#2830)
* [Bug 2845] Harden memory allocation in ntpd.
* [Bug 2852] 'make check' can't find unity.h.  Hal Murray.
* [Bug 2854] Missing brace in libntp/strdup.c.  Masanari Iida.
* [Bug 2855] Implement conditional leap smear code.  Martin Burnicki.
* [Bug 2855] leap smear cleanup.  Harlan Stenn.
* Initial support for experimental leap smear code.  Harlan Stenn.
* Fixes to sntp/tests/fileHandlingTest.h.in.  Harlan Stenn.
* Report select() debug messages at debug level 3 now.
* sntp/scripts/genLocInfo: treat raspbian as debian.
* Unity test framework fixes.
  ** Requires ruby for changes to tests.
* Initial support for PACKAGE_VERSION tests.
* sntp/libpkgver belongs in EXTRA_DIST, not DIST_SUBDIRS.
* tests/bug-2803/Makefile.am must distribute bug-2803.h.
* automake-1.15 cleanup for sntp/tests/fileHandlingTest.h.in .  Harlan Stenn.
---
(4.2.8p3-RC1) 2015/05/12 Released by Harlan Stenn <stenn@ntp.org>

* CID 739725: Fix a rare resource leak in libevent/listener.c.
* CID 1295478: Quiet a pedantic potential error from the fix for Bug 2776.
* CID 1296235: Fix refclock_jjy.c and correcting type of the driver40-ja.html
* CID 1269537: Clean up a line of dead code in getShmTime().
* [Bug 2590] autogen-5.18.5.
* [Bug 2612] restrict: Warn when 'monitor' can't be disabled because
  of 'limited'.
* [Bug 2650] fix includefile processing.
* [Bug 2745] ntpd -x steps clock on leap second
   Fixed an initial-value problem that caused misbehaviour in absence of
   any leapsecond information.
   Do leap second stepping only of the step adjustment is beyond the
   proper jump distance limit and step correction is allowed at all.
* [Bug 2750] build for Win64
  Building for 32bit of loopback ppsapi needs def file
* [Bug 2776] Improve ntpq's 'help keytype'.
* [Bug 2782] Refactor refclock_shm.c, add memory barrier protection.
* [Bug 2792] If the IFF_RUNNING interface flag is supported then an
  interface is ignored as long as this flag is not set since the
  interface is not usable (e.g., no link).
* [Bug 2794] Clean up kernel clock status reports.
* [Bug 2800] refclock_true.c true_debug() can't open debug log because
  of incompatible open/fdopen parameters.
* [Bug 2804] install-local-data assumes GNU 'find' semantics.
* [Bug 2806] refclock_jjy.c supports the Telephone JJY.
* [Bug 2808] GPSD_JSON driver enhancements, step 1.
  Fix crash during cleanup if GPS device not present and char device.
  Increase internal token buffer to parse all JSON data, even SKY.
  Defer logging of errors during driver init until the first unit is
  started, so the syslog is not cluttered when the driver is not used.
  Various improvements, see http://bugs.ntp.org/2808 for details.
  Changed libjsmn to a more recent version.
* [Bug 2810] refclock_shm.c memory barrier code needs tweaks for QNX.
* [Bug 2813] HP-UX needs -D__STDC_VERSION__=199901L and limits.h.
* [Bug 2815] net-snmp before v5.4 has circular library dependencies.
* [Bug 2821] Add a missing NTP_PRINTF and a missing const.
* [Bug 2822] New leap column in sntp broke NTP::Util.pm.
* [Bug 2825] Quiet file installation in html/ .
* [Bug 2830] ntpd doesn't always transfer the correct TAI offset via autokey
   NTPD transfers the current TAI (instead of an announcement) now.
   This might still needed improvement.
* Add an assert to the ntpq ifstats code.
* Clean up the RLIMIT_STACK code.
* Improve the ntpq documentation around the controlkey keyid.
* ntpq.c cleanup.
* Windows port build cleanup.
---
(4.2.8p2) 2015/04/07 Released by Harlan Stenn <stenn@ntp.org>
(4.2.8p2-RC3) 2015/04/03 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2763] Fix for different thresholds for forward and backward steps.
* Initial import of the Unity test framework.
---
(4.2.8p2-RC2) 2015/04/03 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2592] FLAG_TSTAMP_PPS cleanup for refclock_parse.c.
* [Bug 2769] New script: update-leap
* [Bug 2769] cleannup for update-leap
* [Bug 2788] New flag -G (force_step_once).
* [Bug 2794] Clean up kernel clock status reports.
* [Bug 2795] Cannot build without OpenSLL (on Win32).
  Provided a Win32 specific wrapper around libevent/arc4random.c.
  fixed some minor warnings.
* [Bug 2796] ntp-keygen crashes in 'getclock()' on Win32.
* [Bug 2797] ntp-keygen trapped in endless loop for MD5 keys
  on big-endian machines.
* [Bug 2798] sntp should decode and display the leap indicator.
* Simple cleanup to html/build.html
---
(4.2.8p2-RC1) 2015/03/30 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2794] Don't let reports on normal kernel status changes
  look like errors.
* [Bug 2788] New flag -G (force_step_once).
* [Bug 2592] Account for PPS sources which can provide an accurate
  absolute time stamp, and status information.
  Fixed indention and removed trailing whitespace.
* [Bug 1787] DCF77's formerly "antenna" bit is "call bit" since 2003.
* [Bug 1960] setsockopt IPV6_MULTICAST_IF: Invalid argument.
* [Bug 2346] "graceful termination" signals do not do peer cleanup.
* [Bug 2728] See if C99-style structure initialization works.
* [Bug 2747] Upgrade libevent to 2.1.5-beta.
* [Bug 2749] ntp/lib/NTP/Util.pm needs update for ntpq -w, IPv6, .POOL. .
* [Bug 2751] jitter.h has stale copies of l_fp macros.
* [Bug 2756] ntpd hangs in startup with gcc 3.3.5 on ARM.
* [Bug 2757] Quiet compiler warnings.
* [Bug 2759] Expose nonvolatile/clk_wander_threshold to ntpq.
* [Bug 2763] Allow different thresholds for forward and backward steps.
* [Bug 2766] ntp-keygen output files should not be world-readable.
* [Bug 2767] ntp-keygen -M should symlink to ntp.keys.
* [Bug 2771] nonvolatile value is documented in wrong units.
* [Bug 2773] Early leap announcement from Palisade/Thunderbolt
* [Bug 2774] Unreasonably verbose printout - leap pending/warning
* [Bug 2775] ntp-keygen.c fails to compile under Windows.
* [Bug 2777] Fixed loops and decoding of Meinberg GPS satellite info.
  Removed non-ASCII characters from some copyright comments.
  Removed trailing whitespace.
  Updated definitions for Meinberg clocks from current Meinberg header files.
  Now use C99 fixed-width types and avoid non-ASCII characters in comments.
  Account for updated definitions pulled from Meinberg header files.
  Updated comments on Meinberg GPS receivers which are not only called GPS16x.
  Replaced some constant numbers by defines from ntp_calendar.h
  Modified creation of parse-specific variables for Meinberg devices
  in gps16x_message().
  Reworked mk_utcinfo() to avoid printing of ambiguous leap second dates.
  Modified mbg_tm_str() which now expexts an additional parameter controlling
  if the time status shall be printed.
* [Sec 2779] ntpd accepts unauthenticated packets with symmetric key crypto.
* [Sec 2781] Authentication doesn't protect symmetric associations against
  DoS attacks.
* [Bug 2783] Quiet autoconf warnings about missing AC_LANG_SOURCE.
* [Bug 2784] Fix for 2782 uses clock_gettime() instead of get_ostime().
* [Bug 2789] Quiet compiler warnings from libevent.
* [Bug 2790] If ntpd sets the Windows MM timer highest resolution
  pause briefly before measuring system clock precision to yield
  correct results.
* Comment from Juergen Perlinger in ntp_calendar.c to make the code clearer.
* Use predefined function types for parse driver functions
  used to set up function pointers.
  Account for changed prototype of parse_inp_fnc_t functions.
  Cast parse conversion results to appropriate types to avoid
  compiler warnings.
  Let ioctl() for Windows accept a (void *) to avoid compiler warnings
  when called with pointers to different types.
---
(4.2.8p1) 2015/02/04 Released by Harlan Stenn <stenn@ntp.org>

* Update the NEWS file.
* [Sec 2671] vallen in extension fields are not validated.
---
(4.2.8p1-RC2) 2015/01/29 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2627] shm refclock allows only two units with owner-only access
  rework: reverted sense of mode bit (so default reflects previous
  behaviour) and updated ducumentation.
* [Bug 2732] - Leap second not handled correctly on Windows 8
  use 'GetTickCount()' to get the true elapsed time of slew
  (This should work for all versions of Windows >= W2K)
* [Bug 2738] Missing buffer initialization in refclocK_parse.c::parsestate().
* [Bug 2739] Parse driver with PPS enabled occasionally evaluates
  PPS timestamp with wrong sign.
  Removed some German umlauts.
* [Bug 2740] Removed some obsolete code from the parse driver.
* [Bug 2741] Incorrect buffer check in refclocK_parse.c::parsestatus().
---
(4.2.8p1-RC1) 2015/01/24 Released by Harlan Stenn <stenn@ntp.org>

* Start the RC for 4.2.8p1.
* [Bug 2187] Update version number generation scripts.
* [Bug 2617] Fix sntp Usage documentation section.
* [Sec 2672] Code cleanup: On some OSes ::1 can be spoofed...
* [Bug 2736] Show error message if we cannot open the config file.
* Copyright update.
* Fix the package name.
---
(4.2.8p1-beta5) 2015/01/07 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2695] Windows build: __func__ not supported under Windows.
* [Bug 2728] Work around C99-style structure initialization code
  for older compilers, specifically Visual Studio prior to VS2013.
---
(4.2.8p1-beta4) 2015/01/04 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1084] PPSAPI for ntpd on Windows with DLL backends
* [Bug 2695] Build problem on Windows (sys/socket.h).
* [Bug 2715] mdnstries option for ntp.conf from NetBSD.
* Fix a regression introduced to timepps-Solaris.h as part of:
  [Bug 1206] Required compiler changes for Windows
  (4.2.5p181) 2009/06/06
---
(4.2.8p1-beta3) 2015/01/02 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2627] shm refclock allows only two units with owner-only access
  Use mode bit 0 to select public access for units >= 2 (units 0 & 1 are
  always private.
* [Bug 2681] Fix display of certificate EOValidity dates on 32-bit systems.
* [Bug 2695] 4.2.8 does not build on Windows.
* [bug 2700] mrulist stopped working in 4.2.8.
* [Bug 2706] libparse/info_trimble.c build dependencies are broken.
* [Bug 2713] variable type/cast, parameter name, general cleanup from NetBSD.
* [Bug 2714] libevent may need to be built independently of any build of sntp.
* [Bug 2715] mdnstries option for ntp.conf from NetBSD.
---
(4.2.8p1-beta2) 2014/12/27 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2674] Install sntp in sbin on NetBSD.
* [Bug 2693] ntp-keygen doesn't build without OpenSSL and sntp.
* [Bug 2707] Avoid a C90 extension in libjsmn/jsmn.c.
* [Bug 2709] see if we have a C99 compiler (not yet required).
---
(4.2.8p1-beta1) 2014/12/23 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 2672] On some OSes ::1 can be spoofed, bypassing source IP ACLs.
* [Bug 2693] ntp-keygen doesn't build without OpenSSL.
* [Bug 2697] IN6_IS_ADDR_LOOPBACK build problems on some OSes.
* [Bug 2699] HAVE_SYS_SELECT_H is misspelled in refclock_gpsdjson.c.
---
(4.2.8) 2014/12/19 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 730] Increase RSA_generate_key modulus.
* [Sec 2666] Use cryptographic random numbers for md5 key generation.
* [Sec 2667] buffer overflow in crypto_recv().
* [Sec 2668] buffer overflow in ctl_putdata().
* [Sec 2669] buffer overflow in configure().
* [Sec 2670] Missing return; from error clause.
* [Sec 2671] vallen in extension fields are not validated.
* [Sec 2672] On some OSes ::1 can be spoofed, bypassing source IP ACLs.
* [Bug 2691] Wrong variable name in refclock_ripencc.c.
(4.2.7p486-RC) 2014/12/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2687] RefClock 26/hpgps doesn't work at default line speed
(4.2.7p485-RC) 2014/12/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2686] refclock_gpsdjson needs strtoll(), which is not always present.
(4.2.7p484-RC) 2014/12/11 Released by Harlan Stenn <stenn@ntp.org>
(4.2.7p483) 2014/12/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2685] Better document the KOD file for sntp.
(4.2.7p482) 2014/12/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2641] sntp is installed in the wrong location in Solaris.
* [Bug 2678] nmea_control() now checks 'refclock_params()' result.
(4.2.7p481) 2014/11/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2314] Only enable PPS if kernel consumer binding succeeds.
* [Bug 2314] Kernel PPS binding EOPNOTSUPP is a failure condition.
* Rename pps_enable to hardpps_enable.
(4.2.7p480) 2014/11/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2677] PATH_MAX isn't #define'd under Windows.
  Regression from the patch fixing Bug 2639.
(4.2.7p479) 2014/11/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2651] Certificates with ASN timestamps w/ 4-digit years mis-parsed.
(4.2.7p478) 2014/11/14 Released by Harlan Stenn <stenn@ntp.org>
* [Sec 2630] buffer overrun in ntpq tokenize().
* [Bug 2639] Check return value of ntp_adjtime().
* [Bug 2650] includefile processing broken.
* [Bug 2661] ntpq crashes with mreadvar.
(4.2.7p477) 2014/11/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2657] Document that "restrict nopeer" intereferes with "pool".
(4.2.7p476) 2014/10/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2503] SHT utility outdated
(4.2.7p475) 2014/09/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2654] refclock_true.c doesn't identify the Mk III.
(4.2.7p474) 2014/09/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2536] ntpd sandboxing support (libseccomp2) cleanup.
* [Bug 2649] Clean up html/ page installation.
(4.2.7p473) 2014/09/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2649] Clean up html/ page installation.
(4.2.7p472) 2014/09/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2556] mrulist is missing from the generated ntpq man page.
(4.2.7p471) 2014/09/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2649] "make install" leaves wrong owner for files in html/.
* [Bug 2652] Windows hates directory names that contain a :.
(4.2.7p470) 2014/09/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2502] Autogen text replacement errors.
* autogen-5.18.5pre1
* html/ cleanups from Hal Murray.
(4.2.7p469) 2014/09/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2536] ntpd sandboxing support (libseccomp2) cleanup.
(4.2.7p468) 2014/08/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2556] ntpq man page cleanup.
* autogen-5.18.4
(4.2.7p467) 2014/08/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2639] Check return value of ntp_adjtime().
* [Bug 2640] STA_NANO can result in invalid ntv.constant.
(4.2.7p466) 2014/08/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2536] ntpd sandboxing support (libseccomp2) cleanup.
(4.2.7p465) 2014/08/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2538] NTP programs print exit code in help/usage text.
* [Bug 2595] Man page quirks: ntpdate references in ntpd.
* [Bug 2613] www.ntp.org/bugs.html tells folks to email doc bugs to DLM.
* [Bug 2636] Clutter in syslog if gpsd not running
   - found (hopefully) last cause for clutter in protocol version
   - log GPSD revision and release numbers with protocol version
(4.2.7p464) 2014/08/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2636] Fix coverity warning from previous patch.
(4.2.7p463) 2014/08/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2636] Clutter in syslog if gpsd not running
   - make driver work with GPSD protocol version 3.9
   - use exponential back-off for connection problems
   - implement rate-limit for syslog entries
(4.2.7p462) 2014/08/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2622] Synchronisation problem using SHM [...]
  Add 'control' function -- fudge values not available during start.
(4.2.7p461) 2014/08/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1128] ntpq truncates "remote" host information.
* More autogen-5.18.4pre14 cleanup.
(4.2.7p460) 2014/08/13 Released by Harlan Stenn <stenn@ntp.org>
* More autogen-5.18.4pre14 cleanup.
(4.2.7p459) 2014/08/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2630] Limit the ntpq command buffer to 512 bytes.
* FlexeLint cleanups.
* Try bison-3.0.2 instead of bison-2.5.
(4.2.7p458) 2014/08/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2633] Provide stdnoreturn.h for windows port.
(4.2.7p457) 2014/08/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2622] Synchronisation problem using SHM when time difference is
  more than four hours: Change SHM driver so TOY restricted API is not
  used any more. (Plus some minor cleanup in logic and flow control)
* Pass the configration source into the parser as argument rather
  than through a global variable.
* Fix nits in the ntpq man page.
* autogen-5.18.4pre14
(4.2.7p456) 2014/08/07 Released by Harlan Stenn <stenn@ntp.org>
* CID 739722: Change the way the extention and MAC fields are processed.
(4.2.7p455) 2014/08/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2565] ntpd sometimes logs unexpected getifaddrs() errors.
* CID 739722: Clean up the definition of the exten field of struct pkt.
(4.2.7p454) 2014/07/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2628] 'mon_getmoremem()' relies on undefined behaviour
(4.2.7p453) 2014/07/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2597] leap file loose ends (follow-up)
  - uniform expiration check messages for config and timer triggered
    leap file loads
  - timer triggered loads log messages only once per day
(4.2.7p452) 2014/07/18 Released by Harlan Stenn <stenn@ntp.org>
* Make all of the html/ .html files use the same format for "Last update".
(4.2.7p451) 2014/07/17 Released by Harlan Stenn <stenn@ntp.org>
* Fix the "Last update" entries in the html/ subtree.
(4.2.7p450) 2014/07/16 Released by Harlan Stenn <stenn@ntp.org>
* Distribute the scripts needed for the fix for Bug 2547.
(4.2.7p449) 2014/07/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2547] Automate update of "Last Update" datestamps in .html files.
* [Bug 2623] Missing {} in refclock_oncore.c.
* Quiet warnings from ntp_calendar.h: avoid using argument names.
* Fix typos in decode.html and debug.html .
(4.2.7p448) 2014/07/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2621] Avoid use of indeterminate address after 'free()'
  (minor C standard conformance issue)
* Quiet warnings from ntp_calendar.h: avoid using argument names.
(4.2.7p447) 2014/07/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2620] Use version.pm for checking version numbers in NTP::Util.
* [Bug 2624] Fix signed compare on 'l_fp'.
(4.2.7p446) 2014/06/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2597] leap file processing -- loose ends.
* [Bug 2614] use 'unsigned long' consistently in ntp_random.c
  to avoid possibly undefined behaviour in signed int overflow
* [Bug 2619] Save a signed int copy of the return value of i2d_DSA_SIG().
  Provide missing msyslog() message in crypto_alice().
* Fix a variable lifetime issue.
* Allow for version suffix in libevent in ntp_libevent.m4.
(4.2.7p445) 2014/06/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2556] mrulist isn't mentioned in the ntpq man page.
(4.2.7p444) 2014/05/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2597] leap file processing -- loose ends
  fixed coverity issues
(4.2.7p443) 2014/05/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2594] Update the year in sntp/include/copyright.def.
(4.2.7p442) 2014/05/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2589] Update VS2013 project files for libntp.
* [Bug 2600] Fix "Undisicplined Local Clock" driver1.html page.
(4.2.7p441) 2014/05/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2597] leap file processing -- loose ends
  log daily warning when leap info less than 28 days to expiration or
  already expired; nag hourly on last day before expiration; log when
  leapfile name is invalid
(4.2.7p440) 2014/04/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2536] ntpd sandboxing support (libseccomp2) cleanup.
* [Bug 2570] cleanup: fix log format for successful leapfile load
(4.2.7p439) 2014/04/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2589] fix VS2009 compile problem.
(4.2.7p438) 2014/04/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2546] Windows build documentation updates.
(4.2.7p437) 2014/03/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2537] ntpd truncates symmetric keys to 20 bytes.
* [Bug 2546] Documentation updates.
(4.2.7p436) 2014/03/31 Released by Harlan Stenn <stenn@ntp.org>
* Update to libopts-40.2.15, and autogen-5.18.3pre18.
* [Bug 2311] Add more tags to mdoc2xxx.
* [Bug 2502] Assorted text replacement errors in 4.2.7p345
* [Bug 2538] ntp programs print exit code as part of the "usage" text.
(4.2.7p435) 2014/03/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2570] cleanup: reduced logging noise, moved some functions
  into libntp.
(4.2.7p434) 2014/03/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2577] Update VS2013 solution and project files.
(4.2.7p433) 2014/03/10 Released by Harlan Stenn <stenn@ntp.org>
* Clean up last-update timestamps of html/*.html files.
* [Bug 2546] Documentation updates.
(4.2.7p432) 2014/03/09 Released by Harlan Stenn <stenn@ntp.org>
* CID 711660: Do a non-NULL pointer assertion check a bit earlier.
(4.2.7p431) 2014/03/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2572] cross-compiling fails for --with-yielding-select.
(4.2.7p430) 2014/03/04 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to libevent-2.1.3-alpha-dev.
* [Bug 2572] cross-compiling fails for --with-yielding-select.
(4.2.7p429) 2014/03/03 Released by Harlan Stenn <stenn@ntp.org>
* CID 1165098: Remove logically dead code from refclock_true.c.
* CID 1189401: Use INSIST() instead of a belt-and-suspenders pointer check.
* In ntp_dir_sep.m4, we care about $host_os, not $target_os.
* [Bug 2170] Use AC_PREPROC_IFELSE instead of AC_EGREP_CPP.
* [Bug 2540] bootstrap script needs to 'touch' files in finer-grained groups.
* [Bug 2570] refuse to load leapsec file with bad/missing SHA1 hash
  -- change reading the hash line code: NIST omits leading zeros.
* [Bug 2576] refclock_gpsdjson.c doesn't compile if CLOCK_GPSDJSON is
  not enabled at configure time.
(4.2.7p428) 2014/03/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2570] refuse to load leapsec file with bad/missing SHA1 hash
* [Bug 2562] Distribute the code in libjsmn/ .
(4.2.7p427) 2014/03/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2562] GPSD_JSON: fix solaris issues (asprintf(), isfinite())
* [Bug 2562] first release of the GPSD client clock (type 46)
(4.2.7p426) 2014/02/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2113] Warn about ignored extra args in ntpq.
* [Bug 2540] bootstrap script needs to 'touch' files in finer-grained groups.
* [Bug 2561] Allow wildcards in the target of the "interface" command.
* [Bug 2572] cross-compiling fails for --with-yielding_select.
(4.2.7p425) 2014/02/26 Released by Harlan Stenn <stenn@ntp.org>
* Copyright file update.
(4.2.7p424) 2014/02/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2541] ntpd terminates itself with SIGHUP unexpectedly.
(4.2.7p423) 2014/02/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2565] Handle EINTR on getifaddrs().
(4.2.7p422) 2014/02/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2536] ntpd sandboxing support (libseccomp2).
(4.2.7p421) 2014/02/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 898] More documentation fixes.
* [Bug 2555] Autogen mdoc man pages all stamped with SunOS 5.10.
* calc_tickadj/Makefile.am man/mdoc page build cleanup.
(4.2.7p420) 2014/02/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 492] Clearly document ntpdate's pending deprecation.
* [Bug 1186] ntpd fails with link local IPv6 addresses.
* [Sec 2542] Strengthen the mrulist nonce.
(4.2.7p419) 2014/02/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2466] Wrap NMEA timestamps in 1024 week cycles.
(4.2.7p418) 2014/02/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2551] --disable-local-libevent breaks the build.
(4.2.7p417) 2014/02/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2539] doc and code tweaks for NMEA driver.
* Add check for enable stats to ntpd/complete.conf.in
* Fix typo in html/confopt.html
(4.2.7p416) 2014/01/31 Released by Harlan Stenn <stenn@ntp.org>
* Tweak the 'Modified' line on appropriate html pages.
* Note in the deprecation of ntpdc in its documentation.
* [Bug 2332] Be more careful about when we use 'libgcc_s'.
(4.2.7p415) 2014/01/28 Released by Harlan Stenn <stenn@ntp.org>
* Fix the man page installation for the scripts/ files.
(4.2.7p414) 2014/01/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 792] TrueTime TL-3 WWV refclock support.
* [Bug 898] Documentation fixes.
* [Bug 930] ntpdc docs refer to 'clockinfo', but mean 'clockstat'.
* [Bug 1002] ntp-keygen option and documentation updates: -p/--pvt-passwd
  is now -p/--password, and -q/--get-pvt-passwd is now -q/--export-passwd.
* [Bug 1349] statistics command not documented in HTML documentation.
  In html/monopt.html, add statistics id, definition, description, and
  correct typo.
  In html/scripts/monopt.txt, add statistics item, href, and comment.
  In ntpd/ntp.conf.def, under statistics correct four to eight kinds.
  In ntpd/complete.conf.in, add all eight kinds to statistics.
  In html/comdex.html, remove duplicate footer.
* [Bug 1734] Include man page for ntp.conf (fixed in 4.2.7p297).
* [Bug 2049] Clarify ntpdate's -d option behavior.
* [Bug 2366] ntpdc.html: burst/iburst only work on servers.
* [Bug 2493] ntptrace needs a man page (fixed in 4.2.7p402).
* [Bug 2545] Cleanup of scripts/monitoring/ntptrap.
(4.2.7p413) 2014/01/27 Released by Harlan Stenn <stenn@ntp.org>
* Require a version string for perl scripts that use autogen.
* html/ cleanup.
(4.2.7p412) 2014/01/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2540] bootstrap script needs to 'touch' files in finer-grained groups.
(4.2.7p411) 2014/01/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2532] Note in ntpdc docs that "enable pps" only works on older ntpd.
(4.2.7p410) 2014/01/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2332] Force reference to 'libgcc_s' when using GCC, because
  threading+restricted user+locked memory otherwise fails on Linux.
* [Bug 2530] Fix documentation for enable/disable mode7 and pps.
* Cleanup to the new scripts/*/Makefile.am files.
(4.2.7p409) 2014/01/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2060] Warn about restrictions with "kod" but not "limited".
(4.2.7p408) 2013/12/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2187] Update version number generation scripts.
(4.2.7p407) 2013/12/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2519] mktime.c does not compile on 64-bit Solaris but we do not
  need timegm() and the Solaris provides mktime().
* [Bug 2522] Revert Bug 2513 fix - it breaks backward compatibility.
(4.2.7p406) 2013/12/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2521] VPATH tweaks for perl -opts files.
(4.2.7p405) 2013/12/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2521] bootstrap script needs a tweak for perl -opts files.
* [Bug 2524] Add ntpsweep to sntp/loc/* files.
* [Bug 2526] Add "noinst" support to the sntp/loc/ framework.
(4.2.7p404) 2013/12/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 135] AIX5: "Address already in use" for IPv6 wildcard.
(4.2.7p403) 2013/12/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2513] Remove any PIDFILE in finish().
* [Bug 2516] Enable clock_gettime() support for AIX 5+.
* [Bug 2517] Fix peer status errors in decode.html.
(4.2.7p402) 2013/12/23 Released by Harlan Stenn <stenn@ntp.org>
* Incorporate Oliver Kindernay's GSoC 2013 scripts/ cleanup.
(4.2.7p401) 2013/11/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2491] VS20xx compile fixes.
(4.2.7p400) 2013/11/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2491] VS2013 project files.
(4.2.7p399) 2013/11/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2326] More leapsecond file notification cleanup.
* [Bug 2506] make sure routing updates are always tracked
* [Bug 2514] secs/* #define usage cleanup.
(4.2.7p398) 2013/11/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2326] More leapsecond file notification cleanup.
* Improve sntp KoD data file fopen() error message.
(4.2.7p397) 2013/11/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2326] More leapsecond file notification cleanup.
(4.2.7p396) 2013/11/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2326] Improve stale leapsecond notifications.
(4.2.7p395) 2013/11/12 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to autogen-5.18.3pre5 and libopts-40.1.15.
(4.2.7p394) 2013/11/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1050] Change ONCORE log message for leap second announcement
  to avoid misunderstandings.
* [Bug 2499] Win32 user-space/loopback ppsapi provider drops samples.
* [Bug 2256] Improve configure's function searches in libraries.
(4.2.7p393) 2013/10/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2272] Use C99 integer types. ntp_calendar.h and ntp_types.h .
(4.2.7p392) 2013/10/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2375] Improve AIX compatibility.
* [Bug 2490] Fixed non-const initializer coming from [Bug 2250] fix.
(4.2.7p391) 2013/10/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2250] Rework of leap second handling machine.
* [Bug 2419] [rc-nmea] Improve clockstats reporting when receiver sends
  data without valid GPS fix.
(4.2.7p390) 2013/09/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2482] Cleanup of droproot and jail support for Solaris.
(4.2.7p389) 2013/09/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2473] revisited: NTPD exits after clock is stepped backwards
  Avoid possible unsigned underrun for startup condition when testing
  for clock backstep.
* [Bug 2481] ntpd aborts when both user and group are specified with -u.
* [Bug 2482] Add droproot and jail support for Solaris.
(4.2.7p388) 2013/09/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2473] NTPD exits after clock is stepped backwards externally
(4.2.7p387) 2013/09/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1642] ntpdsim can't find simnulate block in config file.
(4.2.7p386) 2013/09/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2472] (WinXP) Avoid self-termination of IO thread during exit().
(4.2.7p385) 2013/08/19 Released by Harlan Stenn <stenn@ntp.org>
* CID 975596: Copy/paste error: vallen should be siglen.
* CID 1009579: Check return status of X509_add_ext().
* [2085] Fix root distance and root dispersion calculations.
* [Bug 2426] Possibly uninitialized data in crypto_send() - CID 975596.
(4.2.7p384) 2013/08/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2450] --version has bogus short option.
(4.2.7p383) 2013/08/10 Released by Harlan Stenn <stenn@ntp.org>
* (no changes - force a rebuild for a new Coverity scan)
(4.2.7p382) 2013/08/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2454] Need way to set file descriptor limit - cleanup.
(4.2.7p381) 2013/08/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2451] rlimit command is missing from the table of contents in
  miscopt.html .
* [Bug 2452] provide io_handler/input_handler only on
  non HAVE_IO_COMPLETION_PORT platforms
* [Bug 2453] Need a way to avoid calling mlockall.
* [Bug 2454] Need way to set file descriptor limit.
* [Bug 2458] AM_CONFIG_HEADER is obsolete.
(4.2.7p380) 2013/08/03 Released by Harlan Stenn <stenn@ntp.org>
* CID 984511: Some systems have different printf needs for sizeof.
(4.2.7p379) 2013/08/02 Released by Harlan Stenn <stenn@ntp.org>
* CID 739724: Fix printf arg mismatch in a debug line.
* [Bug 2425] compile io_handler() in ntp_io.c unconditionally
* [Bug 2448] Fix checks for configure --with-stack-limit and --with-memlock
  values.
(4.2.7p378) 2013/08/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2425] move part of input handler code from ntpd.c to ntp_io.c
  and fix select()-only platforms calling input_handler directly.
* [Bug 2446] Quiet warnings from Oracle's Studio compiler.
* Upgrade to AutoGen-5.18.1pre3
* Upgrade to libopts-40.1.15.
(4.2.7p377) 2013/07/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2397] License/copyright cleanup.
* [Bug 2439] Fix check of EscapeCommFunction() in ports/winnt/libntp/termios.c.
(4.2.7p376) 2013/07/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2322] Oncore driver should send 0 PPS offset to GPS.
(4.2.7p375) 2013/07/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 883] log warning arguments swapped in refclock_gpsvme.c.
* [Bug 2368] Correct bug in previous attempt.
* [Bug 2413] Fix "make check" with automake >= 1.13.
* [Bug 2434] Line-buffer (v. block-buffer) stdout.
(4.2.7p374) 2013/07/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2368] make check troubles in libevent.
* [Bug 2425] setup SIGIO/SIGPOLL for asyncio on the read side
  of a socketpair for the worker thread.
(4.2.7p373) 2013/07/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2427] configure fails to detect recvmsg() on Solaris.
(4.2.7p372) 2013/07/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1466] Oncore should set FLAG_PPS.
* [Bug 2375] AIX 7 doesn't like a libevent validation check.
* [Bug 2423] Log command-line args at LOG_INFO.
* [Bug 2428] do_unconf() should reset 'items' before the 2nd loop.
(4.2.7p371) 2013/07/07 Released by Harlan Stenn <stenn@ntp.org>
* CID 1042586: Check the return value of clock_gettime() in worker_sleep().
* Upgrade to libopts-39.0.14 from 5.17.5pre10.
(4.2.7p370) 2013/07/06 Released by Harlan Stenn <stenn@ntp.org>
* Remove \n's from syslog output strings.
(4.2.7p369) 2013/07/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2415] RES_LIMITED flags check should use &, not &&.
* Have NTP_LIBNTP check for time.h and clock_getres().
* Fix ntpsweep to use sntp instead of ntpdate, from Oliver Kindernay.
(4.2.7p368) 2013/05/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2145] ntpq dumps core when displaying sys_var_list and more.
(4.2.7p367) 2013/04/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1485] Sometimes ntpd crashes
* [Bug 2382] Implement LOGTOD using ldexp() instead of shifting.
(4.2.7p366) 2013/04/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1866] Disable some debugging output in refclock_oncore.
(4.2.7p365) 2013/04/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2149] Log an error message if /proc/net/if_inet6 cannot be opened.
(4.2.7p364) 2013/03/26 Released by Harlan Stenn <stenn@ntp.org>
* Bump sntp/include/autogen-version.def .
(4.2.7p363) 2013/03/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2357] sntp/libopts/usage.c sometimes needs -lintl.
* Upgrade to libopts from 5.17.3pre10.
(4.2.7p362) 2013/03/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2364] "sed -i" is not portable.
(4.2.7p361) 2013/03/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2357] sntp/libopts/usage.c sometimes needs -lintl.
* [Bug 2365] "make check" fails in libevent.
(4.2.7p360) 2013/03/15 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade libevent (coverity fixes, etc.).
* EEXIST is OK for mkdir() in sntp/kod_management.c.
(4.2.7p359) 2013/03/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2359] Fix send_via_ntp_signd() prototype.
(4.2.7p358) 2013/02/27 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to autogen-5.17.3pre4 and libopts-38.0.13.
* [Bug 2357] sntp/libopts/usage.c on NetBSD needs -lintl.
(4.2.7p357) 2013/02/22 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to autogen-5.17.2pre and libopts-38.0.13.
(4.2.7p356) 2013/02/19 Released by Harlan Stenn <stenn@ntp.org>
* Added loc/debian.
(4.2.7p355) 2013/02/18 Released by Harlan Stenn <stenn@ntp.org>
* CID 739708: Check return status of fcntl() in refclock_arc.c.
* CID 739709: Check return status of fcntl() in refclock_datum.c.
* CID 739710: Check return status of mkdir() in sntp/kod_management.c.
* CID 739711: Ignore return status of remove() in ntp-keygen.c.
* CID 739723: Print sizeof as unsigned.
* CID 971094: Clean up time of check/time of use in check_leap_file().
(4.2.7p354) 2013/02/10 Released by Harlan Stenn <stenn@ntp.org>
* CID 97194: Check return from setsockopt().
* CID 739473,739532: Out-of-bounds access/illegal address computation.
* CID 739558: Double close.
* CID 739559: Double close.
* CID 739713: devmask/recmask copy/paste error.
* CID 739714: Fix code indentation level.
* CID 739715: Clean up sockaddr_dump().
(4.2.7p353) 2013/02/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2326] Check hourly for a new leapfile if the old one expired.
(4.2.7p352) 2013/01/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2326] Notice when a new leapfile has been installed.
(4.2.7p351) 2013/01/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2328] Don't apply small time adjustments on Windows versions
  which don't support this.
(4.2.7p350) 2013/01/21 Released by Harlan Stenn <stenn@ntp.org>
* Added sntp/loc/netbsd based on info from Christos Zoulas.
(4.2.7p349) 2013/01/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2321] Fixed Windows build, but autogen update still required.
(4.2.7p348) 2013/01/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2327] Rename sntp/ag-tpl/:Old to sntp/ag-tpl/Old.
* Cleanup to ntpsnmpd-opts.def.
* Cleanup to ntpq.texi.
* Documentation cleanup to the ntpd, ntpdc, ntpq and ntp-wait
  .def files.
* In ntp.conf.def, cleanup SEE ALSO, document 'rlimit' options.
* Add a reference to RFC5907 in the ntpsnmpd documentation.
(4.2.7p347) 2013/01/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2325] Re-enable mlockall() check under Linux post-1223 fix.
(4.2.7p346) 2013/01/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1223] reorganize inclusion of sys/resource.h.
(4.2.7p345) 2013/01/04 Released by Harlan Stenn <stenn@ntp.org>
* Update several .def files to use autogen-5.17 feature set.
(4.2.7p344) 2013/01/03 Released by Harlan Stenn <stenn@ntp.org>
* Refactor and enhance mdoc2texi.
* Make sure agtexi-file.tpl defines label-str.
* Cleanup to ntp.conf.def.
* Upgrade to autogen-5.17 and libopts-37.0.12.
(4.2.7p343) 2013/01/02 Released by Harlan Stenn <stenn@ntp.org>
* Update the copyright year.
(4.2.7p342) 2012/12/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2081 - Backward Incompatible] rawstats now logs everything.
(4.2.7p341) 2012/12/30 Released by Harlan Stenn <stenn@ntp.org>
(4.2.7p340) 2012/12/29 Released by Harlan Stenn <stenn@ntp.org>
* mdoc2texi fixes: trailing punctuation.
(4.2.7p339) 2012/12/26 Released by Harlan Stenn <stenn@ntp.org>
* mdoc2texi fixes: parseQuote, closing of list item tables.
* ntp-wait, ntpd, ntpdc, ntpq, ntpsnmpd autogen documentation updates.
(4.2.7p338) 2012/12/25 Released by Harlan Stenn <stenn@ntp.org>
* mdoc2texi fixes: Handle_ArCmFlIc, Handle_Fn, HandleQ.
* ntp-keygen autogen documentation updates.
* ntpq autogen docs.
(4.2.7p337) 2012/12/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1223] More final cleanup for rlimit changes.
(4.2.7p336) 2012/12/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1223] Final cleanup for rlimit changes.
(4.2.7p335) 2012/12/18 Released by Harlan Stenn <stenn@ntp.org>
* Update documentation templates and definitions.
* Create agtexi-file.tpl .
(4.2.7p334) 2012/12/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2114] Update tests for sntp's synch distance.
* Create ntp-keygen.{html,texi}.
(4.2.7p333) 2012/12/07 Released by Harlan Stenn <stenn@ntp.org>
* Autogen documentation cleanup.
(4.2.7p332) 2012/12/06 Released by Harlan Stenn <stenn@ntp.org>
* sntp documentation cleanup.
(4.2.7p331) 2012/12/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2114] Correctly calculate sntp's synch distance.
(4.2.7p330) 2012/12/03 Released by Harlan Stenn <stenn@ntp.org>
* autogen doc cleanup
(4.2.7p329) 2012/12/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2278] ACTS flag3 mismatch between code and driver18.html.
* Use an enum for the ACTS state table.
* html doc reconciliation with DLM's copy.
(4.2.7p328) 2012/11/30 Released by Harlan Stenn <stenn@ntp.org>
* html doc reconciliation with DLM's copy.
(4.2.7p327) 2012/11/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2024] Identify Events in the system status word in decode.html.'
* [Bug 2040] Provide a command-line option for the identity key bits.
* Create loc/darwin for Mac OSX
(4.2.7p326) 2012/11/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1214] 'proto: precision = ...' should be at INFO, not NOTICE.
* [Bug 2246] Clear sys_leap when voting says to disarm the leap.
(4.2.7p325) 2012/11/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2202] ntpq.html: there is no "acv" billboard.
* [Bug 2306] keep pps hack for Win32 even if user-mode/loopback
  PPS API is activated on a serial line.
(4.2.7p324) 2012/11/19 Released by Harlan Stenn <stenn@ntp.org>
* Reinstate doc fix to authentic.html from Mike T.
* [Bug 1223] cleanup for rlimit changes.
* [Bug 2098] Install DLM's HTML documentation.
* [Bug 2306] Added user-mode/loop-back PPS API provider for Win32
(4.2.7p323) 2012/11/18 Released by Harlan Stenn <stenn@ntp.org>
* html/ updates from Dave Mills.
(4.2.7p322) 2012/11/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1223] Allow configurable values for RLIMIT_STACK and
  RLIMIT_MEMLOCK.
* [Bug 1320] Log ntpd's initial command-line parameters. (updated fix)
* [Bug 2120] no sysexits.h under QNX.
* [Bug 2123] cleanup to html/leap.html.
(4.2.7p321) 2012/11/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1320] Log ntpd's initial command-line parameters.
(4.2.7p320) 2012/11/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 969] Clarify ntpdate.html documentation about -u and ntpd.
* [Bug 1217] libisc/ifiter_sysctl.c:internal_current(): Ignore RTM
  messages with wrong version
(4.2.7p319) 2012/11/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2296] Fix compile problem with building with old OpenSSL.
(4.2.7p318) 2012/11/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2301] Remove spurious debug output from ntpq.
(4.2.7p317) 2012/11/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 922] Allow interspersed -4 and -6 flags on the ntpq command line.
(4.2.7p316) 2012/10/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2296] Update fix for Bug 2294 to handle --without-crypto.
(4.2.7p315) 2012/10/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2294] ntpd crashes in FIPS mode.
(4.2.7p314) 2012/10/23 Released by Harlan Stenn <stenn@ntp.org>
* Document a tricky malloc() of dns_ctx in sntp.
(4.2.7p313) 2012/10/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2291] sntp should report why it cannot open file.kod.
* [Bug 2293] add support for SO_BINTIME, refine support for
  SO_TIMESTAMPNS (bug 1374)
(4.2.7p312) 2012/10/11 Released by Harlan Stenn <stenn@ntp.org>
* Clean up testing/debugging of fix for [Bug 938] from sntp/main.c .
(4.2.7p311) 2012/10/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 938] The argument to the -D flag takes a number, not a string.
* [Bug 1013] ntpdate's HTML page claims wrong default version.
* [Bug 1374] Support SO_TIMESTAMPNS.
(4.2.7p310) 2012/10/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1374] Support SO_TIMESTAMPNS.
* [Bug 2266] Remove deprecated refclock_trak.c from Windows Makefile
  equivalents.
* [Bug 2274] Bring libopts/enum.c back to (old) ANSI C compliance.
(4.2.7p309) 2012/10/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2287] ntpdate returns 0 even if adjtime() call fails.
(4.2.7p308) 2012/09/29 Released by Harlan Stenn <stenn@ntp.org>
* CID 97198: Check return from ioctl() calls in refclock_acts.c.
(4.2.7p307) 2012/09/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1997] Fix sntp broadcast timeouts.
* [Bug 2234] Fix incorrect ntptrace html documentation.
* [Bug 2262] Install html docs in $htmldir.
* Fix typo in html/select.html.
(4.2.7p306) 2012/09/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 752] ToS cleanup from Mike Tatarinov.
(4.2.7p305) 2012/09/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 752] Use proper ToS network packet markings for IPv4 and IPv6.
* [Bug 1232] Convert SHM refclock to use struct timespec.
* [Bug 2258] Add syslog message about leap insertion.
* [Bug 2263] broadcast server doesn't work for host with
  OS_MISSES_SPECIFIC_ROUTE_UPDATES.
* [Bug 2271] Decode refclock types when built with --disable-all-clocks.
* [Bug 2276] clk_sel240x.c #define's _XOPEN_SOURCE, breaking QNX6.
* Updates to driver28.html.
(4.2.7p304) 2012/09/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2264] Cleanup SEL240X Refclock.
* In refclock_wwv.c rename SECOND to WWV_SEC and MINUTE to WWV_MIN.
(4.2.7p303) 2012/09/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1232] Add nanosecond support to SHM driver.
(4.2.7p302) 2012/09/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2160] Log warning about expired leapseconds file.
(4.2.7p301) 2012/09/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2164] Greater precision needed for ntpq offset report.
* Clean the man5_MANS in ntpd/ .
(4.2.7p300) 2012/09/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2262] Install sntp.html into htmldir.
* [Bug 2270] Install fails due to repeated man5 page names.
(4.2.7p299) 2012/09/01 Released by Harlan Stenn <stenn@ntp.org>
* More cleanup to the bootstrap script.
(4.2.7p298) 2012/09/01 Released by Harlan Stenn <stenn@ntp.org>
* Handle additional man page sections in the bootstrap script.
* Remove extraneous parens.
* Add a missing "%s" syslog format string.
(4.2.7p297) 2012/09/01 Released by Harlan Stenn <stenn@ntp.org>
* Fix mdoc2man.
* Distribute ntp.conf.def and ntp.keys.def.
(4.2.7p296) 2012/08/31 Released by Harlan Stenn <stenn@ntp.org>
* Begin support for autogen maintaining ntp.conf and ntp.keys docs.
* Upgrade to autogen-5.16.2 and libopts-36.5.11.
* Potential bugfix for agtexi-cmd.tpl.
(4.2.7p295) 2012/08/11 Released by Harlan Stenn <stenn@ntp.org>
* Look for syslog's facilitynames[].
(4.2.7p294) 2012/08/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2242] configure fails to detect getifaddrs function on Solaris.
* [Bug 2249] Bad operator for 'test' in 'make check' of libevent.
* [Bug 2252] palisade: formats nanosecs to a 6-char field.
* Attempt to resolve strict-aliasing violation in refclock_tsyncpci.c.
* Fix && -> & typo in refclock_palisade.c debug statements.
(4.2.7p293) 2012/08/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2247] (more) Get rid of the TRAK refclock - deprecated since 2006.
* Documentation cleanup from Mike T.
* Cleanup kclk_sel240x.o rules in libparse/Makefile.am.
(4.2.7p292) 2012/08/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1545] Note why we are logging the Version string.
* [Bug 1872] Remove legacy ppsclock fdpps, #ifdef PPS.
* [Bug 2075] Fix spelling of 'incompatible'.
* [Bug 2247] Get rid of the TRAK refclock - deprecated since 2006.
* Clean up an exit status in ntpq.c.
(4.2.7p291) 2012/07/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2241] MDNS registration should only happen if requested.
(4.2.7p290) 2012/07/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1454] Add parse clock support for the SEL-240x GPS products.
* CID 709185: refclock_chu.c will leak fd==0 (better fix)
(4.2.7p289) 2012/07/16 Released by Harlan Stenn <stenn@ntp.org>
* CID 97123: Future-proof possible change to refclock_nmea.c.
* CID 97377: ntp-keygen.c's followlink() might not NUL-terminate.
* CID 709185: refclock_chu.c will leak fd==0 (which should be impossible).
(4.2.7p288) 2012/07/03 Released by Harlan Stenn <stenn@ntp.org>
* CID 709173: Make sure a libisc function we do not use is called properly.
(4.2.7p287) 2012/07/03 Released by Harlan Stenn <stenn@ntp.org>
* Remove 1024 associations-per-server limit from ntpq.
* Remove blank line between ntpq mreadvar associations.
(4.2.7p286) 2012/06/28 Released by Harlan Stenn <stenn@ntp.org>
* CID 97193: check return from sscanf() in ntp_config.c.
* CID 709169: check return from open("/dev/null", 0) and friends.
* CID 709207: Initialize "quality" for ulink_receive.
(4.2.7p285) 2012/06/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2227] Enable mrulist access control via "restrict ... nomrulist".
* Automake-1.12 wants us to use AM_PROG_AR.
* Conditionalize msyslog messages about rejected mode 6 requests due to
  nomodify and nomrulist restrictions under "logconfig +sysinfo".
* Increment sys_restricted in a few rejection paths due to nomodify
  restrictions where previosuly overlooked.
(4.2.7p284) 2012/06/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2225] libevent configure hangs.
* Update bundled libevent to git master, post libevent 2.1.1-alpha.
(4.2.7p283) 2012/06/16 Released by Harlan Stenn <stenn@ntp.org>
* In sntp/m4/ntp_openssl.m4, Support multiple package names for the
  crypto library.  Add legacy support for -Wl,-rpath.
(4.2.7p282) 2012/06/15 Released by Harlan Stenn <stenn@ntp.org>
* tickadj may need to be linked with PTHREAD_LIBS.
(4.2.7p281) 2012/06/14 Released by Harlan Stenn <stenn@ntp.org>
* U_INT32_MAX cleanup in include/ntp_types.h .
* When linking, ntp_keygen and tickadj need $(LIBM).
(4.2.7p280) 2012/06/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2224] Use-after-free in routing socket code after dropping root.
(4.2.7p279) 2012/06/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2211] findbcastinter(): possibly undefined variable iface used.
* [Bug 2220] Incorrect check for maximum association id in ntpq.
(4.2.7p278) 2012/06/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2204] Build with --enable-getifaddrs=glibc fails.
* [Bug 2178] refclock_tsyncpci.c reach register fails to shift.
* [Bug 2191] dcfd -Y y2kcheck on CentOS 6.2 x86_64 breaks make check.
(4.2.7p277) 2012/05/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2193] Building timestruct tests with Clang 3.1 fails.
(4.2.7p276) 2012/05/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2179] Remove sntp/header.h.
(4.2.7p275) 2012/04/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1744] Remove obsolete ntpdate/ntptime* items.
(4.2.7p274) 2012/04/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2174] ntpd rejects source UDP ports less than 123 as bogus.
(4.2.7p273) 2012/04/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2141] handle_sigio() calls get_systime(), which must be
  reentrant when SIGIO is used.  Sanity checks relative to the prior
  get_systime() are disabled in ntpd on systems with signaled I/O, but
  active in sntp and ntpdate.
* Correct authnumfreekeys accounting broken in 4.2.7p262.
(4.2.7p272) 2012/04/14 Released by Harlan Stenn <stenn@ntp.org>
* LCRYPTO is gone - replace with VER_SUFFIX.
* Change the link order for ntpsntpd.
* Remove extra 'nlist' check from configure.ac.
(4.2.7p271) 2012/04/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1122] openssl detection via pkg-config fails when no additional
  -Idir flags are needed.
* Avoid overwriting user variable LDFLAGS with OpenSSL flags, instead
  they are added to LDFLAGS_NTP.
(4.2.7p270) 2012/03/26 Released by Harlan Stenn <stenn@ntp.org>
* Update driver45.html page.
(4.2.7p269) 2012/03/25 Released by Harlan Stenn <stenn@ntp.org>
* Clean up configure.ac.
* Cleanup configure.ac's TSYNC PCI section.
(4.2.7p268) 2012/03/24 Released by Harlan Stenn <stenn@ntp.org>
* Update driver45.html page.
(4.2.7p267) 2012/03/23 Released by Harlan Stenn <stenn@ntp.org>
* Initial cut at a basic driver45.html page.
(4.2.7p266) 2012/03/21 Released by Harlan Stenn <stenn@ntp.org>
* Add refclock_tsyncpci.c (driver 45) supporting Spectracom TSYNC timing
  boards.
(4.2.7p265) 2012/03/20 Released by Harlan Stenn <stenn@ntp.org>
* Treat zero counter as indication of precise system time in Windows
  PPSAPI helper function pps_ntp_timestamp_from_counter(), enabling
  PPSAPI providers to use the Windows 8 precise clock directly.
(4.2.7p264) 2012/03/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2160] Note if leapseconds file is past its prime.
* Use GetSystemTimePreciseAsFileTime() on Windows 8.
(4.2.7p263) 2012/03/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2156] clock instability with LOCAL driver, from Miroslav Lichvar.
* [Bug 2159] Windows ntpd using leapfile erroneous leap second 20120401.
(4.2.7p262) 2012/02/29 Released by Harlan Stenn <stenn@ntp.org>
* Improve ntpd scalability for servers with many trusted keys.
(4.2.7p261) 2012/02/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2048] add the clock variable timecode to SHM refclock.
(4.2.7p260) 2012/02/24 Released by Harlan Stenn <stenn@ntp.org>
* Fix the check-scm-rev invocation in several Makefile.am's.
(4.2.7p259) 2012/02/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2148] ntpd 4.2.7p258 segfault with 0x0100000 bit in NMEA mode.
* refclock_nmea.c merge cleanup thanks to Juergen Perlinger.
(4.2.7p258) 2012/02/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2140] Rework of Windows I/O completion port handling to avoid
  garbling serial input in UNIX line discipline emulation.
* [Bug 2143] NMEA driver: discard data if quality indication not good,
  add statistic counters (mode bit enabled) to clockstats file.
(4.2.7p257) 2012/02/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2135] defer calls to 'io_input' to main thread under Windows.
(4.2.7p256) 2012/02/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2131] Set the system variable settimeofday only after clock step.
* [Bug 2134] --enable-C99-snprintf does not force rpl_snprintf use.
(4.2.7p255) 2012/01/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 603] Only link with nlist()-related libraries when needed:
  More cleanup.
(4.2.7p254) 2012/01/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 603] Only link with nlist()-related libraries when needed.
(4.2.7p253) 2012/01/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2126] Compile error on Windows with libopts from Autogen 5.14.
* Update one of the license URLs.
(4.2.7p252) 2012/01/25 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to autogen-5.14 (and libopts-36.1.11).
(4.2.7p251) 2012/01/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2115] ntptrace should accept both rootdispersion and rootdisp.
(4.2.7p250) 2012/01/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2113] Warn about ignored extra args in ntpq.
* Update the copyright year.
(4.2.7p249) 2012/01/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2111] Remove minpoll delay before iburst for pool and
  manycastclient.
* Move refclock-specific scheduled timer code under #ifdef REFCLOCK
  and move "action" and "nextaction" data for same from struct peer to
  struct refclockproc.  These provide a way to schedule a callback some
  seconds in the future.
(4.2.7p248) 2012/01/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2109] "make clean check" is broken with gtest available.
* [Bug 2110] systime.c typo breaks build on microsecond clocks.
(4.2.7p247) 2012/01/07 Released by Harlan Stenn <stenn@ntp.org>
* Fix build break triggered by updating deps-ver and libntp/systime.c at
  the same time by explicitly depending systime_s.c on systime.c.
(4.2.7p246) 2012/01/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2104] ntpdc fault with oversize -c command.
* [Bug 2106] Fix warnings when using -Wformat-security.
* Refactor timespecops.h and timevalops.h into inline functions.
(4.2.7p245) 2011/12/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2100] conversion problem with timespec/timeval <--> l_fp fixed;
  added tests to expose the bug.
(4.2.7p244) 2011/12/25 Released by Harlan Stenn <stenn@ntp.org>
* Updates from 4.2.6p5.
(4.2.7p243) 2011/12/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2095] ntptrace now needs 'rv' instead of 'pstat', reported
  by Michael Tatarinov.
(4.2.7p242) 2011/12/21 Released by Harlan Stenn <stenn@ntp.org>
* Include missing html/icons/sitemap.png, reported by Michael Tatarinov.
* Documentation updates from Dave Mills.
(4.2.7p241) 2011/12/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2015] Overriding sys_tick should recalculate sys_precision.
* [Bug 2037] Fuzzed non-interpolated clock may decrease.
* [Bug 2068] "tos ceiling" default and cap changed to 15.
* Floor peer delay using system precision, as with jitter, reflecting
  inability to measure shorter intervals.
(4.2.7p240) 2011/12/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2092] clock_select() selection jitter miscalculated.
* [Bug 2093] Reintroduce smaller stratum factor to system peer metric.
(4.2.7p239) 2011/12/11 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p238) 2011/12/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2082] from 4.2.6p5-RC3: 3-char refid sent by ntpd 4.2.6p5-RC2
  ends with extra dot.
* [Bug 2085] from 4.2.6p5-RC3: clock_update() sys_rootdisp calculation
  omits root delay.
* [Bug 2086] from 4.2.6p5-RC3: get_systime() should not offset by
  sys_residual.
* [Bug 2087] from 4.2.6p5-RC3: sys_jitter calculation overweights
  sys.peer jitter.
* from 4.2.6p5-RC3: Ensure NULL peer->dstadr is not accessed in orphan
  parent selection.
(4.2.7p237) 2011/12/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2050] from 4.2.6p5-RC2: Orphan mode stratum counting to infinity.
* [Bug 2059] from 4.2.6p5-RC2: optional billboard column "server" does
  not honor -n.
* [Bug 2066] from 4.2.6p5-RC2: ntpq lopeers ipv6 "local" column overrun.
* [Bug 2068] from 4.2.6p5-RC2: ntpd sends nonprintable stratum 16 refid
  to ntpq.
* [Bug 2069] from 4.2.6p5-RC2: broadcastclient, multicastclient spin up
  duplicate ephemeral associations without broadcastdelay.
* [Bug 2072] from 4.2.6p5-RC2: Orphan parent selection metric needs
  ntohl().
* [Bug 2073] Correct ntpq billboard's MODE_PASSIVE t from 'u' to 'S'.
* from 4.2.6p5-RC2: Exclude not-yet-determined sys_refid from use in
  loopback TEST12 (from Dave Mills).
* from 4.2.6p5-RC2: Never send KoD rate limiting response to MODE_SERVER.
* Floor calculation of sys_rootdisp at sys_mindisp in clock_update (from
  Dave Mills).
* Restore 4.2.6 clock_combine() weighting to ntp-dev, reverting to pre-
  4.2.7p70 method while also avoiding divide-by-zero (from Dave Mills).
* Round l_fp traffic interval when converting to integer in rate limit
  and KoD calculation.
(4.2.7p236) 2011/11/16 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p235) 2011/11/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2052] Autokey CRYPTO_ASSOC host@group vallen needs checking.
(4.2.7p234) 2011/11/07 Released by Harlan Stenn <stenn@ntp.org>
* Clean up -libm entries regarding libntp.a
(4.2.7p233) 2011/11/06 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p232) 2011/11/05 Released by Harlan Stenn <stenn@ntp.org>
* Update the NEWS file so we note the default disable of mode 7 requests.
* Clean up some bitrotted code in libntp/socket.c.
(4.2.7p231) 2011/11/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1940] ignore auth key if hex decoding fails.
* Add ntpq reslist command to query access restrictions, similar to
  ntpdc's reslist.
(4.2.7p230) 2011/11/01 Released by Harlan Stenn <stenn@ntp.org>
* Disable mode 7 (ntpdc) query processing in ntpd by default.  ntpq is
  believed to provide all functionality ntpdc did, and uses a less-
  fragile protocol that's safer and easier to maintain.  If you do find
  some management via ntpdc is needed, you can use "enable mode7" in the
  ntpd configuration.
* Directly limit the number of datagrams in a mrulist response, rather
  than limiting the number of entries returned to indirectly limit the
  datagram count.
* Documentation updates from Dave Mills.
(4.2.7p229) 2011/10/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1995] fix wrong use of ZERO() macro in 'ntp_calendar.c'
(4.2.7p228) 2011/10/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1995] add compile time stamp based era unfolding for
  'step_systime()' and necessary support to 'ntp-calendar.c'.
(4.2.7p227) 2011/10/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2036] gcc 2.95.3 preprocessor can't nest #ifdef in macro args.
* A number of compiler warnings eliminated.
(4.2.7p226) 2011/10/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2035] ntpq -c mrulist sleeps 1 sec between queries, not 5 msec.
* Documentation updates from Dave Mills.
(4.2.7p225) 2011/10/15 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p224) 2011/10/14 Released by Harlan Stenn <stenn@ntp.org>
* ntpq mrulist shows intermediate counts every five seconds while
  retrieving list, and allows Ctrl-C interruption of the retrieval,
  showing the incomplete list as retrieved.  Reduce delay between
  successive mrulist retrieval queries from 30 to 5 msec.  Do not
  give up mrulist retrieval when a single query times out.
(4.2.7p223) 2011/10/12 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p222) 2011/10/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2029] "make check" clutters syslog.
* Log signal description along with number on ntpd exit.
(4.2.7p221) 2011/10/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2025] Switching between daemon and kernel loops can doubly-
  correct drift
* [Bug 2028] ntpd -n (nofork) redirects logging to stderr.
* Documentation updates from Dave Mills.
(4.2.7p220) 2011/10/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1945] mbg_gps166.h use of _TM_DEFINED conflicts with MS VC.
* [Bug 1946] parse_start uses open; does not work on Windows.
* [Bug 1947] Porting parse-based Wharton refclock driver to Windows.
* [Bug 2024] Remove unused system event code EVNT_CLKHOP.
(4.2.7p219) 2011/10/04 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p218) 2011/10/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2019] Allow selection of cipher for private key files.
* Documentation updates from Dave Mills.
* ntp-keygen private key cipher default now triple-key triple DES CBC.
* ntp-keygen -M is intended to ignore all other defaults and
  options, so do not attempt to open existing Autokey host certificate
  before generating symmetric keys and terminating.
* Restore IFF, MV, and GQ identity parameter filename convention to
  ntpkey_<scheme>par_<group/host> in ntpd, matching ntp-keygen.
* Change some error logging to syslog to ignore logconfig mask, such
  as reporting PPSAPI failure in NMEA and WWVB refclocks.
* ntp-keygen on Windows XP and later systems will now create links
  expected by ntpd.  They are hardlinks on Windows, soft on POSIX.
* Conditionalize NMEA serial open message under clockevent.
* Send all peer variables to trappers in report_event().
(4.2.7p217) 2011/09/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2020] ntp-keygen -s no longer sets host in cert file name.
* [Backward Incompatible] ntp-keygen -i option long name changed from
  misleading --issuer-name to --ident.
(4.2.7p216) 2011/09/27 Released by Harlan Stenn <stenn@ntp.org>
* sntp documentation tag cleanup.
* mdoc2man improvements.
(4.2.7p215) 2011/09/24 Released by Harlan Stenn <stenn@ntp.org>
* Use patched mdoc2man script, from Eric Feng.
* Sync with ntp-4.2.6p4 (a no-op).
(4.2.7p214) 2011/09/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1981] Initial offset convergence applies frequency correction 2x
  with kernel discipline.
* [Bug 2008] Initial offset convergence degraded with 500 PPM adjtime().
* [Bug 2009] EVNT_NSET adj_systime() mishandled by Windows ntpd.
(4.2.7p213) 2011/09/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1999] NMEA does not send PMOTG messages any more.
(4.2.7p212) 2011/09/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2003] from 4.2.6p4-RC3: ntpq_read_assoc_peervars() broken.
(4.2.7p211) 2011/09/01 Released by Harlan Stenn <stenn@ntp.org>
* Update libevent to git head (2.1 branch) as of 2.0.14-stable.
(4.2.7p210) 2011/08/31 Released by Harlan Stenn <stenn@ntp.org>
* Require -D4 or higher for ntpd SIGALRM debug trace from [Bug 2000].
(4.2.7p209) 2011/08/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2000] ntpd worker threads must block signals expected in main
  thread.
* [Bug 2001] add ntpq -c timerstats like ntpdc -c timerstats.
* [Bug 2001] from 4.2.6p4-RC3: ntpdc timerstats reports overruns as
  handled.
* Update sntp tests to track the change of root dispersion to
  synchronization distance.
(4.2.7p208) 2011/08/24 Released by Harlan Stenn <stenn@ntp.org>
* Fix the CLOCK_MONOTONIC TRACE() message.
(4.2.7p207) 2011/08/22 Released by Harlan Stenn <stenn@ntp.org>
* Restore the original CLOCK_MONOTONIC output format in sntp.
* Cleanups for ntp-wait-opts.def and ntp.keys.def .
(4.2.7p206) 2011/08/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1993] ntpd Windows port adj_systime() broken in 4.2.7p203.
* sntp documentation and behavior improvements suggested by
  Steven Sommars.
* Have sntp report synchronization distance instead of root dispersion.
* Clean up ntp-wait-opts.def .
(4.2.7p205) 2011/08/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1992] util/tg2 doesn't compile, needs libntp.
(4.2.7p204) 2011/08/16 Released by Harlan Stenn <stenn@ntp.org>
* Added support for Garmin's $PGRMF sentence to NMEA driver
* [Bug 1988] Better sntp send failed error message needed.
* [Bug 1989] sntp manual page sometimes refers to SNTP as a program.
* [Bug 1990] sntp output should include stratum.
(4.2.7p203) 2011/08/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1986] Require Visual C++ 2005 or later compilers in Windows port.
* Actually use long long for (u_)int64 by correcting spelling of
  SIZEOF_LONG_LONG in ntp_types.h.
* Force .exe minimum Windows version to 0x0400 to allow NT4 in
  vs2005/*.vcproj files.
* Fix make distcheck with --enable-libevent-regress problem with
  unwritable $srcdir.
* Correct init_logging()'s def_syslogmask type to u_int32 following
  change of ntp_syslogmask from u_long to u_int32 in p202.
(4.2.7p202) 2011/08/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1983] --without-sntp build breaks in sntp subdir.
* [Bug 1984] from 4.2.6p4-RC3: ntp/libisc fails to compile on OS X 10.7.
* [Bug 1985] from 4.2.6p4-RC3: "logconfig =allall" rejected.
(4.2.7p201) 2011/08/05 Released by Harlan Stenn <stenn@ntp.org>
* sntp: change -h/--headspace to -g/--gap, and change the default gap
  from 10 to 50ms
* [Backward Incompatible] from 4.2.6p4: sntp: -l/--filelog ->
  -l/--logfile, to be consistent with ntpd.
* Documentation updates from Dave Mills.
* From 4.2.6p4: libopts/file.c fix from Bruce Korb (arg-type=file).
(4.2.7p200) 2011/08/04 Released by Harlan Stenn <stenn@ntp.org>
* Sync with 4.2.6p4-RC2.
(4.2.7p199) 2011/07/29 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p198) 2011/07/28 Released by Harlan Stenn <stenn@ntp.org>
* remove old binsubdir stuff from SNTP, as NTP_LOCINFO does that now.
(4.2.7p197) 2011/07/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1975] from 4.2.6p4-RC2: libntp/mktime.c won't work with 64-bit
  time_t
* [Bug 1976] genLocInfo writes to srcdir break 'make distcheck'.
* [Bug 1977] Fix flag/description mismatches in ntp-keygen-opts.def.
* Do not force "legacy" when --with-locfile is not given, genLocInfo
  will find the correct default for the system.
* Fix warnings in ntp_request.c ([Bug 1973] oversight) and sntp/main.c
  (CID 159, apparent overrun due to union, actually correct).
* Update sntp/loc/solaris to conform to stock locations.
(4.2.7p196) 2011/07/27 Released by Harlan Stenn <stenn@ntp.org>
* DEFAULT INSTALLATION DIRECTORY CHANGES ON SOME OSes: to get the old
  behavior, pass --with-locfile=legacy to 'configure'
* [Bug 1972] from 4.2.6p4-RC2: checking for struct rtattr fails.
* [Bug 1973] Widen reference clock mode from 8 to 32 bits.
* Removed sntp/m4/ntp_bindir.m4 - no longer needed.
* Move loc/ to sntp/loc/ .
* Move scripts/cvo.sh to sntp/scripts/cvo.sh .
* Move scripts/genLocInfo to sntp/scripts/genLocInfo .
* Give NTP_LOCINFO an optional path-to argument.
* Remove hacks to get NTP_LOCINFO-related data to sntp/ .
* Move sntp/include/mansec2subst.sed to sntp/scripts/mansec2subst.sed .
* If no "more specific" loc file is found for redhat* or fedora*,
  look for a loc/redhat file.
* If no "more specific" loc file is found and uname says this is Linux,
  look for a loc/linux file.
* Improve the help text: --with-locfile=XXX .
* work around solaris /bin/sh issues for genLocInfo.
(4.2.7p195) 2011/07/25 Released by Harlan Stenn <stenn@ntp.org>
* Added loc/redhat.
(4.2.7p194) 2011/07/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1608] from 4.2.6p4-RC2: Parse Refclock driver should honor
  trusttime.
* Add support for installing programs and scripts to libexec.
* Added loc/solaris.
(4.2.7p193) 2011/07/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1970] from 4.2.6p4-RC2: UNLINK_EXPR_SLIST() causes crash if list
  is empty.
* Update libevent to 2.1 HEAD as of merge of 2.0.13-stable-dev.
* Match addr_eqprefix() sizeof and memcpy destination to make it clear
  to static analysis that there is no buffer overrun (CID 402).
(4.2.7p192) 2011/07/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1966] Broken FILES section for ntp.keys.def.
(4.2.7p191) 2011/07/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1948] Update man page section layout.
* [Bug 1963] add reset command for ntpq :config, similar to ntpdc's.
* [Bug 1964] --without-sntp should not build sntp.
(4.2.7p190) 2011/07/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1961] from 4.2.6p4: html2man update: distribute ntp-wait.html.
* Require autogen-5.12.
(4.2.7p189) 2011/07/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1134] from 4.2.6p4-RC1: ntpd fails binding to tentative IPv6
  addresses.
* [Bug 1790] from 4.2.6p4-RC1: Update config.guess and config.sub to
  detect AIX6.
(4.2.7p188) 2011/06/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1958] genLocInfo must export PATH.
* ntp-wait: some versions of ntpd spell "associd" differently.
(4.2.7p187) 2011/06/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1954] Fix typos in [s]bin_PROGRAMS in ntpd/Makefile.am.
* Implement --with-locfile=filename configure argument.  If filename is
  empty we'll look under loc/ for a good fit.  If the filename contains
  a / character, it will be treated as a "normal" pathname.  Otherwise,
  that explicit file will be searched for under loc/ .
(4.2.7p186) 2011/06/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1950] Control installation of event_rpcgen.py.
* Update .point-changed-filelist for the new man pages.
* Update the building of OS-specific programs.
* Finish conversion to genLocInfo.
* validate MANTAGFMT in genLocInfo.
* Documentation update from Dave Mills.
(4.2.7p185) 2011/06/21 Released by Harlan Stenn <stenn@ntp.org>
* ntp_locs.m4: handle the case where . is not in the PATH.
* More genLocInfo cleanup.
(4.2.7p184) 2011/06/20 Released by Harlan Stenn <stenn@ntp.org>
* Added ntp_locs.m4.
* genLocInfo improvements.
* Add the man page tag "flavor" to the loc.* files.
* Add/distribute genLocInfo.
(4.2.7p183) 2011/06/19 Released by Harlan Stenn <stenn@ntp.org>
* Update the autogen include list for scripts/Makefile.am.
* Added loc.freebsd (and distribute it).
* Added loc.legacy (and distribute it).
(4.2.7p182) 2011/06/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1304] Update sntp.html to reflect new implementation.
* Update .point-changed-filelist .
* ntpdc documentation fixes.
* Update ntp-wait autogen docs.
* Update the ntpd autogen docs.
* Update the ntpsnmpd autogen docs.
* Use autogen to produce ntp-keygen docs.
* Add "license name" to ntp.lic for autogen-5.11.10.
* Prepare for ntp.keys.5.
(4.2.7p181) 2011/06/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1938] addr_eqprefix() doesn't clear enough storage.
(4.2.7p180) 2011/06/06 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to libevent-2.0.12.
* More sntp.1 cleanups.
* Produce ntpq.1 with the new autogen macros.
* Remove the deprecated "detail" stanza from ntpdc-opts.def.
(4.2.7p179) 2011/06/03 Released by Harlan Stenn <stenn@ntp.org>
* Update cmd-doc.tlib to autogen-5.11.10pre5.
* Upgrade local autoopts templates to 5.11.10pre5.
(4.2.7p178) 2011/06/02 Released by Harlan Stenn <stenn@ntp.org>
* Update the std_def_list to include the ntp.lic file.
* Distribute the ntp.lic file.
* Add http://ntp.org/license to the ntp.lic file.
(4.2.7p177) 2011/06/01 Released by Harlan Stenn <stenn@ntp.org>
* Use the latest autogen's new copyright template code.
* Clean up the ntp.lic file.
(4.2.7p176) 2011/05/31 Released by Harlan Stenn <stenn@ntp.org>
* sntp documentation cleanup.
* autogen documentation template cleanup.
(4.2.7p175) 2011/05/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1936] Correctly set IPV6_MULTICAST_LOOP.
* cmd-doc.tlib cleanup from Bruce Korb.
* sntp documentation cleanup.
(4.2.7p174) 2011/05/28 Released by Harlan Stenn <stenn@ntp.org>
* ntpdc documentation cleanup.
* sntp documentation cleanup.
* Don't build libevent with openssl support.  Right now, libevent
  doesn't use pkg-config to find openssl's installation location.
(4.2.7p173) 2011/05/25 Released by Harlan Stenn <stenn@ntp.org>
* Typo in emalloc.c hides file and line number from emalloc() error msg.
* parsesolaris.c compile fails on SPARC Solaris with conflicting printf.
* ntp_util.c compile fails on AIX and OSF with conflicting statsdir.
(4.2.7p172) 2011/05/24 Released by Harlan Stenn <stenn@ntp.org>
* Remove hardcoded 1/960 s. fudge for <CR> transmission time at 9600 8n1
  from WWVB/Spectracom driver introduced in 4.2.7p169.
(4.2.7p171) 2011/05/23 Released by Harlan Stenn <stenn@ntp.org>
* Eliminate warnings about shadowing global "basename" on Linux.
* Use filegen_config() consistently when changing filegen options.
* mprintf() should go to stdout, not stderr.  DPRINTF() uses mprintf().
* Repair a few simulator problems (more remain).
* Documentation updates from Dave Mills.
(4.2.7p170) 2011/05/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1932] libevent/util_internal.h builtin_expect compile error with
  gcc 2.95.
* Use 64-bit scalars in LFPTOD() and DTOLFP() on more platforms by
  conditionalizing on HAVE_U_INT64 rather than UINT64_MAX.
(4.2.7p169) 2011/05/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1933] WWVB/Spectracom driver timestamps LFs, not CRs.
(4.2.7p168) 2011/05/16 Released by Harlan Stenn <stenn@ntp.org>
* Convert receive buffer queue from doubly-linked list to FIFO.
(4.2.7p167) 2011/05/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1927] io_closeclock() should purge pending recvbufs.
* [Bug 1931] cv always includes fudgetime1, never fudgetime2.
* Use acts_close() in acts_shutdown() to avoid leaving a stale lockfile
  if unpeered via runtime configuration while the modem is open.
* Correct acts_close() test of pp->io.fd to see if it is open.
* 4.2.7p164 documentation updates re: 'tos orphanwait' expanded scope.
(4.2.7p166) 2011/05/13 Released by Harlan Stenn <stenn@ntp.org>
* If we have local overrides for autogen template files, use them.
* Convert more of the sntp-opt.def documentation from man to mdoc.
(4.2.7p165) 2011/05/11 Released by Harlan Stenn <stenn@ntp.org>
* Convert snmp docs to mdoc format, which requires autogen 5.11.9.
* from 4.2.6p4-RC1: Require autogen 5.11.9.
(4.2.7p164) 2011/05/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 988] Local clock eats up -g option, so ntpd stops with large
  initial time offset.
* [Bug 1921] LOCAL, ACTS drivers with "prefer" excluded from initial
  candidate list.
* [Bug 1922] "tos orphanwait" applied incorrectly at startup.
* [Bug 1923] orphan parent favored over LOCAL, ACTS drivers.
* [Bug 1924] Billboard tally codes sometimes do not match operation,
  variables.
* Change "pool DNS" messages from msyslog to debug trace output.
* Remove unused FLAG_SYSPEER from peer->status.
* Respect "tos orphanwait" at startup.  Previously there was an
  unconditional 300 s. startup orphanwait, though other values were
  respected for subsequent orphan wait periods after no_sys_peer events.
* Apply "tos orphanwait" (def. 300 seconds) to LOCAL and ACTS reference
  clock drivers, in addition to orphan parent operation.  LOCAL and ACTS
  are not selectable during the orphanwait delay at startup and after
  each no_sys_peer event.  This prevents a particular form of clock-
  hopping, such as using LOCAL briefly at startup before remote peers
  are selectable.  This fixes the issue reported in [Bug 988].
* Documentation updates from Dave Mills.
(4.2.7p163) 2011/05/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1911] missing curly brace in libntp/ntp_rfc2553.c
(4.2.7p162) 2011/05/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1910] Support the Tristate Ltd. TS-GPSclock-01.
(4.2.7p161) 2011/05/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1904] 4.2.7p160 Windows build broken (POSIX_SHELL).
* [Bug 1906] 4.2.7p160 - libtool: compile: cannot determine name of
  library object in ./libevent
* Share a single sntp/libevent/build-aux directory between all three
  configure scripts.
* Add missing --enable-local-libevent help to top-level configure.
(4.2.7p160) 2011/05/01 Released by Harlan Stenn <stenn@ntp.org>
* from 4.2.6p4-RC1: Upgrade to libopts 35.0.10 from AutoGen 5.11.9pre8.
* [Bug 1901] Simulator does not set progname.
(4.2.7p159) 2011/04/28 Released by Harlan Stenn <stenn@ntp.org>
* Fix a couple of unused variable warnings.
* cleanup in timespecops.c / timevalops.c
(4.2.7p158) 2011/04/24 Released by Harlan Stenn <stenn@ntp.org>
* Update libevent --disable-libevent-regress handling to work when
  building libevent using mingw.
(4.2.7p157) 2011/04/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1890] 4.2.7p156 segfault in duplicate freeaddrinfo().
(4.2.7p156) 2011/04/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1851] freeaddrinfo() called after getaddrinfo() fails.
(4.2.7p155) 2011/04/18 Released by Harlan Stenn <stenn@ntp.org>
* Fix leak in refclock_datum.c start failure path.
(4.2.7p154) 2011/04/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1887] DNS fails on 4.2.7p153 using threads.
(4.2.7p153) 2011/04/16 Released by Harlan Stenn <stenn@ntp.org>
* A few more Coverity Scan cleanups.
(4.2.7p152) 2011/04/15 Released by Harlan Stenn <stenn@ntp.org>
* Update embedded libevent to current 2.1 git HEAD.
(4.2.7p151) 2011/04/14 Released by Harlan Stenn <stenn@ntp.org>
* Detect vsnprintf() support for "%m" and disable our "%m" expansion.
* Add --enable-c99-sprintf to configure args for -noopenssl variety of
  flock-build to avoid regressions in (v)snprintf() replacement.
* More msnprintf() unit tests.
* Coverity Scan error checking fixes.
* Log failure to fetch time from HOPF_P hardware.
* Check HOPF_S sscanf() conversion count before converted values.
(4.2.7p150) 2011/04/13 Released by Harlan Stenn <stenn@ntp.org>
* Remove never-used, incomplete ports/winnt/ntpd/refclock_trimbledc.[ch]
* On systems without C99-compliant (v)snprintf(), use C99-snprintf
  replacements (http://www.jhweiss.de/software/snprintf.html)
* Remove remaining sprintf() calls except refclock_ripencc.c (which is
  kept out of --enable-all-clocks as a result), upstream libs which use
  sprintf() only after careful buffer sizing.
(4.2.7p149) 2011/04/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1881] describe the {+,-,s} characters in configure --help output.
(4.2.7p148) 2011/04/09 Released by Harlan Stenn <stenn@ntp.org>
* Use _mkgmtime() as timegm() in the Windows port, rather than
  libntp/mktime.c's timegm().  Fixed [Bug 1875] on Windows using the old
  asn2ntp() code from before 4.2.7p147.
* ntp_crypto.c string buffer safety.
* Remove use of MAXFILENAME in mode 7 (ntpdc) on-wire structs.
* Change ntpd MAXFILENAME from 128 to 256 to match ntp-keygen.
* Buffer safety and sign extension fixes (thanks Coverity Scan).
(4.2.7p147) 2011/04/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1875] 'asn2ntp()' rewritten with 'caltontp()'; 'timegm()'
  substitute likely to crash with 64bit time_t.
(4.2.7p146) 2011/04/05 Released by Harlan Stenn <stenn@ntp.org>
* String buffer safety cleanup, converting to strlcpy() and strlcat().
* Use utmpname() before pututline() so repeated steps do not
  accidentally record into wtmp where utmp was intended.
* Use setutent() before each pututline() including first.
(4.2.7p145) 2011/04/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1840] ntp_lists.h FIFO macros buggy.
(4.2.7p144) 2011/04/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1874] ntpq -c "rv 0 sys_var_list" empty.
(4.2.7p143) 2011/03/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1732] ntpd ties up CPU on disconnected USB refclock.
* [Bug 1861] tickadj build failure using uClibc.
* [Bug 1862] in6addr_any test in configure fooled by arm gcc 4.1.3 -O2.
* Remove kernel line discipline driver code for clk and chu, deprecate
  related LDISC_ flags, and remove associated ntpd code to decode the
  timestamps, remove clktest line discipline test program.
* Remove "signal_no_reset: signal 17 had flags 4000000" logging, as it
  indicates no problem and is interpreted as an error.  Previously some
  bits had been ignored one-by-one, but Linux SA_RESTORER definition is
  unavailable to user headers.
(4.2.7p142) 2011/03/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1844] ntpd 4.2.7p131 NetBSD, --gc-sections links bad executable.
* Fix "make distcheck" break in libevent/sample caused by typo.
(4.2.7p141) 2011/03/20 Released by Harlan Stenn <stenn@ntp.org>
* Add "ntpq -c iostats" similar to "ntpdc -c iostats".
* Compare entire timestamp to reject duplicates in refclock_pps().
(4.2.7p140) 2011/03/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1848] ntpd 4.2.7p139 --disable-thread-support does not compile.
* Add --disable-thread-support to one flock-build variation.
* One more lock-while-init in lib/isc/task.c to quiet lock analysis.
(4.2.7p139) 2011/03/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1848] make check ntpd --saveconfigquit clutters syslog.
(4.2.7p138) 2011/03/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1846] MacOSX: debug symbol not found by propdelay or tickadj.
(4.2.7p137) 2011/03/07 Released by Harlan Stenn <stenn@ntp.org>
* Use TRACE() instead of DPRINTF() for libntp and utilities, which
  use the "debug" variable regardless of #ifdef DEBUG.
* Declare debug in libntp instead of each program.  Expose extern
  declaration to utilities, libntp, and DEBUG ntpd.
* Lock under-construction task, taskmgr objects to satisfy Coverity's
  mostly-correct assumptions about which variables are protected by
  which locks.
(4.2.7p136) 2011/03/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1839] 4.2.7p135 still installs libevent ev*.h headers.
(4.2.7p135) 2011/03/02 Released by Harlan Stenn <stenn@ntp.org>
* libevent: When building on systems with CLOCK_MONOTONIC available,
  separate the internal timeline (possibly counting since system boot)
  from the gettimeofday() timeline in event_base cached timevals.  Adds
  new event_base_tv_cached() to retrieve cached callback round start
  time on the internal timeline, and changes
  event_based_gettimeofday_cached() to always return times using the
  namesake timeline.  This preserves the benefit of using the never-
  stepped monotonic clock for event timeouts while providing clients
  with times consistently using gettimeofday().
* Correct event_base_gettimeofday_cached() workaround code in
  sntp to work with corrected libevent.
* Remove sntp l_fp_output() test now that it uses prettydate().
* [Bug 1839] 4.2.7p131 installs libevent ev*.h headers.
* Ensure CONFIG_SHELL is not empty before relying on it for #! scripts.
(4.2.7p134) 2011/02/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1837] Build fails on Win7 due to regedit requiring privilege.
* Provide fallback definitions for GetAdaptersAddresses() for Windows
  build environments lacking iphlpapi.h.
* Rename file containing 1.xxxx ChangeSet revision from version to
  scm-rev to avoid invoking GNU make implicit rules attempting to
  compile version.c into version.  Problem was with sntp/version.o
  during make distcheck after fix for spurious sntp rebuilds.
* Add INC_ALIGNED_PTR() macro to align pointers like malloc().
(4.2.7p133) 2011/02/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1834] ntpdate 4.2.7p131 aborts with assertion failure.
* Move sntp last in top-level Makefile.am SUBDIRS so that the libevent
  tearoff (if required) and sntp are compiled after the rest.
* Use a single set of Automake options for each package in configure.ac
  AM_INIT, remove Makefile.am AUTOMAKE_OPTIONS= lines.
* Correct spurious sntp rebuilds triggered by a make misperception
  sntp/version was out-of-date relative to phony target FRC.version.
* Do not cache paths to perl, test, or pkg-config, searching the PATH
  at configure time is worth it to pick up tool updates.
(4.2.7p132) 2011/02/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1832] ntpdate doesn't allow timeout > 2s.
* [Bug 1833] The checking sem_timedwait() fails without -pthread.
* ElectricFence was suffering bitrot - remove it.  valgrind works well.
* Enable all relevant automake warnings.
* Correct Solaris 2.1x PTHREAD_ONCE_INIT extra braces test to avoid
  triggering warnings due to excess braces.
* Remove libevent-cfg from sntp/Makefile.am.
* Provide bug report and URL options to Autoconf.
* Avoid relying on remake rules for routine build/flock-build for
  libevent as for the top-level and sntp subproject.
(4.2.7p131) 2011/02/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1087] -v/--normalverbose conflicts with -v/--version in sntp.
* [Bug 1088] sntp should (only) report the time difference without -s/-a.
* older autoconf sometimes dislikes [].
* Move "can't write KoD file" warning from sntp shutdown to startup.
* refclock_acts.c cleanup from Dave Mills.
* Convert sntp to libevent event-driven socket programming.  Instead of
  blocking name resolution and querying one NTP server at a time,
  resolve server names and send NTP queries without blocking.  Add
  sntp command-line options to adjust timing and optionally wait for all
  servers to respond instead of exiting after the first.
* Import libevent 2.0.10-stable plus local patches as a tearoff, used
  only if the target system lacks an installed libevent 2.0.9 or later.
* Move blocking worker and resolver to libntp from ntpd.
* Use threads rather than forked child processes for blocking worker
  when possible.  Override with configure --disable-thread-support.
* Move init_logging(), change_logfile(), and setup_logfile() from ntpd
  to libntp, use them in sntp.
* Test --without-sntp in flock-build script's -no-refclocks variety.
* Avoid invoking config.status twice in a row in build script.
* Move more m4sh tests needed by libntp to shared .m4 files.
* Split up ntp_libntp.m4 into smaller, more specific subsets.
* Enable gcc -Wcast-align, fix many instances of warnings when casting
  a pointer to a more-strictly-aligned underlying type.
(4.2.7p130) 2011/02/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1811] Update the download location in WHERE-TO-START.
(4.2.7p129) 2011/02/09 Released by Harlan Stenn <stenn@ntp.org>
* Add missing "break;" to ntp_control.c ctl_putsys() for caliberrs, used
  by ntpq -c kerninfo introduced in 4.2.7p104.
* Fix leak in ntp_control.c read_mru_list().
(4.2.7p128) 2011/01/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1799] ntpq mrv crash.
* [Bug 1801] ntpq mreadvar requires prior association caching.
(4.2.7p127) 2011/01/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1797] Restore stale timestamp check from the RANGEGATE cleanup.
(4.2.7p126) 2011/01/27 Released by Harlan Stenn <stenn@ntp.org>
* Fix unexposed fencepost error in format_time_fraction().
* Add more unit tests for timeval_tostr() and timespec_tostr().
(4.2.7p125) 2011/01/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1794] ntpq -c rv missing clk_wander information.
* [Bug 1795] ntpq readvar does not display last variable.
(4.2.7p124) 2011/01/25 Released by Harlan Stenn <stenn@ntp.org>
* sntp/Makefile.am needs any passed-in CFLAGS.
(4.2.7p123) 2011/01/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1788] tvtots.c tables inaccurate
(4.2.7p122) 2011/01/22 Released by Harlan Stenn <stenn@ntp.org>
* ACTS refclock cleanup from Dave Mills.
* Avoid shadowing the "group" global variable.
(4.2.7p121) 2011/01/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1786] Remove extra semicolon from ntp_proto.c .
(4.2.7p120) 2011/01/20 Released by Harlan Stenn <stenn@ntp.org>
* Change new timeval and timespec to string routines to use snprintf()
  rather than hand-crafted conversion, avoid signed int overflow there.
* Add configure support for SIZEOF_LONG_LONG to enable portable use of
  snprintf() with time_t.
* Grow ntpd/work_thread.c arrays as needed.
* Add DEBUG_* variants of ntp_assert.h macros which compile away using
  ./configure --disable-debugging.
* Fix tvalops.cpp unit test failures for 32-bit builds.
* Return to a single autoreconf invocation in ./bootstrap script.
* Fix warnings seen on FreeBSD 9.
* crypto group changes from Dave Mills.
* Lose the RANGEGATE check in PPS, from Dave Mills.
* ACTS refclock cleanup from Dave Mills.
* Documentation updates from Dave Mills.
* NMEA driver documentation update from Juergen Perlinger.
(4.2.7p119) 2011/01/18 Released by Harlan Stenn <stenn@ntp.org>
* added timespecops.{c,h} and tievalops.{c.h} to libntp and include
  added tspecops.cpp to tests/libntp
* Correct msyslog.c build break on Solaris 2.9 from #ifdef/#if mixup.
(4.2.7p118) 2011/01/15 Released by Harlan Stenn <stenn@ntp.org>
* Simplify the built-sources stuff in sntp/ .
* Fix check for -lipv6 on HP-UX 11.
(4.2.7p117) 2011/01/13 Released by Harlan Stenn <stenn@ntp.org>
* Add configure --without-sntp option to disable building sntp and
  sntp/tests.  withsntp=no in the environment changes the default.
* Build infrastructure cleanup:
  Move m4 directory to sntp/m4.
  Share a single set of genver output between sntp and the top level.
  Share a single set of autogen included .defs in sntp/include.
  Share a single set of build-aux scripts (e.g. config.guess, missing).
  Add ntp_libntp.m4 and ntp_ipv6.m4 to reduce configure.ac duplication.
  Warn and exit build/flock-build if bootstrap needs to be run.
(4.2.7p116) 2011/01/10 Released by Harlan Stenn <stenn@ntp.org>
* refclock_nmea.c refactoring by Juergen Perlinger.
(4.2.7p115) 2011/01/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1780] Windows ntpd 4.2.7p114 crashes in ioctl().
* [Bug 1781] longlong undefined in sntp handle_pkt() on Debian amd64.
(4.2.7p114) 2011/01/08 Released by Harlan Stenn <stenn@ntp.org>
* Fix for openssl pkg-config detection eval failure.
* Add erealloc_zero(), refactor estrdup(), emalloc(), emalloc_zero() to
  separate tracking callsite file/line from using debug MS C runtime,
  and to reduce code duplication.
(4.2.7p113) 2011/01/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1776] sntp mishandles -t/--timeout and -a/--authentication.
* Default to silent make rules, override with make V=1 or ./configure
  --disable-silent-rules.
* Correct --with-openssl-incdir defaulting with pkg-config.
* Correct ./build on systems without gtest available.
* Begin moving some of the low-level socket stuff to libntp.
(4.2.7p112) 2011/01/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1773] openssl not detected during ./configure.
* [Bug 1774] Segfaults if cryptostats enabled and built without OpenSSL.
* Use make V=0 in build script to increase signal/noise ratio.
(4.2.7p111) 2011/01/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1772] refclock_open() return value check wrong for ACTS.
* Default --with-openssl-libdir and --with-openssl-incdir to the values
  from pkg-config, falling back on our usual search paths if pkg-config
  is not available or does not have openssl.pc on PKG_CONFIG_PATH.
* Change refclock_open() to return -1 on failure like open().
* Update all refclock_open() callers to check for fd <= 0 indicating
  failure, so they work with older and newer refclock_open() and can
  easily backport.
* Initialize refclockproc.rio.fd to -1, harmonize refclock shutdown
  entrypoints to avoid crashing, particularly if refclock_open() fails.
* Enable tickadj-like taming of wildly off-spec Windows clock using
  NTPD_TICKADJ_PPM env. var. specifying baseline slew.
(4.2.7p110) 2011/01/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1771] algorithmic error in 'clocktime()' fixed.
* Unit tests extended for hard-coded system time.
* make V=0 and configure --enable-silent-rules supported.
* setvar modemsetup = ATE0... overrides ACTS driver default.
* Preserve last timecode in ACTS driver (ntpq -ccv).
* Tolerate previous ATE1 state when sending ACTS setup.
* Enable raw tty line discipline in Windows port.
* Allow tty open/close/open to succeed on Windows port.
* Enable ACTS and CHU reference clock drivers on Windows.
(4.2.7p109) 2011/01/02 Released by Harlan Stenn <stenn@ntp.org>
* Remove nearly all strcpy() and most strcat() from NTP distribution.
  One major pocket remains in ntp_crypto.c.  libopts & libisc also have
  (safe) uses of strcpy() and strcat() remaining.
* Documentation updates from Dave Mills.
(4.2.7p108) 2011/01/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1764] Move Palisade modem control logic to configure.ac.
* [Bug 1768] TIOCFLUSH undefined in linux for refclock_acts.
* Autokey multiple identity group improvements from Dave Mills.
* from 4.2.6p3: Update the copyright year.
(4.2.7p107) 2010/12/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1764] Palisade driver doesn't build on Linux.
* [Bug 1766] Oncore clock has offset/high jitter at startup.
* Move ntp_control.h variable IDs to ntp_control.c, remove their use by
  ntpq.  They are implementation details private to ntpd.  [Bug 597] was
  caused by ntpq's reliance on these IDs it need not know about.
* refclock_acts.c updates from Dave Mills.
(4.2.7p106) 2010/12/30 Released by Harlan Stenn <stenn@ntp.org>
* from 4.2.6p3: Update genCommitLog for the bk-5 release.
(4.2.7p105) 2010/12/29 Released by Harlan Stenn <stenn@ntp.org>
(4.2.7p104) 2010/12/28 Released by Harlan Stenn <stenn@ntp.org>
* from 4.2.6p3: Create and use scripts/check--help when generating
  .texi files.
* from 4.2.6p3: Update bk triggers for the bk-5 release.
* Support for multiple Autokey identity groups from Dave Mills.
* Documentation updates from Dave Mills.
* Add ntpq kerninfo, authinfo, and sysinfo commands similar to ntpdc's.
(4.2.7p103) 2010/12/24 Released by Harlan Stenn <stenn@ntp.org>
* Add ntpq pstats command similar to ntpdc's.
* Remove ntpq pstatus command, rv/readvar does the same and more.
* Documentation updates from Dave Mills.
(4.2.7p102) 2010/12/23 Released by Harlan Stenn <stenn@ntp.org>
* Allow ntpq &1 associd use without preceding association-fetching.
* Documentation updates from Dave Mills.
(4.2.7p101) 2010/12/22 Released by Harlan Stenn <stenn@ntp.org>
* from 4.2.6p3-RC12: Upgrade to libopts 34.0.9 from AutoGen 5.11.6pre7.
* from 4.2.6p3-RC12: Relax minimum Automake version to 1.10 with updated
  libopts.m4.
(4.2.7p100) 2010/12/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1743] from 4.2.6p3-RC12: Display timezone offset when showing
  time for sntp in the local timezone (documentation updates).
(4.2.7p99) 2010/12/21 Released by Harlan Stenn <stenn@ntp.org>
* Add unit tests for msnprintf().
(4.2.7p98) 2010/12/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1761] clockstuff/clktest-opts.h omitted from tarball.
* [Bug 1762] from 4.2.6p3-RC12: manycastclient responses interfere.
* Documentation updates from Dave Mills.
(4.2.7p97) 2010/12/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1458] from 4.2.6p3-RC12: Can not compile NTP on FreeBSD 4.7.
* [Bug 1760] from 4.2.6p3-RC12: ntpd Windows interpolation cannot be
  disabled.
* from 4.2.6p3-RC12: Upgrade to libopts 34.0.9 from AutoGen 5.11.6pre5.
* Documentation updates from Dave Mills.
(4.2.7p96) 2010/12/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1758] from 4.2.6p3-RC12: setsockopt IPV6_MULTICAST_IF with wrong
  ifindex.
* Documentation updates from Dave Mills.
(4.2.7p95) 2010/12/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1753] 4.2.7p94 faults on startup in newpeer(), strdup(NULL).
* [Bug 1754] from 4.2.6p3-RC12: --version output should be more verbose.
* [Bug 1757] from 4.2.6p3-RC12: oncore snprintf("%m") doesn't expand %m.
* from 4.2.6p3-RC12: Suppress ntp-keygen OpenSSL version display for
  --help, --version, display both build and runtime OpenSSL versions
  when they differ.
* from 4.2.6p3-RC12: Upgrade to libopts 33.5.8 from AutoGen 5.11.6pre3.
* Documentation updates from Dave Mills.
(4.2.7p94) 2010/12/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1751] from 4.2.6p3-RC12: Support for Atari FreeMiNT OS.
* Documentation updates from Dave Mills.
(4.2.7p93) 2010/12/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1510] from 4.2.6p3-RC12: Add modes 20/21 for driver 8 to support
  RAWDCF @ 75 baud.
* [Bug 1741] from 4.2.6p3-RC12: Enable multicast reception on each
  address (Windows).
* from 4.2.6p3-RC12: Other manycastclient repairs:
  Separate handling of scope ID embedded in many in6_addr from ifindex
  used for IPv6 multicasting ioctls.
  Add INT_PRIVACY endpt bit flag for IPv6 RFC 4941 privacy addresses.
  Enable outbound multicast from only one address per interface in the
  same subnet, and in that case prefer embedded MAC address modified
  EUI-64 IPv6 addresses first, then static, and last RFC 4941 privacy
  addresses.
  Use setsockopt(IP[V6]_MULTICAST_IF) before each send to multicast to
  select the local source address, using the correct socket is not
  enough.
* "server ... ident <groupname>" changes from Dave Mills.
* Documentation updates from Dave Mills.
(4.2.7p92) 2010/12/08 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1743] from 4.2.6p3-RC12: Display timezone offset when showing
  time for sntp in the local timezone.
(4.2.7p91) 2010/12/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1732] ntpd ties up CPU on disconnected USB device.
* [Bug 1742] form 4.2.6p3-RC12: Fix a typo in an error message in the
  "build" script.
(4.2.7p90) 2010/12/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1738] Windows ntpd has wrong net adapter name.
* [Bug 1740] ntpdc -c reslist packet count wrongly treated as signed.
(4.2.7p89) 2010/12/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1736] tos int, bool options broken in 4.2.7p66.
* from 4.2.6p3-RC12: Clean up the SNTP documentation.
(4.2.7p88) 2010/12/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1735] 'clocktime()' aborts ntpd on bogus input
(4.2.7p87) 2010/12/01 Released by Harlan Stenn <stenn@ntp.org>
* from 4.2.6p3-RC12: Clean up m4 quoting in configure.ac, *.m4 files,
  resolving intermittent AC_LANG_PROGRAM possibly undefined errors.
(4.2.7p86) 2010/11/29 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p85) 2010/11/24 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p84) 2010/11/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1618] Unreachable code in jjy_start().
* [Bug 1725] from 4.2.6p3-RC11: ntpd sends multicast from only one
  address.
* from 4.2.6p3-RC11: Upgrade libopts to 33.3.8.
* from 4.2.6p3-RC11: Bump minimum Automake version to 1.11, required for
  AM_COND_IF use in LIBOPTS_CHECK.
* An almost complete rebuild of the initial loopfilter configuration
  process, including the code that determines the interval between
  frequency file updates, from Dave Mills.
* Documentation updates from Dave Mills.
* Add ntp-keygen -l/--lifetime to control certificate expiry.
* JJY driver improvements for Tristate JJY01/02, including changes
  to its clockstats format.
* Add "nonvolatile" ntp.conf directive to control how often the
  driftfile is written.
(4.2.7p83) 2010/11/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1727] ntp-keygen PLEN, ILEN undeclared --without-crypto.
* Remove top-level libopts, use sntp/libopts.
* from 4.2.6p3-RC11: Remove log_msg() and debug_msg() from sntp in favor
  of msyslog().
* Documentation updates from Dave Mills.
(4.2.7p82) 2010/11/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1728] from 4.2.6p3-RC11: In ntp_openssl.m4, don't add
  -I/usr/include or -L/usr/lib to CPPFLAGS or LDFLAGS.
(4.2.7p81) 2010/11/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1681] from 4.2.6p3-RC10: More sntp logging cleanup.
* [Bug 1683] from 4.2.6p3-RC10: Non-localhost on loopback exempted from
  nic rules.
* [Bug 1719] Cleanup for ntp-keygen and fix -V crash, from Dave Mills.
(4.2.7p80) 2010/11/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1574] from 4.2.6p3-RC9: sntp doesn't set tv_usec correctly.
* [Bug 1681] from 4.2.6p3-RC9: sntp logging cleanup.
* [Bug 1683] from 4.2.6p3-RC9: Interface binding does not seem to work
  as intended.
* [Bug 1708] make check fails with googletest 1.4.0.
* [Bug 1709] from 4.2.6p3-RC9: ntpdate ignores replies with equal
  receive and transmit timestamps.
* [Bug 1715] sntp utilitiesTest.IPv6Address failed.
* [Bug 1718] Improve gtest checks in configure.ac.
(4.2.7p79) 2010/11/07 Released by Harlan Stenn <stenn@ntp.org>
* Correct frequency estimate with no drift file, from David Mills.
(4.2.7p78) 2010/11/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1697] filegen implementation should be improved.
* Refactor calendar functions in terms of new common code.
* Documentation updates from Dave Mills.
(4.2.7p77) 2010/11/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1692] packageinfo.sh needs to be "sourced" using ./ .
* [Bug 1695] ntpdate takes longer than necessary.
(4.2.7p76) 2010/11/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1690] Unit tests fails to build on some systems.
* [Bug 1691] Use first NMEA sentence each second.
* Put the sntp tests under sntp/ .
* ... and only build/run them if we have gtest.
* Documentation updates from Dave Mills.
(4.2.7p75) 2010/10/30 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* Include Linus Karlsson's GSoC 2010 testing code.
(4.2.7p74) 2010/10/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1685] from 4.2.6p3-RC8: NMEA driver mode byte confusion.
* from 4.2.6p3-RC8: First cut at using scripts/checkChangeLog.
* Documentation updates from Dave Mills.
(4.2.7p73) 2010/10/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1680] Fix alignment of clock_select() arrays.
* refinements to new startup behavior from David Mills.
* For the bootstrap script, touch .html files last.
* Add 'make check' test case that would have caught [Bug 1678].
(4.2.7p72) 2010/10/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1679] Fix test for -lsocket.
* Clean up missing ;; entries in configure.ac.
(4.2.7p71) 2010/10/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1676] from 4.2.6p3-RC7: NMEA: $GPGLL did not work after fix
  for Bug 1571.
* [Bug 1678] "restrict source" treated as "restrict default".
* from 4.2.6p3-RC7: Added scripts/checkChangeLog.
(4.2.7p70) 2010/10/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1571] from 4.2.6p3-RC6: NMEA does not relate data to PPS edge.
* [Bug 1572] from 4.2.p63-RC6: NMEA time adjustment for GPZDG buggy.
* [Bug 1675] from 4.2.6p3-RC6: Prohibit includefile remote config.
* Enable generating ntpd/ntp_keyword.h after keyword-gen.c changes on
  Windows as well as POSIX platforms.
* Fix from Dave Mills for a rare singularity in clock_combine().
(4.2.7p69) 2010/10/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1671] Automatic delay calibration is sometimes inaccurate.
(4.2.7p68) 2010/10/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1669] from 4.2.6p3-RC5: NTP fails to compile on IBM AIX 5.3.
* [Bug 1670] Fix peer->bias and broadcastdelay.
* Documentation updates from Dave Mills.
* Documentation EOL cleanup.
(4.2.7p67) 2010/10/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1649] from 4.2.6p3-RC5: Require NMEA checksum if $GPRMC or
  previously seen.
(4.2.7p66) 2010/10/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1277] Provide and use O(1) FIFOs, esp. in the config tree code.
* Remove unused 'bias' configuration keyword.
(4.2.7p65) 2010/10/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1584] from 4.2.6p3-RC4: wrong SNMP type for precision,
  resolution.
* Remove 'calldelay' and 'sign' remnants from parser, ntp_config.c.
(4.2.7p64) 2010/10/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1584] from 4.2.6p3-RC3: ntpsnmpd OID must be mib-2.197.
* [Bug 1659] from 4.2.6p3-RC4: Need CLOCK_TRUETIME not CLOCK_TRUE.
* [Bug 1663] ntpdsim should not open net sockets.
* [Bug 1665] from 4.2.6p3-RC4: is_anycast() u_int32_t should be u_int32.
* from 4.2.6p3: ntpsnmpd, libntpq warning cleanup.
* Remove 'calldelay' and 'sign' keywords (Dave Mills).
* Documentation updates from Dave Mills.
(4.2.7p63) 2010/10/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1080] from 4.2.6p3-RC3: ntpd on ipv6 routers very chatty.
* Documentation nit cleanup.
* Documentation updates from Dave Mills.
(4.2.7p62) 2010/10/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 750] from 4.2.6p3-RC3: Non-existing device causes coredump with
  RIPE-NCC driver.
* [Bug 1567] from 4.2.6p3-RC3: Support Arbiter 1093C Satellite Clock on
  Windows.
* [Bug 1581] from 4.2.6p3-RC3: printf format string mismatch leftover.
* [Bug 1659] from 4.2.6p3-RC3: Support Truetime Satellite Clocks on
  Windows.
* [Bug 1660] from 4.2.6p3-RC3: On some systems, test is in /usr/bin, not
  /bin.
* [Bug 1661] from 4.2.6p3-RC3: Re-indent refclock_ripencc.c.
* Lose peer_count from ntp_peer.c and ntp_proto.c (Dave Mills).
* Documentation updates from Dave Mills.
(4.2.7p61) 2010/10/06 Released by Harlan Stenn <stenn@ntp.org>
* Documentation and code cleanup from Dave Mills. No more NTP_MAXASSOC.
(4.2.7p60) 2010/10/04 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p59) 2010/10/02 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* Variable name cleanup from Dave Mills.
* [Bug 1657] darwin needs res_9_init, not res_init.
(4.2.7p58) 2010/09/30 Released by Harlan Stenn <stenn@ntp.org>
* Clock select bugfix from Dave Mills.
* [Bug 1554] peer may stay selected as system peer after becoming
  unreachable.
* [Bug 1644] from 4.2.6p3-RC3: cvo.sh should use lsb_release to identify
  linux distros.
* [Bug 1646] ntpd crashes with relative path to logfile.
(4.2.7p57) 2010/09/27 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p56) 2010/09/25 Released by Harlan Stenn <stenn@ntp.org>
* Clock combining algorithm improvements from Dave Mills.
* Documentation updates from Dave Mills.
* [Bug 1642] ntpdsim can't find simulate block in config file.
* [Bug 1643] from 4.2.6p3-RC3: Range-check the decoding of the RIPE-NCC
  status codes.
(4.2.7p55) 2010/09/22 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* [Bug 1636] from 4.2.6p3-RC2: segfault after denied remote config.
(4.2.7p54) 2010/09/21 Released by Harlan Stenn <stenn@ntp.org>
* More Initial convergence improvements from Dave Mills.
* Documentation updates from Dave Mills.
* [Bug 1635] from 4.2.6p3-RC2: "filegen ... enable" is not default.
(4.2.7p53) 2010/09/20 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* More Initial convergence improvements from Dave Mills.
(4.2.7p52) 2010/09/19 Released by Harlan Stenn <stenn@ntp.org>
* Initial convergence improvements from Dave Mills.
(4.2.7p51) 2010/09/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1344] from 4.2.6p3-RC1: ntpd on Windows exits without logging
  cause.
* [Bug 1629] 4.2.7p50 configure.ac changes invalidate config.cache.
* [Bug 1630] 4.2.7p50 cannot bootstrap on Autoconf 2.61.
(4.2.7p50) 2010/09/16 Released by Harlan Stenn <stenn@ntp.org>
* Cleanup NTP_LIB_M.
* [Bug 1628] Clean up -lxnet/-lsocket usage for (open)solaris.
(4.2.7p49) 2010/09/13 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p48) 2010/09/12 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.7p47) 2010/09/11 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* [Bug 1588] finish configure --disable-autokey implementation.
* [Bug 1616] refclock_acts.c: if (pp->leap == 2) is always false.
* [Bug 1620] [Backward Incompatible] "discard minimum" value should be in
  seconds, not log2 seconds.
(4.2.7p46) 2010/09/10 Released by Harlan Stenn <stenn@ntp.org>
* Use AC_SEARCH_LIBS instead of AC_CHECK_LIB for NTP_LIB_M.
(4.2.7p45) 2010/09/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1578] Consistently use -lm when needed.
(4.2.7p44) 2010/08/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1573] from 4.2.6p3-beta1: Miscalculation of offset in sntp.
(4.2.7p43) 2010/08/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1602] Refactor some of the sntp/ directory to facililtate testing.
(4.2.7p42) 2010/08/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1593] ntpd abort in free() with logconfig syntax error.
* [Bug 1595] from 4.2.6p3-beta1: empty last line in key file causes
  duplicate key to be added
* [Bug 1597] from 4.2.6p3-beta1: packet processing ignores RATE KoD packets,
  Because of a bug in string comparison.
(4.2.7p41) 2010/07/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1581] from 4.2.6p3-beta1: ntp_intres.c size_t printf format
  string mismatch.
* [Bug 1586] ntpd 4.2.7p40 doesn't write to syslog after fork on QNX.
* Avoid race with parallel builds using same source directory in
  scripts/genver by using build directory for temporary files.
* orphanwait documentation updates.
(4.2.7p40) 2010/07/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1395] ease ntpdate elimination with ntpd -w/--wait-sync
* [Bug 1396] allow servers on ntpd command line like ntpdate
(4.2.7p39) 2010/07/09 Released by Harlan Stenn <stenn@ntp.org>
* Fix typo in driver28.html.
* [Bug 1581] from 4.2.6p2: size_t printf format string mismatches, IRIG
  string buffers undersized.  Mostly backported from earlier ntp-dev
  fixes by Juergen Perlinger.
(4.2.7p38) 2010/06/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1570] backported to 4.2.6p2-RC7.
* [Bug 1575] from 4.2.6p2-RC7: use 'snprintf' with LIB_BUFLENGTH in
  inttoa.c, tvtoa.c and utvtoa.c
* [Bug 1576] backported to 4.2.6p2-RC7.
* Typo fix in a comment in ntp_proto.c.
(4.2.7p37) 2010/06/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1576] sys/sysctl.h depends on sys/param.h on OpenBSD.
(4.2.7p36) 2010/06/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1560] Initial support for orphanwait, from Dave Mills.
* clock_filter()/reachability fixes from Dave Mills.
(4.2.7p35) 2010/06/12 Released by Harlan Stenn <stenn@ntp.org>
* Rewrite of multiprecision macros in 'ntp_fp.h' from J. Perlinger
  <perlinger@ntp.org>
* [Bug 715] from 4.2.6p2-RC6: libisc Linux IPv6 interface iteration
  drops multicast flags.
(4.2.7p34) 2010/06/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1570] serial clock drivers get outdated input from kernel tty
  line buffer after startup
(4.2.7p33) 2010/06/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1561] from 4.2.6p2-RC5: ntpq, ntpdc "passwd" prompts for MD5
  password w/SHA1.
* [Bug 1565] from 4.2.6p2-RC5: sntp/crypto.c compile fails on MacOS over
  vsnprintf().
* from 4.2.6p2-RC5: Windows port: do not exit in
  ntp_timestamp_from_counter() without first logging the reason.
(4.2.7p32) 2010/05/19 Released by Harlan Stenn <stenn@ntp.org>
* Copyright file cleanup from Dave Mills.
* [Bug 1555] from 4.2.6p2-RC4: sntp illegal C (mixed code and
  declarations).
* [Bug 1558] pool prototype associations have 0.0.0.0 for remote addr.
* configure.ac: add --disable-autokey, #define AUTOKEY to enable future
  support for building without Autokey, but with OpenSSL for its digest
  algorithms (hash functions).  Code must be modified to use #ifdef
  AUTOKEY instead of #ifdef OPENSSL where appropriate to complete this.
* include/ntp_crypto.h: make assumption AUTOKEY implies OPENSSL explicit.
(4.2.7p31) 2010/05/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1325] from 4.2.6p2-RC3: unreachable code sntp recv_bcst_data().
* [Bug 1459] from 4.2.6p2-RC3: sntp MD5 authentication does not work
  with ntpd.
* [Bug 1552] from 4.2.6p2-RC3: update and complete broadcast and crypto
  features in sntp.
* [Bug 1553] from 4.2.6p2-RC3: sntp/configure.ac OpenSSL support.
* from 4.2.6p2-RC3: Escape unprintable characters in a refid in ntpq -p
  billboard.
* from 4.2.6p2-RC3: Simplify hash client code by providing OpenSSL
  EVP_*() API when built without OpenSSL.  (already in 4.2.7)
* from 4.2.6p2-RC3: Do not depend on ASCII in sntp.
(4.2.7p30) 2010/05/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1526] ntpd DNS pipe read EINTR with no network at startup.
* Update the ChangeLog entries when merging items from -stable.
(4.2.7p29) 2010/05/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1542] ntpd mrulist response may have incorrect last.older.
* [Bug 1543] ntpq mrulist must refresh nonce when retrying.
* [Bug 1544] ntpq mrulist sscanf timestamp format mismatch on 64-bit.
* Windows compiling hints/winnt.html update from G. Sunil Tej.
(4.2.7p28) 2010/05/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1512] from 4.2.6p2-RC3: ntpsnmpd should connect to net-snmpd
  via a unix-domain socket by default.
  Provide a command-line 'socket name' option.
* [Bug 1538] from 4.2.6p2-RC3: update refclock_nmea.c's call to
  getprotobyname().
* [Bug 1541] from 4.2.6p2-RC3: Fix wrong keyword for "maxclock".
(4.2.7p27) 2010/04/27 Released by Harlan Stenn <stenn@ntp.org>
(4.2.7p26) 2010/04/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1465] from 4.2.6p2-RC2: Make sure time from TS2100 is not
  invalid (backport from -dev).
* [Bug 1528] from 4.2.6p2-RC2: Fix EDITLINE_LIBS link order for ntpq
  and ntpdc.
* [Bug 1531] Require nonce with mrulist requests.
* [Bug 1532] Remove ntpd support for ntpdc's monlist in favor of ntpq's
  mrulist.
* [Bug 1534] from 4.2.6p2-RC2: conflicts with VC++ 2010 errno.h.
* [Bug 1535] from 4.2.6p2-RC2: "restrict -4 default" and "restrict
  -6 default" ignored.
(4.2.7p25) 2010/04/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1528] from 4.2.6p2-RC2: Remove --with-arlib from br-flock.
* [Bug 1503] [Bug 1504] [Bug 1518] [Bug 1522] from 4.2.6p2-RC2:
  all of which were fixed in 4.2.7 previously.
(4.2.7p24) 2010/04/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1390] Control PPS on the Oncore M12.
* [Bug 1518] Windows ntpd should lock to one processor more
  conservatively.
* [Bug 1520] '%u' formats for size_t gives warnings with 64-bit builds.
* [Bug 1522] Enable range syntax "trustedkey (301 ... 399)".
* Documentation updates for 4.2.7p22 changes and additions, updating
  ntpdc.html, ntpq.html, accopt.html, confopt.html, manyopt.html,
  miscopt.html, and miscopt.txt.
* accopt.html: non-ntpport doc changes from Dave Mills.
* Modify full MRU list preemption when full to match "discard monitor"
  documentation, by removing exception for count == 1.
(4.2.7p23) 2010/04/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1516] unpeer by IP address fails, DNS name works.
* [Bug 1517] ntpq and ntpdc should verify reverse DNS before use.
  ntpq and ntpdc now use the following format for showing purported
  DNS names from IP address "reverse" DNS lookups when the DNS name
  does not exist or does not include the original IP address among
  the results: "192.168.1.2 (fake.dns.local)".
(4.2.7p22) 2010/04/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1432] Don't set inheritable flag for linux capabilities.
* [Bug 1465] Make sure time from TS2100 is not invalid.
* [Bug 1483] AI_NUMERICSERV undefined in 4.2.7p20.
* [Bug 1497] fudge is broken by getnetnum() change.
* [Bug 1503] Auto-enabling of monitor for "restrict ... limited" wrong.
* [Bug 1504] ntpdate tickles ntpd "discard minimum 1" rate limit if
  "restrict ... limited" is used.
* ntpdate: stop querying source after KoD packet response, log it.
* ntpdate: rate limit each server to 2s between packets.
* From J. N. Perlinger: avoid pointer wraparound warnings in dolfptoa(),
  printf format mismatches with 64-bit size_t.
* Broadcast client (ephemeral) associations should be demobilized only
  if they are not heard from for 10 consecutive polls, regardless of
  surviving the clock selection.  Fix from David Mills.
* Add "ntpq -c ifstats" similar to "ntpdc -c ifstats".
* Add "ntpq -c sysstats" similar to "ntpdc -c sysstats".
* Add "ntpq -c monstats" to show monlist knobs and stats.
* Add "ntpq -c mrulist" similar to "ntpdc -c monlist" but not
  limited to 600 rows, and with filtering and sorting options:
  ntpq -c "mrulist mincount=2 laddr=192.168.1.2 sort=-avgint"
  ntpq -c "mrulist sort=addr"
  ntpq -c "mrulist mincount=2 sort=count"
  ntpq -c "mrulist sort=-lstint"
* Modify internal representation of MRU list to use l_fp fixed-point
  NTP timestamps instead of seconds since startup.  This increases the
  resolution and substantially improves accuracy of sorts involving
  timestamps, at the cost of flushing all MRU entries when the clock is
  stepped, to ensure the timestamps can be compared with the current
  get_systime() results.
* Add ntp.conf "mru" directive to configure MRU parameters, such as
  "mru mindepth 600 maxage 64 maxdepth 5000 maxmem 1024" or
  "mru initalloc 0 initmem 16 incalloc 99 incmem 4".  Several pairs are
  equivalent with one in units of MRU entries and its twin in units of
  kilobytes of memory, so the last one used in ntp.conf controls:
  maxdepth/maxmem, initalloc/initmem, incalloc/incmem.  With the above
  values, ntpd will preallocate 16kB worth of MRU entries, allocating
  4kB worth each time more are needed, with a hard limit of 1MB of MRU
  entries.  Until there are more than 600 entries none would be reused.
  Then only entries for addresses last seen 64 seconds or longer ago are
  reused.
* Limit "ntpdc -c monlist" response in ntpd to 600 entries, the previous
  overall limit on the MRU list depth which was driven by the monlist
  implementation limit of one request with a single multipacket
  response.
* New "pool" directive implementation modeled on manycastclient.
* Do not abort on non-ASCII characters in ntp.conf, ignore them.
* ntpq: increase response reassembly limit from 24 to 32 packets, add
  discussion in comment regarding results with even larger MAXFRAGS.
* ntpq: handle "passwd MYPASSWORD" (without prompting) as with ntpdc.
* ntpdc: do not examine argument to "passwd" if not supplied.
* configure: remove check for pointer type used with qsort(), we
  require ANSI C which mandates void *.
* Reset sys_kodsent to 0 in proto_clr_stats().
* Add sptoa()/sockporttoa() similar to stoa()/socktoa() adding :port.
* Use memcpy() instead of memmove() when buffers can not overlap.
* Remove sockaddr_storage from our sockaddr_u union of sockaddr,
  sockaddr_in, and sockaddr_in6, shaving about 100 bytes from its size
  and substantially decreasing MRU entry memory consumption.
* Extend ntpq readvar (alias rv) to allow fetching up to three named
  variables in one operation:  ntpq -c "rv 0 version offset frequency".
* ntpq: use srchost variable to show .POOL. prototype associations'
  hostname instead of address 0.0.0.0.
* "restrict source ..." configures override restrictions for time
  sources, allows tight default restrictions to be used with the pool
  directive (where server addresses are not known in advance).
* Ignore "preempt" modifier on manycastclient and pool prototype
  associations.  The resulting associations are preemptible, but the
  prototype must not be.
* Maintain and use linked list of associations (struct peer) in ntpd,
  avoiding walking 128 hash table entries to iterate over peers.
* Remove more workarounds unneeded since we require ISO C90 AKA ANSI C:
  - remove fallback implementations for memmove(), memset, strstr().
  - do not test for atexit() or memcpy().
* Collapse a bunch of code duplication in ntpd/ntp_restrict.c added with
  support for IPv6.
* Correct some corner case failures in automatically enabling the MRU
  list if any "restrict ... limited" is in effect, and in disabling MRU
  maintenance. (ntp_monitor.c, ntp_restrict.c)
* Reverse the internal sort order of the address restriction lists, but
  preserve the same behavior.  This allows removal of special-case code
  related to the default restrictions and more straightforward lookups
  of restrictions for a given address (now, stop on first match).
* Move ntp_restrict.c MRU doubly-linked list maintenance code into
  ntp_lists.h macros, allowing more duplicated source excision.
* Repair ntpdate.c to no longer test HAVE_TIMER_SETTIME.
* Do not reference peer_node/unpeer_node after freeing when built with
  --disable-saveconfig and using DNS.
(4.2.7p21) 2010/03/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 2399] Reset sys_kodsent in proto_clr_stats().
* [Bug 1514] from 4.2.6p1-RC6: Typo in ntp_proto.c: fabs(foo < .4)
  should be fabs(foo) < .4.
* [Bug 1464] from 4.2.6p1-RC6: synchronization source wrong for
  refclocks ARCRON_MSF (27) and SHM (28).
* From 4.2.6p1-RC6: Correct Windows port's refclock_open() to
  return 0 on failure not -1.
* From 4.2.6p1-RC6: Correct CHU, dumbclock, and WWVB drivers to
  check for 0 returned from refclock_open() on failure.
* From 4.2.6p1-RC6: Correct "SIMUL=4 ./flock-build -1" to
  prioritize -1/--one.
* [Bug 1306] constant conditionals in audio_gain().
(4.2.7p20) 2010/02/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1483] hostname in ntp.conf "restrict" parameter rejected.
* Use all addresses for each restrict by hostname.
* Use async DNS to resolve trap directive hostnames.
(4.2.7p19) 2010/02/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1338] Update the association type codes in ntpq.html.
* [Bug 1478] from 4.2.6p1-RC5: linking fails: EVP_MD_pkey_type.
* [Bug 1479] from 4.2.6p1-RC5: not finding readline headers.
* [Bug 1484] from 4.2.6p1-RC5: ushort is not defined in QNX6.
(4.2.7p18) 2010/02/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1480] from 4.2.6p1-RC5: snprintf() cleanup caused
  unterminated refclock IDs.
* Stop using getaddrinfo() to convert numeric address strings to on-wire
  addresses in favor of is_ip_address() alone.
(4.2.7p17) 2010/02/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1477] from 4.2.6p1-RC5: First non-gmake make in clone
  w/VPATH can't make COPYRIGHT.
* Attempts to cure CID 108 CID 118 CID 119 TAINTED_SCALAR warnings.
* Broaden ylwrap workaround VPATH_HACK to all non-GNU make.
(4.2.7p16) 2010/02/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1474] from 4.2.6p1-RC4: ntp_keygen LCRYPTO after libntp.a.
* Include 4.2.6p1-RC4: Remove arlib.
(4.2.7p15) 2010/02/03 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1455] from 4.2.6p1: ntpd does not try /etc/ntp.audio.
* Include 4.2.6p1: Convert many sprintf() calls to snprintf(), also
  strcpy(), strcat().
* Include 4.2.6p1: Fix widely cut-n-pasted bug in refclock shutdown
  after failed start.
* Include 4.2.6p1: Remove some dead code checking for emalloc()
  returning NULL.
(4.2.7p14) 2010/02/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1338] ntpq displays incorrect association type codes.
* [Bug 1469] u_int32, int32 changes broke HP-UX 10.20 build.
* [Bug 1470] from 4.2.6p1: "make distdir" compiles keyword-gen.
* [Bug 1471] CID 120 CID 121 CID 122 is_ip_address() uninit family.
* [Bug 1472] CID 116 CID 117 minor warnings in new DNS code.
* [Bug 1473] from 4.2.6p1: "make distcheck" version.m4 error.
(4.2.7p13) 2010/01/31 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1467] from 4.2.6p1: Fix bogus rebuild of sntp/sntp.html.
(4.2.7p12) 2010/01/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1468] 'make install' broken for root on default NFS mount.
(4.2.7p11) 2010/01/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 47] Debugging and logging do not work after a fork.
* [Bug 1010] getaddrinfo() could block and thus should not be called by
  the main thread/process.
* New async DNS resolver in ntpd allows nonblocking queries anytime,
  instead of only once at startup.
(4.2.7p10) 2010/01/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1140] from 4.2.6p1-RC5: Clean up debug.html, decode.html,
  and ntpq.html.
* Include 4.2.6p1-RC3: Use TZ=UTC instead of TZ= when calling date in
  scripts/mkver.in .
* [Bug 1448] from 4.2.6p1-RC3: Some macros not correctly conditionally
  or absolutely defined on Windows.
* [Bug 1449] from 4.2.6p1-RC3: ntpsim.h in ntp_config.c should be used
  conditionally.
* [Bug 1450] from 4.2.6p1-RC3: Option to exclude warnings not
  unconditionally defined on Windows.
(4.2.7p9) 2010/01/13 Released by Harlan Stenn <stenn@ntp.org>
(4.2.7p8) 2010/01/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 702] ntpd service logic should use libopts to examine cmdline.
* [Bug 1451] from 4.2.6p1-RC3: sntp leaks KoD entry updating.
* [Bug 1453] from 4.2.6p1-RC3: Use $CC in config.cache filename.
(4.2.7p7) 2009/12/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 620] ntpdc getresponse() esize != *rsize s/b size != *rsize.
* [Bug 1446] 4.2.7p6 requires autogen, missing ntpd.1, *.texi, *.menu.
(4.2.7p6) 2009/12/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1443] Remove unnecessary dependencies on ntp_io.h
* [Bug 1442] Move Windows functions into libntp files
* [Bug 1127] from 4.2.6p1-RC3: Check the return of X590_verify().
* [Bug 1439] from 4.2.6p1-RC3: .texi gen after binary is linked.
* [Bug 1440] from 4.2.6p1-RC3: Update configure.ac to support kfreebsd.
* [Bug 1445] from 4.2.6p1-RC3: IRIX does not have -lcap or support
  linux capabilities.
(4.2.7p5) 2009/12/25 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.6p1-RC2
(4.2.7p4) 2009/12/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1429] ntpd -4 option does not reliably force IPv4 resolution.
* [Bug 1431] System headers must come before ntp headers in ntp_intres.c .
(4.2.7p3) 2009/12/22 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1426] scripts/VersionName needs . on the search path.
* [Bug 1427] quote missing in ./build - shows up on NetBSD.
* [Bug 1428] Use AC_HEADER_RESOLV to fix breaks from resolv.h
(4.2.7p2) 2009/12/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1419] ntpdate, ntpdc, sntp, ntpd ignore configure --bindir.
* [Bug 1421] add util/tg2, a clone of tg that works on Linux, NetBSD, and
  FreeBSD
(4.2.7p1) 2009/12/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1348] ntpd Windows port should wait for sendto() completion.
* [Bug 1413] test OpenSSL headers regarding -Wno-strict-prototypes.
* [Bug 1418] building ntpd/ntpdc/ntpq statically with ssl fails.
(4.2.7p0) 2009/12/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1412] m4/os_cflags.m4 caches results that depend on $CC.
* [Bug 1414] Enable "make distcheck" success with BSD make.
(4.2.7) 2009/12/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1407] configure.ac: recent GNU Make -v does not include "version".
---
(4.2.6p5) 2011/12/24 Released by Harlan Stenn <stenn@ntp.org>

No changes from 4.2.6p5-RC3.

---
(4.2.6p5-RC3) 2011/12/08 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2082] 3-char refid sent by ntpd 4.2.6p5-RC2 ends with extra dot.
* [Bug 2085] clock_update() sys_rootdisp calculation omits root delay.
* [Bug 2086] get_systime() should not offset by sys_residual.
* [Bug 2087] sys_jitter calculation overweights sys.peer jitter.
* Ensure NULL peer->dstadr is not accessed in orphan parent selection.

---
(4.2.6p5-RC2) 2011/11/30 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2050] Orphan mode stratum counting to infinity.
* [Bug 2059] optional billboard column "server" does not honor -n.
* [Bug 2066] ntpq lopeers ipv6 "local" column overrun.
* [Bug 2068] ntpd sends nonprintable stratum 16 refid to ntpq.
* [Bug 2069] broadcastclient, multicastclient spin up duplicate
  ephemeral associations without broadcastdelay.
* [Bug 2072] Orphan parent selection metric needs ntohl().
* Exclude not-yet-determined sys_refid from use in loopback TEST12
  (from David Mills).
* Never send KoD rate limiting response to MODE_SERVER response.

---
(4.2.6p5-RC1) 2011/10/18 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 2034] Listening address configuration with prefix misapplied.

---
(4.2.6p4) 2011/09/22 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1984] ntp/libisc fails to compile on OS X 10.7 (Lion).
* [Bug 1985] "logconfig =allall" rejected.
* [Bug 2001] ntpdc timerstats reports overruns as handled.
* [Bug 2003] libntpq ntpq_read_assoc_peervars() broken.
* [Backward Incompatible] sntp: -l/--filelog -> -l/--logfile, to be
  consistent with ntpd.
* libopts/file.c fix from Bruce Korb (arg-type=file).

---
(4.2.6p4-RC2) 2011/08/04 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1608] Parse Refclock driver should honor trusttime.
* [Bug 1961] html2man update: distribute ntp-wait.html.
* [Bug 1970] UNLINK_EXPR_SLIST() causes crash if list is empty.
* [Bug 1972] checking for struct rtattr fails.
* [Bug 1975] libntp/mktime.c won't work with 64-bit time_t
* [Bug 1978] [Bug 1134] fix in 4.2.6p4-RC1 doesn't build on older Linux.
* Backport several fixes for Coverity warnings from ntp-dev.
* Backport if_nametoindex() check for hpux.

---
(4.2.6p4-RC1) 2011/07/10 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1134] ntpd fails binding to tentative IPv6 addresses.
* [Bug 1790] Update config.guess and config.sub to detect AIX6.
* [Bug 1961] html2man needs an update.
* Update the NEWS file.

---
(4.2.6p4-beta2) 2011/05/25 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1695] ntpdate takes longer than necessary.
* [Bug 1832] ntpdate doesn't allow timeout > 2s.
* [Bug 1933] WWVB/Spectracom driver timestamps LFs, not CRs.
* Backport utility routines from ntp-dev: mprintf(), emalloc_zero().

---
(4.2.6p4-beta1) 2011/05/16 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1554] peer may stay selected as system peer after becoming
  unreachable.
* [Bug 1921] LOCAL, ACTS drivers with "prefer" excluded from initial
  candidate list.
* [Bug 1923] orphan parent favored over LOCAL, ACTS drivers.
* [Bug 1924] Billboard tally codes sometimes do not match operation,
  variables.
* Enable tickadj-like taming of wildly off-spec Windows clock using
  NTPD_TICKADJ_PPM env. var. specifying baseline slew.
* Upgrade to AutoGen 5.11.9 (and require it).
* Upgrade to libopts 35.0.10 from AutoGen 5.11.9pre8.

---
(4.2.6p3) 2011/01/03 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1764] Palisade driver doesn't build on Linux
* Create and use scripts/check--help when generating .texi files.
* Update bk triggers for the bk-5 release.
* Update genCommitLog for the bk-5 release.
* Update the copyright year.

---
(4.2.6p3-RC12) 2010/12/25 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1458] Can not compile NTP on FreeBSD 4.7.
* [Bug 1510] Add modes 20/21 for driver 8 to support RAWDCF @ 75 baud.
* [Bug 1618] Unreachable code in jjy_start(). (backport from ntp-dev)
* [Bug 1719] ntp-keygen -V crash. (backport)
* [Bug 1740] ntpdc treats many counters as signed. (backport)
* [Bug 1741] Enable multicast reception on each address (Windows).
* [Bug 1742] Fix a typo in an error message in the "build" script.
* [Bug 1743] Display timezone offset when showing time for sntp in the
local timezone.
* [Bug 1751] Support for Atari FreeMiNT OS.
* [Bug 1754] --version output should be more verbose.
* [Bug 1757] oncore snprintf("%m") doesn't expand %m.
* [Bug 1758] setsockopt IPV6_MULTICAST_IF with wrong ifindex.
* [Bug 1760] ntpd Windows interpolation cannot be disabled.
* [Bug 1762] manycastclient solicitation responses interfere.
* Upgrade to libopts 34.0.9 from AutoGen 5.11.6pre7.
* Relax minimum Automake version to 1.10 with updated libopts.m4.
* Suppress ntp-keygen OpenSSL version display for --help, --version,
display both build and runtime OpenSSL versions when they differ.
* Clean up m4 quoting in configure.ac, *.m4 files, resolving
  intermittent AC_LANG_PROGRAM possibly undefined errors.
* Clean up the SNTP documentation.
* Other manycastclient repairs:
  Separate handling of scope ID embedded in many in6_addr from ifindex
  used for IPv6 multicasting ioctls.
  Add INT_PRIVACY endpt bit flag for IPv6 RFC 4941 privacy addresses.
  Enable outbound multicast from only one address per interface in the
  same subnet, and in that case prefer embedded MAC address modified
  EUI-64 IPv6 addresses first, then static, and last RFC 4941 privacy
  addresses.
  Use setsockopt(IP[V6]_MULTICAST_IF) before each send to multicast to
  select the local source address, using the correct socket is not
  enough.

---
(4.2.6p3-RC11) 2010/11/28 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1725] ntpd sends multicast from only one address.
* [Bug 1728] In ntp_openssl.m4, don't add -I/usr/include or -L/usr/lib
  to CPPFLAGS or LDFLAGS.
* [Bug 1733] IRIX doesn't have 'head' (affects scripts/checkChangeLog).
* Remove log_msg() and debug_msg() from sntp in favor of msyslog().
* Use a single copy of libopts/, in sntp/.
* Upgrade libopts to 33.3.8.
* Bump minimum Automake version to 1.11, required for AM_COND_IF
  use in LIBOPTS_CHECK.
* Improvements to the 'build' script.

---
(4.2.6p3-RC10) 2010/11/14 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1681] More sntp logging cleanup.
* [Bug 1683] Non-localhost on loopback exempted from nic rules.

---
(4.2.6p3-RC9) 2010/11/10 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1574] sntp:set_time doesn't set tv_usec correctly.
* [Bug 1681] sntp logging cleanup.
* [Bug 1683] Interface binding does not seem to work as intended.
* [Bug 1691] Use first NMEA sentence each second.
* [Bug 1692] packageinfo.sh needs to be "sourced" using ./ .
* [Bug 1709] ntpdate ignores replies with equal receive and transmit
  timestamps.
* Backport sntp from -dev

---
(4.2.6p3-RC8) 2010/10/29 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1685] NMEA driver mode byte confusion.
* First cut at using scripts/checkChangeLog.

---
(4.2.6p3-RC7) 2010/10/25 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1676] NMEA: $GPGLL did not work after fix for Bug 1571.
* Added scripts/checkChangeLog.

---
(4.2.6p3-RC6) 2010/10/24 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1571] NMEA does not relate data to PPS edge.
* [Bug 1572] NMEA time adjustment for GPZDG buggy.
* [Bug 1675] Prohibit includefile remote config.

---
(4.2.6p3-RC5) 2010/10/22 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1649] Require NMEA checksum if $GPRMC or previously seen.
* [Bug 1669] NTP 4.2.6p2 fails to compile on IBM AIX 5.3.

---
(4.2.6p3-RC4) 2010/10/16 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1584] wrong SNMP type for precision, resolution.
* [Bug 1659] Need CLOCK_TRUETIME not CLOCK_TRUE.
* [Bug 1665] is_anycast() u_int32_t should be u_int32.
* ntpsnmpd, libntpq warning cleanup.

---
(4.2.6p3-RC3) 2010/10/14 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 750] Non-existing device causes coredump with RIPE-NCC driver.
* [Bug 1080] ntpd on ipv6 routers very chatty.
* [Bug 1567] Support Arbiter 1093C Satellite Clock on Windows.
* [Bug 1581] printf format string mismatch leftover.
* [Bug 1584] ntpsnmpd OID must be mib-2.197.
* [Bug 1643] Range-check the decoding of the RIPE-NCC status codes.
* [Bug 1644] cvo.sh should use lsb_release to identify linux distros.
* [Bug 1659] Support Truetime Satellite Clocks on Windows.
* [Bug 1660] On some systems, test is in /usr/bin, not /bin.
* [Bug 1661] Re-indent refclock_ripencc.c.

---
(4.2.6p3-RC2) 2010/09/25 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1635] "filegen ... enable" is not default.
* [Bug 1636] yyparse() segfault after denied filegen remote config.

---
(4.2.6p3-RC1) 2010/09/18 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1344] ntpd on Windows exits without logging cause.

---
(4.2.6p3-beta1) 2010/09/11 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1573] Miscalculation of offset in sntp.
* [Bug 1595] empty last line in key file causes duplicate key to be added
* [Bug 1597] packet processing ignores RATE KoD packets, because of
  a bug in string comparison.
* [Bug 1581] ntp_intres.c size_t printf format string mismatch.

---
(4.2.6p2) 2010/07/09 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1581] size_t printf format string mismatches, IRIG string buffers
  undersized.  Mostly backported from earlier ntp-dev fixes by Juergen
  Perlinger.

---
(4.2.6p2-RC7) 2010/06/19 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1570] serial clock drivers get outdated input from kernel tty
  line buffer after startup
* [Bug 1575] use 'snprintf' with LIB_BUFLENGTH in inttoa.c, tvtoa.c and
  utvtoa.c
* [Bug 1576] sys/sysctl.h depends on sys/param.h on OpenBSD.

---
(4.2.6p2-RC6) 2010/06/12 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 715] libisc Linux IPv6 interface iteration drops multicast flags.

---
(4.2.6p2-RC5) 2010/06/03 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1561] ntpq, ntpdc "passwd" prompts for MD5 password w/SHA1.
* [Bug 1565] sntp/crypto.c compile fails on MacOS over vsnprintf().
* Windows port: do not exit in ntp_timestamp_from_counter() without
  first logging the reason.
* Support "passwd blah" syntax in ntpq.

---
(4.2.6p2-RC4) 2010/05/19 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1555] 4.2.6p2-RC3 sntp illegal C (mixed code and declarations).

---
(4.2.6p2-RC3) 2010/05/11 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1325] unreachable code in sntp recv_bcst_data().
* [Bug 1459] sntp MD5 authentication does not work with ntpd.
* [Bug 1512] ntpsnmpd should connect to net-snmpd via a unix-domain
  socket by default.  Provide a command-line 'socket name' option.
* [Bug 1538] update refclock_nmea.c's call to getprotobyname().
* [Bug 1541] Fix wrong keyword for "maxclock".
* [Bug 1552] update and complete broadcast and crypto features in sntp.
* [Bug 1553] sntp/configure.ac OpenSSL support.
* Escape unprintable characters in a refid in ntpq -p billboard.
* Simplify hash client code by providing OpenSSL EVP_*() API when built
  without OpenSSL.  (from ntp-dev)
* Do not depend on ASCII values for ('A' - '0'), ('a' - '0') in sntp.
* Windows compiling hints/winnt.html update from G. Sunil Tej.

---
(4.2.6p2-RC2) 2010/04/27 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1465] Make sure time from TS2100 is not invalid (backport from
  ntp-dev).
* [Bug 1528] Fix EDITLINE_LIBS link order for ntpq and ntpdc.
* [Bug 1534] win32/include/isc/net.h conflicts with VC++ 2010 errno.h.
* [Bug 1535] "restrict -4 default" and "restrict -6 default" ignored.
* Remove --with-arlib from br-flock.

---
(4.2.6p2-RC1) 2010/04/18 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1503] Auto-enabling of monitor for "restrict ... limited" wrong.
* [Bug 1504] ntpdate tickles ntpd "discard minimum 1" rate limit if
  "restrict ... limited" is used.
* [Bug 1518] Windows ntpd should lock to one processor more
  conservatively.
* [Bug 1522] Enable range syntax "trustedkey (301 ... 399)".
* Update html/authopt.html controlkey, requestkey, and trustedkey docs.

---
(4.2.6p1) 2010/04/09 Released by Harlan Stenn <stenn@ntp.org>
(4.2.6p1-RC6) 2010/03/31 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1514] Typo in ntp_proto.c: fabs(foo < .4) should be fabs(foo) < .4.
* [Bug 1464] synchronization source wrong for refclocks ARCRON_MSF (27)
  and SHM (28).
* Correct Windows port's refclock_open() to return 0 on failure not -1.
* Correct CHU, dumbclock, and WWVB drivers to check for 0 returned from
  refclock_open() on failure.
* Correct "SIMUL=4 ./flock-build -1" to prioritize -1/--one.

---
(4.2.6p1-RC5) 2010/02/09 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1140] Clean up debug.html, decode.html, and ntpq.html.
* [Bug 1438] Remove dead code from sntp/networking.c.
* [Bug 1477] 1st non-gmake make in clone w/VPATH can't make COPYRIGHT.
* [Bug 1478] linking fails with undefined reference EVP_MD_pkey_type.
* [Bug 1479] Compilation fails because of not finding readline headers.
* [Bug 1480] snprintf() cleanup caused unterminated refclock IDs.
* [Bug 1484] ushort is not defined in QNX6.

---
(4.2.6p1-RC4) 2010/02/04 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1455] ntpd does not try /etc/ntp.audio as documented.
* [Bug 1467] Fix bogus rebuild of sntp/sntp.html
* [Bug 1470] "make distdir" in $srcdir builds keyword-gen, libntp.a.
* [Bug 1473] "make distcheck" before build can't make sntp/version.m4.
* [Bug 1474] ntp_keygen needs LCRYPTO after libntp.a.
* Convert many sprintf() calls to snprintf(), also strcpy(), strcat().
* Fix widely cut-n-pasted bug in refclock shutdown after failed start.
* Remove some dead code checking for emalloc() returning NULL.
* Remove arlib.

---
(4.2.6p1-RC3) 2010/01/24 Released by Harlan Stenn <stenn@ntp.org>

* Use TZ=UTC instead of TZ= when calling date in scripts/mkver.in .
* [Bug 1448] Some macros not correctly conditionally or absolutely defined
  on Windows.
* [Bug 1449] ntpsim.h in ntp_config.c should be used conditionally.
* [Bug 1450] Option to exclude warnings not unconditionally defined on Windows.
* [Bug 1127] Properly check the return of X590_verify() - missed one.
* [Bug 1439] .texi generation must wait until after binary is linked.
* [Bug 1440] Update configure.ac to support kfreebsd.
* [Bug 1445] IRIX does not have -lcap or support linux capabilities.
* [Bug 1451] CID 115: sntp leaks KoD entry when updating existing.
* [Bug 1453] Use $CC in config.cache filename in ./build script.

---
(4.2.6p1-RC2) 2009/12/25 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1411] Fix status messages in refclock_oncore.c.
* [Bug 1416] MAXDNAME undefined on Solaris 2.6.
* [Bug 1419] ntpdate, ntpdc, sntp, ntpd ignore configure --bindir.
* [Bug 1424] Fix check for rtattr (rtnetlink.h).
* [Bug 1425] unpeer by association ID sets up for duplicate free().
* [Bug 1426] scripts/VersionName needs . on the search path.
* [Bug 1427] quote missing in ./build - shows up on NetBSD.
* [Bug 1428] Use AC_HEADER_RESOLV to fix breaks from resolv.h
* [Bug 1429] ntpd -4 option does not reliably force IPv4 resolution.
* [Bug 1431] System headers must come before ntp headers in ntp_intres.c .
* [Bug 1434] HP-UX 11 ip_mreq undeclared, _HPUX_SOURCE helps some.
* [Bug 1435] sntp: Test for -lresolv using the same tests as in ntp.

---
(4.2.6p1-RC1) 2009/12/20 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1409] Put refclock_neoclock4x.c under the NTP COPYRIGHT notice.
  This should allow debian and other distros to add this refclock driver
  in further distro releases.
  Detect R2 hardware releases.
* [Bug 1412] m4/os_cflags.m4 caches results that depend on $CC.
* [Bug 1413] test OpenSSL headers regarding -Wno-strict-prototypes.
* [Bug 1414] Enable "make distcheck" success with BSD make.
* [Bug 1415] Fix Mac OS X link problem.
* [Bug 1418] building ntpd/ntpdc/ntpq statically with ssl fails.
* Build infrastructure updates to enable beta releases of ntp-stable.

---
(4.2.6) 2009/12/09 Released by Harlan Stenn <stenn@ntp.org>
* [Sec 1331] from4.2.4p8: DoS with mode 7 packets - CVE-2009-3563.
* [Bug 508] Fixed leap second handling for Windows.
(4.2.5p250-RC) 2009/11/30 Released by Harlan Stenn <stenn@ntp.org>
* sntp documentation updates.
* [Bug 761] internal resolver does not seem to honor -4/-6 qualifiers
* [Bug 1386] Deferred DNS doesn't work on NetBSD
* [Bug 1391] avoid invoking autogen twice for .c and .h files.
* [Bug 1397] shmget() refclock_shm failing because of file mode.
* Pass no_needed to ntp_intres as first part of fixing [Bug 975].
* Add ./configure --enable-force-defer-DNS to help debugging.
(4.2.5p249-RC) 2009/11/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1400] An empty KOD DB file causes sntp to coredump.
* sntp: documentation cleanup.
* sntp: clean up some error messages.
* sntp: Use the precision to control how many offset digits are shown.
* sntp: Show root dispersion.
* Cleanup from the automake/autoconf upgrades.
(4.2.5p248-RC) 2009/11/26 Released by Harlan Stenn <stenn@ntp.org>
* Prepare for the generation of sntp.html.
* Documentation changes from Dave Mills.
* [Bug 1387] Storage leak in ntp_intres (minor).
* [Bug 1389] buffer overflow in refclock_oncore.c
* [Bug 1391] .texi usage text from installed, not built binaries.
* [Bug 1392] intres retries duplicate assocations endlessly.
* Correct *-opts.h dependency so default 'get' action isn't used.
(4.2.5p247-RC) 2009/11/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1142] nodebug builds shed no light on -d, -D option failure.
* [Bug 1179] point out the problem with -i/--jaildir and -u/--user when
  they are disabled by configure.
* [Bug 1308] support systems that lack fork().
* [Bug 1343] sntp doesn't link on Solaris 7, needs -lresolv.
(4.2.5p246-RC) 2009/11/17 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to autogen-5.10
* [Bug 1378] Unnecessary resetting of peers during interface update.
* [Bug 1382] p245 configure --disable-dependency-tracking won't build.
* [Bug 1384] ntpq :config core dumped with a blank password.
(4.2.5p245-RC) 2009/11/14 Released by Harlan Stenn <stenn@ntp.org>
* Cleanup from Dave Mills.
* [Bug 1343] sntp illegal C does not compile on Solaris 7.
* [Bug 1381] Version .deps generated include file dependencies to allow
  known dependency-breaking changes to force .deps to be cleaned,
  triggered by changing the contents of deps-ver and/or sntp/deps-ver.
(4.2.5p244-RC) 2009/11/12 Released by Harlan Stenn <stenn@ntp.org>
* keygen.html updates from Dave Mills.
* [Bug 1003] ntpdc unconfig command doesn't prompt for keyid.
* [Bug 1376] Enable authenticated ntpq and ntpdc using newly-available
  digest types.
* ntp-keygen, Autokey OpenSSL build vs. run version mismatch is now a
  non-fatal warning.
(4.2.5p243-RC) 2009/11/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1226] Fix deferred DNS lookups.
* new crypto signature cleanup.
(4.2.5p242-RC) 2009/11/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1363] CID 92 clarify fallthrough case in clk_trimtsip.c
* [Bug 1366] ioctl(TIOCSCTTY, 0) fails on NetBSD *[0-2].* > 3.99.7.
* [Bug 1368] typos in libntp --without-crypto case
* [Bug 1371] deferred DNS lookup failing with INFO_ERR_AUTH.
* CID 87 dead code in ntpq.c atoascii().
* Fix authenticated ntpdc, broken in p240.
* Stub out isc/mem.h, shaving 47k from a MIPS ntpd binary.
* Shrink keyword scanner FSM entries from 64 to 32 bits apiece.
* Documention updates from Dave Mills.
* authkeys.c cleanup from Dave Mills.
(4.2.5p241-RC) 2009/11/07 Released by Harlan Stenn <stenn@ntp.org>
* html/authopt.html update from Dave Mills.
* Remove unused file from sntp/Makefile.am's distribution list.
* new crypto signature cleanup.
(4.2.5p240-RC) 2009/11/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1364] clock_gettime() not detected, need -lrt on Debian 5.0.3.
* Provide all of OpenSSL's signature methods for ntp.keys (FIPS 140-2).
(4.2.5p239-RC) 2009/10/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1357] bogus assert from refclock_shm.
* [Bug 1359] Debug message cleanup.
* CID 101: more pointer/array cleanup.
* [Bug 1356] core dump from refclock_nmea when can't open /dev/gpsU.
* [Bug 1358] AIX 4.3 sntp/networking.c IPV6_JOIN_GROUP undeclared.
* CID 101: pointer/array cleanup.
(4.2.5p238-RC) 2009/10/27 Released by Harlan Stenn <stenn@ntp.org>
* Changes from Dave Mills.
* driver4.html updates from Dave Mills.
* [Bug 1252] PPSAPI cleanup on ntpd/refclock_wwvb.c.
* [Bug 1354] libtool error building after bootstrap with Autoconf 2.64.
* Allow NTP_VPATH_HACK configure test to handle newer gmake versions.
* CIDs 94-99 make it more clearly impossible for sock_hash() to return
  a negative number.
* CID 105, 106 ensure ntpdc arrays are not overrun even if callers
  misbehave.
* CID 113 use va_end() in refclock_true.c true_debug().
* Get rid of configure tests for __ss_family and __ss_len when the more
  common ss_family and ss_len are present.
(4.2.5p237-RC) 2009/10/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 610] NMEA support for using PPSAPI on a different device.
* [Bug 1238] use only fudge time2 to offset NMEA serial timestamp.
* [Bug 1355] ntp-dev won't compile on OpenBSD 4.6.
(4.2.5p236-RC) 2009/10/22 Released by Harlan Stenn <stenn@ntp.org>
* Cleanup from Dave Mills.
* [Bug 1343] ntpd/ntp_io.c close_fd() does not compile on Solaris 7.
* [Bug 1353] ntpq "rv 0 settimeofday" always shows UNKNOWN on unix.
* Do not attempt to execute built binaries from ntpd/Makefile when
  cross-compiling (keyword-gen and ntpd --saveconfigquit).
* sntp/main.c: Remove duplicate global adr_buf[] (also defined in
  networking.c) which Piotr Grudzinski identified breaking his build.
* Correct in6addr_any test in configure.ac to attempt link too.
(4.2.5p235-RC) 2009/10/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1343] lib/isc build breaks on systems without IPv6 headers.
(4.2.5p234-RC) 2009/10/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1339] redux, use unmodified lib/isc/win32/strerror.c and
  move #define strerror... to a header not used by lib/isc code.
* [Bug 1345] illegal 'grep' option prevents compilation.
* [Bug 1346] keyword scanner broken where char defaults to unsigned.
* [Bug 1347] ntpd/complete.conf missing multicastclient test case.
(4.2.5p233-RC) 2009/10/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1337] cast setsockopt() v4 address pointer to void *.
* [Bug 1342] ignore|drop one IPv6 address on an interface blocks all
  addresses on that interface.
* Documentation cleanup and updates.
(4.2.5p232-RC) 2009/10/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1302] OpenSSL under Windows needs applink support.
* [Bug 1337] fix incorrect args to setsockopt(fd, IP_MULTICAST_IF,...).
* [Bug 1339] Fix Windows-only ntp_strerror() infinite recursion.
* [Bug 1341] NMEA driver requires working PPSAPI #ifdef HAVE_PPSAPI.
* Construct ntpd keyword scanner finite state machine at compile time
  rather than at runtime, shrink entries from 40+ to 8 bytes.
* Update documentation for ntpq --old-rv, saveconfig, saveconfigdir,
  ntpd -I -L and -M, and interface/nic rules. (From Dave Hart)
* [Bug 1337] fix incorrect args to setsockopt(fd, IP_MULTICAST_IF,...)
(4.2.5p231-RC) 2009/10/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1335] Broadcast client degraded by wildcard default change.
(4.2.5p230-RC) 2009/10/09 Released by Harlan Stenn <stenn@ntp.org>
* Start the 4.2.6 Release Candidate cycle.
* Broadcast and transit phase cleanup from Dave Mills.
(4.2.5p229) 2009/10/07 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1334] ntpsnmpd undefined reference to `ntpqOptions'.
* Change ntpsnmpd/Makefile.am include file order to fix FreeBSD build.
(4.2.5p228) 2009/10/06 Released by Harlan Stenn <stenn@ntp.org>
* Reclaim syntax tree memory after application in ntpd built with
  configure --disable-saveconfig.
* [Bug 1135] ntpq uses sizeof(u_long) where sizeof(u_int32) is meant.
* [Bug 1333] ntpd --interface precedence over --novirtualips lost.
(4.2.5p227) 2009/10/05 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1135] :config fails with "Server disallowed request"
* [Bug 1330] disallow interface/nic rules when --novirtualips or
  --interface are used.
* [Bug 1332] ntpq -c 'rv 0 variablename' returns extra stuff.
* Add test of ntpd --saveconfigquit fidelity using new complete.conf.
* Documentation updates from Dave Hart/Dave Mills.
(4.2.5p226) 2009/10/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1318] Allow multiple -g options on ntpd command line.
* [Bug 1327] ntpq, ntpdc, ntp-keygen -d & -D should work with configure
  --disable-debugging.
* Add ntpd --saveconfigquit <filename> option for future build-time
  testing of saveconfig fidelity.
* Clockhop and autokey cleanup from Dave Mills.
* Documentation updates from Dave Mills.
(4.2.5p225) 2009/09/30 Released by Harlan Stenn <stenn@ntp.org>
* authopt documentation changes from Dave Mills/Dave Hart.
* [Bug 1324] support bracketed IPv6 numeric addresses for restrict.
(4.2.5p224) 2009/09/29 Released by Harlan Stenn <stenn@ntp.org>
* Clockhop and documentation fixes from Dave Mills.
* Remove "tos maxhop" ntp.conf knob.
(4.2.5p223) 2009/09/28 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1321] build doesn't work if . isn't on $PATH.
* [Bug 1323] Implement "revoke #" to match documentation, deprecate
  "crypto revoke #".
(4.2.5p222) 2009/09/27 Released by Harlan Stenn <stenn@ntp.org>
* Update libisc code using bind-9.6.1-P1.tar.gz, rearrange our copy to
  mirror the upstream layout (lib/isc/...), and merge in NTP-local
  modifications to libisc.  There is a new procedure to ease future
  libisc merges using a separate "upstream" bk repo.  That will enable
  normal bk pull automerge to handle carrying forward any local changes
  and should enable us to take updated libisc snapshots more often.
* Updated build and flock-build scripts.  flock-build --one is a way
  to perform a flock-build compatible solitary build, handy for a repo
  clone's first build on a machine with autoconf, automake, etc.
* Compiling ntp_parser.y using BSD make correctly places ntp_parser.h
  in the top-level ntpd directory instead of A.*/ntpd.
* bootstrap script updated to remove potentially stale .deps dirs.
* Remove unneeded Makefile.am files from the lib/isc/include tree.
(4.2.5p221) 2009/09/26 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1316] segfault if refclock_nmea can't open file.
* [Bug 1317] Distribute cvo.sh.
(4.2.5p220) 2009/09/25 Released by Harlan Stenn <stenn@ntp.org>
* Rearrange libisc code to match the upstream layout in BIND.  This is
  step one of two, changing the layout but keeping our existing libisc.
(4.2.5p219) 2009/09/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1315] "interface ignore 0.0.0.0" is ignored.
* add implicit "nic ignore all" rule before any rules from ntp.conf, so
  "nic listen eth0" alone means the same as "-I eth0".
* add wildcard match class for interface/nic rules.
* fix mistaken carryover of prefixlen from one rule to the next.
* Ensure IPv6 localhost address ::1 is included in libisc's Windows IPv6
  address enumeration, allowing ntpq and ntpdc's hardcoding to 127.0.0.1
  on Windows to end.
(4.2.5p218) 2009/09/21 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1314] saveconfig emits -4 and -6 on when not given.
* correct parsing and processing of setvar directive.
* highlight location of ntpq :config syntax errors with ^.
* clarify (former) NO_ARG, SINGLE_ARG, MULTIPLE_ARG renaming to
  FOLLBY_TOKEN, FOLLBY_STRING, FOLLBY_STRINGS_TO_EOC.
* parser, saveconfig cleanup to store T_ identifiers in syntax tree.
(4.2.5p217) 2009/09/20 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1300] reject remote configuration of dangerous items.
(4.2.5p216) 2009/09/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1312] ntpq/ntpdc MD5 passwords truncated to 8 chars on Suns.
* CID 10 missing free(up); in refclock_palisade.c error return, again.
* CID 83 added assertion to demonstrate config_nic_rules() does not
  call strchr(NULL, '/').
(4.2.5p215) 2009/09/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1292] Workaround last VC6 unsigned __int64 kink.
(4.2.5p214) 2009/09/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1303] remove top-level "autokey" directive.
* use "nic listen 192.168.0.0/16" instead of
  "nic listen 192.168.0.0 prefixlen 16".
(4.2.5p213) 2009/09/16 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1310] fix Thunderbolt mode in refclock_palisade.c
(4.2.5p212) 2009/09/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 983] add interface [listen | ignore | drop] ... directive.
* [Bug 1243] MD5auth_setkey zero-fills key from first zero octet.
* [Bug 1295] leftover fix, do not crash on exit in free_config_trap()
  when "trap 1.2.3.4" is used without any further options.
* [Bug 1311] 4.2.5p211 doesn't build in no-debug mode.
* document interface (alias nic) and unpeer.
* Correct syntax error line & column numbers.
* CID 79: kod_init_kod_db() fails to fclose(db_s) in two error paths.
* CID 80: attempt to quiet Coverity false positive re: leaking "reason"
  in main().
* Documentation updates from Dave Mills.
* CID 81: savedconfig leaked in save_config().
* Make the code agree with the spec and the book (Dave Mills).
(4.2.5p211) 2009/09/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 663] respect ntpq -c and -p order on command line.
* [Bug 1292] more VC6 unsigned __int64 workarounds.
* [Bug 1296] Added Support for Trimble Acutime Gold.
(4.2.5p210) 2009/09/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1294] Use OPENSSL_INC and OPENSSL_LIB macros for Windows
  and remove unnecessary reference to applink.c for Windows
* [Bug 1295] trap directive options are not optional.
* [Bug 1297] yylex() must always set yylval before returning.
(4.2.5p209) 2009/09/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1290] Fix to use GETTIMEOFDAY macro
* [Bug 1289] Update project files for VC6, VS2003, VS2005, VS 2008
(4.2.5p208) 2009/08/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1293] make configuration dumper ready for release, specifically:
* rename ntpq dumpcfg command to "saveconfig".
* require authentication for saveconfig.
* "restrict ... nomodify" prevents saveconfig and :config.
* "saveconfig ." shorthand to save to startup configuration file.
* support strftime() substitution in saveconfig arg to timestamp
  the output filename, for example "saveconfig %Y%m%d-%H%M%S.conf".
* display saveconfig response message from ntpd in ntpq.
* save output filename in "savedconfig" variable, fetched with ntpq -c
  "rv 0 savedconfig".
* document saveconfig in html/ntpq.html.
* add ./configure --disable-saveconfig to build a smaller ntpd.
* log saveconfig failures and successes to syslog.
(4.2.5p207) 2009/08/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1292] Minor Windows source tweaks for VC6-era SDK headers.
(4.2.5p206) 2009/08/26 Released by Harlan Stenn <stenn@ntp.org>
* accopt.html typo fixes from Dave Mills.
* [Bug 1283] default to remembering KoD in sntp.
* clean up numerous sntp/kod_management.c bugs.
* use all addresses resolved from each DNS name in sntp.
(4.2.5p205) 2009/08/18 Released by Harlan Stenn <stenn@ntp.org>
* accopt.html typo fixes from Dave Mills.
* [Bug 1285] Log ntpq :config/config-from-file events.
* [Bug 1286] dumpcfg omits statsdir, mangles filegen.
(4.2.5p204) 2009/08/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1284] infinite loop in ntpd dumping more than one trustedkey
(4.2.5p203) 2009/08/16 Released by Harlan Stenn <stenn@ntp.org>
* Add ntpq -c dumpcfg, Google Summer of Code project of Max Kuehn
(4.2.5p202) 2009/08/14 Released by Harlan Stenn <stenn@ntp.org>
* install the binary and man page for sntp.
(4.2.5p201) 2009/08/13 Released by Harlan Stenn <stenn@ntp.org>
* sntp: out with the old, in with the new.
(4.2.5p200) 2009/08/12 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1281] Build ntpd on Windows without big SDK download, burn,
  and install by checking in essentially unchanging messages.mc build
  products to avoid requiring mc.exe, which is not included with VC++
  2008 EE.
(4.2.5p199) 2009/08/09 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1279] Cleanup for warnings from Veracode static analysis.
(4.2.5p198) 2009/08/03 Released by Harlan Stenn <stenn@ntp.org>
* Upgrade to autogen-5.9.9-pre5.
(4.2.5p197) 2009/07/30 Released by Harlan Stenn <stenn@ntp.org>
* The build script now has . at the end of PATH for config.guess.
(4.2.5p196) 2009/07/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1272] gsoc_sntp IPv6 build problems under HP-UX 10.
* [Bug 1273] CID 10: Palisade leaks unit struct in error path.
* [Bug 1274] CID 67: ensure resolve_hosts() output count and pointers
  are consistent.
* [Bug 1275] CID 45: CID 46: old sntp uses uninitialized guesses[0],
  precs[0].
* [Bug 1276] CID 52: crypto_xmit() may call crypto_alice[23]()
  with NULL peer.
(4.2.5p195) 2009/07/27 Released by Harlan Stenn <stenn@ntp.org>
* cvo.sh: Add support for CentOS, Fedora, Slackware, SuSE, and QNX.
(4.2.5p194) 2009/07/26 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* Use scripts/cvo.sh in the build script to get better subdir names.
(4.2.5p193) 2009/07/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1261] CID 34: simulate_server() rbuf.msg_flags uninitialized.
* [Bug 1262] CID 35: xpkt.mac uninitialized in simulate_server().
* [Bug 1263] CID 37: CID 38: CID 40: CID 43: multiple refclocks
  uninitialized tm_zone (arc, chronolog, dumbclock, pcf).
* [Bug 1264] CID 64: gsoc_sntp on_wire() frees wrong ptr receiving KoD.
* [Bug 1265] CID 65: CID 66: gsoc_sntp on_wire() leaks x_pkt, r_pkt.
* [Bug 1266] CID 39: datum_pts_start() uninitialized arg.c_ospeed.
* [Bug 1267] CID 44: old sntp handle_saving() writes stack garbage to
  file when clearing.
* [Bug 1268] CID 63: resolve_hosts() leaks error message buffer.
* [Bug 1269] CID 74: use assertion to ensure move_fd() does not return
  negative descriptors.
* [Bug 1270] CID 70: gsoc_sntp recv_bcst_data mdevadr.ipv6mr_interface
  uninitialized.
(4.2.5p192) 2009/07/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 965] CID 42: ss_family uninitialized.
* [Bug 1250] CID 53: kod_init_kod_db() overruns kod_db malloc'd buffer.
* [Bug 1251] CID 68: search_entry() mishandles dst argument.
* [Bug 1252] CID 32: Quiet Coverity warning with assertion.
* [Bug 1253] CID 50: gsoc_sntp/crypto.c auth_init() always returns a
  list with one entry.
* [Bug 1254] CID 56: tv_to_str() leaks a struct tm each call.
* [Bug 1255] CID 55: pkt_output() leaks a copy of each packet.
* [Bug 1256] CID 51: Coverity doesn't recognize our assertion macros as
  terminal.
* [Bug 1257] CID 57: gsoc_sntp auth_init() fails to fclose(keyfile).
* [Bug 1258] CID 54: gsoc_sntp resolve_hosts() needs simplification.
* [Bug 1259] CID 59: gsoc_sntp recv_bcast_data() fails to free(rdata)
  on error paths.
* [Bug 1260] CID 60: gsoc_sntp recvpkt() fails to free(rdata).
* Updated to AutoGen-5.9.9pre2.
(4.2.5p191) 2009/07/21 Released by Harlan Stenn <stenn@ntp.org>
* Updated to AutoGen-5.9.9pre1.
(4.2.5p190) 2009/07/20 Released by Harlan Stenn <stenn@ntp.org>
* Updated to AutoGen-5.9.8.
* [Bug 1248] RES_MSSNTP typo in ntp_proto.c.
* [Bug 1246] use a common template for singly-linked lists, convert most
  doubly-linked lists to singly-linked.
* Log warning about signd blocking when restrict mssntp used.
(4.2.5p189) 2009/07/16 Released by Harlan Stenn <stenn@ntp.org>
* Documentation cleanup from Dave Mills.
(4.2.5p188) 2009/07/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1245] Broken xmt time sent in fast_xmit() of 4.2.5p187.
(4.2.5p187) 2009/07/11 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1042] multicast listeners IPv4+6 ignore new interfaces.
* [Bug 1237] Windows serial code treat CR and LF both as line
  terminators.
* [Bug 1238] use fudge time2 for serial timecode offset in NMEA driver.
* [Bug 1242] Remove --enable-wintime, symmetric workaround is now
  always enabled.
* [Bug 1244] NTP_INSIST(fd != maxactivefd) failure in intres child
* Added restrict keyword "mssntp" for Samba4 DC operation, by Dave Mills.
(4.2.5p186) 2009/07/08 Released by Harlan Stenn <stenn@ntp.org>
* ntp_proto.c cleanup from Dave Mills.
(4.2.5p185) 2009/07/01 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* [Bug 1234] convert NMEA driver to use common PPSAPI code.
* timepps-Solaris.h pps_handle_t changed from pointer to scalar
* Spectracom refclock added to Windows port of ntpd
* [Bug 1236] Declaration order fixed.
* Bracket private ONCORE debug statements with #if 0 rather than #ifdef
  DEBUG
* Delete ONCORE debug statement that is now handled elsewhere.
(4.2.5p184) 2009/06/24 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1233] atom refclock fudge time1 sign flipped in 4.2.5p164.
(4.2.5p183) 2009/06/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1196] setsockopt(SO_EXCLUSIVEADDRUSE) can fail on Windows 2000
  and earlier with WSAINVAL, do not log a complaint in that case.
* [Bug 1210] ONCORE driver terminates ntpd without logging a reason.
* [Bug 1218] Correct comment in refclock_oncore on /etc/ntp.oncore*
  configuration file search order.
* Change ONCORE driver to log using msyslog as well as to any
  clockstats file.
* [Bug 1231] ntpsnmpd build fails after sockaddr union changes.
(4.2.5p182) 2009/06/18 Released by Harlan Stenn <stenn@ntp.org>
* Add missing header dependencies to the ntpdc layout verification.
* prefer.html updates from Dave Mills.
* [Bug 1205] Add ntpd --usepcc and --pccfreq options on Windows
* [Bug 1215] unpeer by association ID
* [Bug 1225] Broadcast address miscalculated on Windows 4.2.5p180
* [Bug 1229] autokey segfaults in cert_install().
* Use a union for structs sockaddr, sockaddr_storage, sockaddr_in, and
  sockaddr_in6 to remove casts and enable type checking.  Collapse
  some previously separate IPv4/IPv6 paths into a single codepath.
(4.2.5p181) 2009/06/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1206] Required compiler changes for Windows
* [Bug 1084] PPSAPI for ntpd on Windows with DLL backends
* [Bug 1204] Unix-style refclock device paths on Windows
* [Bug 1205] partial fix, disable RDTSC use by default on Windows
* [Bug 1208] decodenetnum() buffer overrun on [ with no ]
* [Bug 1211] keysdir free()d twice #ifdef DEBUG
* Enable ONCORE, ARCRON refclocks on Windows (untested)
(4.2.5p180) 2009/05/29 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1200] Enable IPv6 in Windows port
* Lose FLAG_FIXPOLL, from Dave Mills.
(4.2.5p179) 2009/05/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1041] xmt -> aorg timestamp cleanup from Dave Mills,
  reported by Dave Hart.
* [Bug 1193] Compile error: conflicting types for emalloc.
* [Bug 1196] VC6 winsock2.h does not define SO_EXCLUSIVEADDRUSE.
* Leap/expire cleanup from Dave Mills.
(4.2.5p178) 2009/05/21 Released by Harlan Stenn <stenn@ntp.org>
* Provide erealloc() and estrdup(), a la emalloc().
* Improve ntp.conf's parser error messages.
* [Bug 320] "restrict default ignore" does not affect IPv6.
* [Bug 1192] "restrict -6 ..." reports a syntax error.
(4.2.5p177) 2009/05/18 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.4p7
* [Bug 1174] nmea_shutdown assumes that nmea has a unit assigned
* [Bug 1190] NMEA refclock fudge flag4 1 obscures position in timecode
* Update NMEA refclock documentation in html/drivers/driver20.html
(4.2.5p176) 2009/05/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1154] mDNS registration should be done later, repeatedly and only
  if asked for. (second try for fix)
(4.2.5p175) 2009/05/12 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.4p7-RC7
* [Bug 1180] ntpd won't start with more than ~1000 interfaces
* [Bug 1182] Documentation typos and missing bits.
* [Bug 1183] COM port support should extend past COM3
* [Bug 1184] ntpd is deaf when restricted to second IP on the same net
* Clean up configure.ac NTP_CACHEVERSION interface, display cache
  version when clearing.  Fixes a regression.
(4.2.5p174) 2009/05/09 Released by Harlan Stenn <stenn@ntp.org>
* Stale leapsecond file fixes from Dave Mills.
(4.2.5p173) 2009/05/08 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.4p7-RC6
(4.2.5p172) 2009/05/06 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1175] Instability in PLL daemon mode.
* [Bug 1176] refclock_parse.c does not compile without PPSAPI.
(4.2.5p171) 2009/05/04 Released by Harlan Stenn <stenn@ntp.org>
* Autokey documentation cleanup from Dave Mills.
* [Bug 1171] line editing libs found without headers (Solaris 11)
* [Bug 1173] NMEA refclock fails with Solaris PPSAPI
* Fix problem linking msntp on Solaris when sntp subdir is configured
  before parent caused by different gethostent library search order.
* Do not clear config.cache when it is  empty.
(4.2.5p170) 2009/05/02 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1152] adjust PARSE to new refclock_pps logic
* Include 4.2.4p7-RC5
* loopfilter FLL/PLL crossover cleanup from Dave Mills.
* Documentation updates from Dave Mills.
* ntp-keygen cleanup from Dave Mills.
* crypto API cleanup from Dave Mills.
* Add NTP_CACHEVERSION mechanism to ignore incompatible config.cache
* Enable gcc -Wstrict-overflow for gsoc_sntp as well
(4.2.5p169) 2009/04/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1171] Note that we never look for -lreadline by default.
* [Bug 1090] Fix bogus leap seconds in refclock_hpgps.
(4.2.5p168) 2009/04/29 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.4p7-RC4
* [Bug 1169] quiet compiler warnings
* Re-enable gcc -Wstrict-prototypes when not building with OpenSSL
* Enable gcc -Wstrict-overflow
* ntpq/ntpdc emit newline after accepting password on Windows
* Updates from Dave Mills:
* ntp-keygen.c: Updates.
* Fix the error return and syslog function ID in refclock_{param,ppsapi}.
* Make sure syspoll is within the peer's minpoll/maxpoll bounds.
* ntp_crypto.c: Use sign_siglen, not len. sign key filename cleanup.
* Bump NTP_MAXEXTEN from 1024 to 2048, update values for some field lengths.
* m4/ntp_lineeditlibs.m4: fix warnings from newer Autoconf
* [Bug 1166] Remove truncation of position (blanking) code in refclock_nmea.c
(4.2.5p167) 2009/04/26 Released by Harlan Stenn <stenn@ntp.org>
* Crypto cleanup from Dave Mills.
(4.2.5p166) 2009/04/25 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1165] Clean up small memory leaks in the  config file parser
* Correct logconfig keyword declaration to MULTIPLE_ARG
* Enable filename and line number leak reporting on Windows when built
  DEBUG for all the typical C runtime allocators such as calloc,
  malloc, and strdup.  Previously only emalloc calls were covered.
* Add DEBUG-only code to free dynamically allocated memory that would
  otherwise remain allocated at ntpd exit, to allow less forgivable
  leaks to stand out in leaks reported after exit.
* Ensure termination of strings in ports/winnt/libisc/isc_strerror.c
  and quiet compiler warnings.
* [Bug 1057] ntpdc unconfig failure
* [Bug 1161] unpeer AKA unconfig command for ntpq :config
* PPS and crypto cleanup in ntp_proto.c from Dave Mills.
(4.2.5p165) 2009/04/23 Released by Harlan Stenn <stenn@ntp.org>
* WWVB refclock cleanup from Dave Mills.
* Code cleanup: requested_key -> request_key.
* [Bug 833] ignore whitespace at end of remote configuration lines
* [Bug 1033] ntpdc/ntpq crash prompting for keyid on Windows
* [Bug 1028] Support for W32Time authentication via Samba.
* quiet ntp_parser.c malloc redeclaration warning
* Mitigation and PPS/PPSAPI cleanup from Dave Mills.
* Documentation updates from Dave Mills.
* timepps-Solaris.h patches from Dave Hart.
(4.2.5p164) 2009/04/22 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.4p7-RC3
* PPS/PPSAPI cleanup from Dave Mills.
* Documentation updates from Dave Mills.
* [Bug 1125] C runtime per-thread initialization on Windows
* [Bug 1152] temporarily disable refclock_parse, refclock_true until
  maintainers can repair build break from pps_sample()
* [Bug 1153] refclock_nmea should not mix UTC with GPS time
* [Bug 1159] ntpq overlap diagnostic message test buggy
(4.2.5p163) 2009/04/10 Released by Harlan Stenn <stenn@ntp.org>
(4.2.5p162) 2009/04/09 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* Mitigation and PPS cleanup from Dave Mills.
* Include 4.2.4p7-RC2
* [Bug 216] New interpolation scheme for Windows eliminates 1ms jitter
* remove a bunch of #ifdef SYS_WINNT from portable code
* 64-bit time_t cleanup for building on newer Windows compilers
* Only set CMOS clock during ntpd exit on Windows if the computer is
  shutting down or restarting.
* [Bug 1148] NMEA reference clock improvements
* remove deleted gsoc_sntp/utilities.o from repository so that .o build
  products can be cleaned up without corrupting the repository.
(4.2.5p161) 2009/03/31 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
(4.2.5p160) 2009/03/30 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1141] refclock_report missing braces cause spurious "peer event:
  clock clk_unspec" log entries
* Include 4.2.4p7-RC1
(4.2.5p159) 2009/03/28 Released by Harlan Stenn <stenn@ntp.org>
* "bias" changes from Dave Mills.
(4.2.5p158) 2009/01/30 Released by Harlan Stenn <stenn@ntp.org>
* Fix [CID 72], a typo introduced at the latest fix to prettydate.c.
(4.2.5p157) 2009/01/26 Released by Harlan Stenn <stenn@ntp.org>
* Cleanup/fixes for ntp_proto.c and ntp_crypto.c from Dave Mills.
(4.2.5p156) 2009/01/19 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1118] Fixed sign extension for 32 bit time_t in caljulian() and prettydate().
  Fixed some compiler warnings about missing prototypes.
  Fixed some other simple compiler warnings.
* [Bug 1119] [CID 52] Avoid a possible null-dereference in ntp_crypto.c.
* [Bug 1120] [CID 51] INSIST that peer is non-null before we dereference it.
* [Bug 1121] [CID 47] double fclose() in ntp-keygen.c.
(4.2.5p155) 2009/01/18 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* CHU frequency updates.
* Design assertion fixes for ntp_crypto.c from Dave Mills.
(4.2.5p154) 2009/01/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 992] support interface event change on Linux from
  Miroslav Lichvar.
(4.2.5p153) 2009/01/09 Released by Harlan Stenn <stenn@ntp.org>
* Renamed gsoc_sntp/:fetch-stubs to gsoc_sntp/fetch-stubs to avoid
  file name problems under Windows.
  Removed German umlaut from log msg for 4.2.5p142.
(4.2.5p152) 2009/01/08 Released by Harlan Stenn <stenn@ntp.org>
* Include 4.2.4p6: 2009/01/08 Released by Harlan Stenn <stenn@ntp.org>
(4.2.5p151) 2008/12/23 Released by Harlan Stenn <stenn@ntp.org>
* Stats file logging cleanup from Dave Mills.
(4.2.5p150) 2008/12/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1099] Fixed wrong behaviour in sntp's crypto.c.
* [Bug 1103] Fix 64-bit issues in the new calendar code.
(4.2.5p149) 2008/12/05 Released by Harlan Stenn <stenn@ntp.org>
* Fixed mismatches in data types and OID definitions in ntpSnmpSubAgent.c
* added a premliminary MIB file to ntpsnmpd (ntpv4-mib.mib)
(4.2.5p148) 2008/12/04 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1070] Fix use of ntpq_parsestring() in ntpsnmpd.
(4.2.5p147) 2008/11/27 Released by Harlan Stenn <stenn@ntp.org>
* Update gsoc_sntp's GCC warning code.
(4.2.5p146) 2008/11/26 Released by Harlan Stenn <stenn@ntp.org>
* Update Solaris CFLAGS for gsoc_sntp.
(4.2.5p145) 2008/11/20 Released by Harlan Stenn <stenn@ntp.org>
* Deal with time.h for sntp under linux.
* Provide rpl_malloc() for sntp for systems that need it.
* Handle ss_len and socklen type for sntp.
* Fixes to the sntp configure.ac script.
* Provide INET6_ADDRSTRLEN if it is missing.
* [Bug 1095] overflow in caljulian.c.
(4.2.5p144) 2008/11/19 Released by Harlan Stenn <stenn@ntp.org>
* Use int32, not int32_t.
* Avoid the sched*() functions under OSF - link problems.
(4.2.5p143) 2008/11/17 Released by Harlan Stenn <stenn@ntp.org>
* sntp cleanup and fixes.
(4.2.5p142) 2008/11/16 Released by Harlan Stenn <stenn@ntp.org>
* Imported GSoC SNTP code from Johannes Maximilian Kuehn.
(4.2.5p141) 2008/11/13 Released by Harlan Stenn <stenn@ntp.org>
* New caltontp.c and calyearstart.c from Juergen Perlinger.
(4.2.5p140) 2008/11/12 Released by Harlan Stenn <stenn@ntp.org>
* Cleanup lint from the ntp_scanner files.
* [Bug 1011] gmtime() returns NULL on windows where it would not under Unix.
* Updated caljulian.c and prettydate.c from Juergen Perlinger.
(4.2.5p139) 2008/11/11 Released by Harlan Stenn <stenn@ntp.org>
* Typo fix to driver20.html.
(4.2.5p138) 2008/11/10 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 474] --disable-ipv6 is broken.
* IPv6 interfaces were being looked for twice.
* SHM driver grabs more samples, add clockstats
* decode.html and driver20.html updates from Dave Mills.
(4.2.5p137) 2008/11/01 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1069] #undef netsnmp's PACKAGE_* macros.
* [Bug 1068] Older versions of netsnmp do not have netsnmp_daemonize().
(4.2.5p136) 2008/10/27 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1078] statsdir configuration parsing is broken.
(4.2.5p135) 2008/09/23 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1072] clock_update should not allow updates older than sys_epoch.
(4.2.5p134) 2008/09/17 Released by Harlan Stenn <stenn@ntp.org>
* Clean up build process for ntpsnmpd.
(4.2.5p133) 2008/09/16 Released by Harlan Stenn <stenn@ntp.org>
* Add options processing to ntpsnmpd.
* [Bug 1062] Check net-snmp headers before deciding to build ntpsnmpd.
* Clean up the libntpq.a build.
* Regenerate ntp_parser.[ch] from ntp_parser.y
(4.2.5p132) 2008/09/15 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1067] Multicast DNS service registration must come after the fork
  on Solaris.
* [Bug 1066] Error messages should log as errors.
(4.2.5p131) 2008/09/14 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1065] Re-enable support for the timingstats file.
(4.2.5p130) 2008/09/13 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1064] Implement --with-net-snmp-config=progname
* [Bug 1063] ntpSnmpSubagentObject.h is missing from the distribution.
(4.2.5p129) 2008/09/11 Released by Harlan Stenn <stenn@ntp.org>
* Quiet some libntpq-related warnings.
(4.2.5p128) 2008/09/08 Released by Harlan Stenn <stenn@ntp.org>
* Import Heiko Gerstung's GSoC2008 NTP MIB daemon.
(4.2.5p127) 2008/09/01 Released by Harlan Stenn <stenn@ntp.org>
* Regenerate ntpd/ntp_parser.c
(4.2.5p126) 2008/08/31 Released by Harlan Stenn <stenn@ntp.org>
* Stop libtool-1.5 from looking for C++ or Fortran.
* [BUG 610] Documentation update for NMEA reference clock driver.
* [Bug 828] Fix IPv4/IPv6 address parsing.
* Changes from Dave Mills:
  Documentation updates.
  Fix a corner case where a frequency update was reported but not set.
  When LEAP_NOTINSYNC->LEAP_NOWARNING, call crypto_update() if we have
  crypto_flags.
(4.2.5p125) 2008/08/18 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 1052] Add linuxPPS support to ONCORE driver.
(4.2.5p124) 2008/08/17 Released by Harlan Stenn <stenn@ntp.org>
* Documentation updates from Dave Mills.
* Include 4.2.4p5: 2008/08/17 Released by Harlan Stenn <stenn@ntp.org>
* [Bug 861] leap info was not being transmitted.
* [Bug 1046] refnumtoa.c is using the wrong header file.
* [Bug 1047] enable/disable options processing fix.
* header file cleanup.
* [Bug 1037] buffer in subroutine was 1 byte short.
* configure.ac: cleanup, add option for wintime, and lay the groundwork
  for the changes needed for bug 1028.
* Fixes from Dave Mills: 'bias' and 'interleave' work.  Separate
  phase and frequency discipline (for long poll intervals).  Update
  TAI function to match current leapsecond processing.
* Documentation updates from Dave Mills.
* [Bug 1037] Use all 16 of the MD5 passwords generated by ntp-keygen.
* Fixed the incorrect edge parameter being passed to time_pps_kcbind in
  NMEA refclock driver.
* [Bug 399] NMEA refclock driver does not honor time1 offset if flag3 set.
* [Bug 985] Modifications to NMEA reference clock driver to support Accord
  GPS Clock.
* poll time updates from Dave Mills.
* local refclock documentation updates from Dave Mills.
* [Bug 1022] Fix compilation problems with yesterday's commit.
* Updates and cleanup from Dave Mills:
  I've now spent eleven months of a sabbatical year - 7 days a week, 6-10
  hours most days - working on NTP. I have carefully reviewed every major
  algorithm, examined its original design and evolution from that design.
  I've trimmed off dead code and briar patches and did zillions of tests
  contrived to expose evil vulnerabilities. The development article is in
  rather good shape and should be ready for prime time.

  1. The protostats statistics files have been very useful in exposing
  little twitches and turns when something hiccups, like a broken PPS
  signal. Most of what used to be syslog messages are now repackaged as
  protostats messages with optional syslog as well. These can also be sent
  as traps which might be handy to tiggle a beeper or celltext. These, the
  sysstats files and cryptostats files reveal the ambient health of a busy
  server, monitor traffic and error counts and spot crypto attacks.

  2. Close inspection of the clock discipline behavior at long poll
  intervals (36 h) showed it not doing as well as it should. I redesigned
  the FLL loop to improve nominal accuracy from  several tens of
  milliseconds to something less than ten milliseconds.

  3. Autokey (again). The enhanced error checking was becoming a major
  pain. I found a way to toss out gobs of ugly fat code and replace the
  function with a much simpler and more comprehensive scheme. It resists
  bait-and-switch attacks and quickly detect cases when the protocol is
  not correctly synchronized.

  4. The interface code for the kernel PPS signal was not in sync with the
  kernel code itself. Some error checks were duplicated and some
  ineffective. I found none of the PPS-capable drivers, including the atom
  driver, do anything when the prefer peer fails; the kernel PPS signal
  remains in control. The atom driver now disables the kernel PPS when the
  prefer peer comes bum. This is important when the prefer peer is not a
  reference clock but a remote NTP server.

  5. The flake restrict bit turned out to be really interesting,
  especially with symmtric modes and of those especially those using
  Autokey. Small changes in the recovery procedures when packets are lost
  now avoid almost all scenarios which previously required protocol resets.

  6. I've always been a little uncomfortable when using the clock filter
  with long poll intervals because the samples become less and less
  correlated as the sample age exceeds the Allan intercept. Various
  schemes have been used over the years to cope with this fact. The latest
  one and the one that works the best is to use a modified sort metric
  where the delay is used when the age of the sample is less than the
  intercept and the sum of delay and dispersion above that. The net result
  is that, at small poll intervals the algorithm operates as a minimum
  filter, while at larger poll intervals it morphs to FIFO. Left
  unmodified, a sample could be used when twelve days old. This along with
  the FLL modifications has made a dramatic improvement at large poll
  intervals.

- [Backward Incompatible] The 'state' variable is no longer reported or
  available via ntpq output.  The following system status bit names
  have been changed:
  - sync_alarm -> leap_alarm
  - sync_atomic -> sync_pps
  - sync_lf_clock -> sync_lf_radio
  - sync_hf_clock -> sync_hf_radio
  - sync_uhf_clock -> sync_uhf_radio
  - sync_local_proto -> sync_local
  - sync_udp/time -> sync_other
  Other names have been changed as well.  See the change history for
  libntp/statestr.c for more details.
  Other backward-incompatible changes in ntpq include:
  - assID -> associd
  - rootdispersion -> rootdisp
  - pkt_head -> pkt_neader
  See the change history for other details.

* Updates and cleanup from Dave Mills.
* [Bug 995] Remove spurious ; from ntp-keygen.c.
* More cleanup and changes from Dave Mills.
* [Bug 980] Direct help to stdout.
---
(4.2.4p8) 2009/12/08 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 1331] DoS with mode 7 packets - CVE-2009-3563.

---
(4.2.4p7) 2009/05/18 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 1151] Remote exploit if autokey is enabled - CVE-2009-1252.
* [Bug 1187] Update the copyright date.
* [Bug 1191] ntpd fails on Win2000 - "Address already in use" after fix
  for [Sec 1149].

---
(4.2.4p7-RC7) 2009/05/12 Released by Harlan Stenn <stenn@ntp.org>

* ntp.isc.org -> ntp.org cleanup.
* [Bug 1178] Use prior FORCE_DNSRETRY behavior as needed at runtime,
  add configure --enable-ignore-dns-errors to be even more stubborn

---
(4.2.4p7-RC6) 2009/05/08 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 784] Make --enable-linuxcaps the default when available
* [Bug 1179] error messages for -u/--user and -i lacking droproot
* Updated JJY reference clock driver from Takao Abe
* [Bug 1071] Log a message and exit before trying to use FD_SET with a
  descriptor larger than FD_SETSIZE, which will corrupt memory
* On corruption of the iface list head in add_interface, log and exit

---
(4.2.4p7-RC5) 2009/05/02 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1172] 4.2.4p7-RC{3,4} fail to build on linux.
* flock-build script unportable 'set -m' use removed

---
(4.2.4p7-RC4) 2009/04/29 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1167] use gcc -Winit-self only if it is understood

---
(4.2.4p7-RC3) 2009/04/22 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 787] Bug fixes for 64-bit time_t on Windows
* [Bug 813] Conditional naming of Event
* [Bug 1147] System errors should be logged to msyslog()
* [Bug 1155] Fix compile problem on Windows with VS2005
* [Bug 1156] lock_thread_to_processor() should be declared in header
* [Bug 1157] quiet OpenSSL warnings, clean up configure.ac
* [Bug 1158] support for aix6.1
* [Bug 1160] MacOS X is like BSD regarding F_SETOWN

---
(4.2.4p7-RC2) 2009/04/09 Released by Harlan Stenn <stenn@ntp.org>

* [Sec 1144] limited buffer overflow in ntpq.  CVE-2009-0159
* [Sec 1149] use SO_EXCLUSIVEADDRUSE on Windows

---
(4.2.4p7-RC1) 2009/03/30 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1131] UDP sockets should not use SIGPOLL on Solaris.
* build system email address cleanup
* [Bug 774] parsesolaris.c does not compile under the new Solaris
* [Bug 873] Windows serial refclock proper TTY line discipline emulation
* [Bug 1014] Enable building with VC9 (in Visual Studio 2008,
  Visual C++ 2008, or SDK)
* [Bug 1117] Deferred interface binding under Windows works only correctly
  if FORCE_DNSRETRY is defined
* [BUG 1124] Lock QueryPerformanceCounter() client threads to same CPU
* DPRINTF macro made safer, always evaluates to a statement and will not
  misassociate an else which follows the macro.

---
(4.2.4p6) 2009/01/08 Released by Harlan Stenn <stenn@ntp.org>

* [Bug 1113] Fixed build errors with recent versions of openSSL.
* [Sec 1111] Fix incorrect check of EVP_VerifyFinal()'s return value.
* Update the copyright year.

---
(4.2.4p5) 2008/08/17 Released by Harlan Stenn <stenn@ntp.org>

* [BUG 1051] Month off by one in leap second message written to clockstats
  file fixed.
* [Bug 450] Windows only: Under original Windows NT we must not discard the
  wildcard socket to workaround a bug in NT's getsockname().
* [Bug 1038] Built-in getpass() function also prompts for password if
  not built with DEBUG.
* [Bug 841] Obsolete the "dynamic" keyword and make deferred binding
  to local interfaces the default.
  Emit a warning if that keyword is used for configuration.
* [Bug 959] Refclock on Windows not properly releasing recvbuffs.
* [Bug 993] Fix memory leak when fetching system messages.
* much cleanup, fixes, and changes from Dave Mills.
* ntp_control.c: LEAPTAB is a filestamp, not an unsigned.  From Dave Mills.
* ntp_config.c: ntp_minpoll fixes from Dave Mills.
* ntp-keygen updates from Dave Mills.
* refresh epoch, throttle, and leap cleanup from Dave Mills.
* Documentation cleanup from Dave Mills.
* [Bug 918] Only use a native md5.h if MD5Init() is available.
* [Bug 979] Provide ntptimeval if it is not otherwise present.
* [Bug 634] Re-instantiate syslog() and logfiles after the daemon fork.
* [Bug 952] Use md5 code with a friendlier license.
* [Bug 977] Fix mismatching #ifdefs for builds without IPv6.
* [Bug 830] Fix the checking order of the interface options.
* Clean up the logfile/syslog setup.
* [Bug 970] Lose obsolete -g flag to ntp-keygen.
* The -e flag to ntp-keygen can write GQ keys now, too.
* ntp_proto.c: sys_survivors and hpoll cleanup from Dave Mills.
* ntp_loopfilter.c: sys_poll cleanup from Dave Mills.
* refclock_wwv.c: maximum-likelihood digit and DSYNC fixes from Dave Mills.
* [Bug 967] preemptable associations are lost forever on a step.
* ntp_config.c: [CID 48] missing "else" clause.
* [Bug 833] ntpq config keyword is quote-mark unfriendly.
* Rename the ntpq "config" keyword to ":config".
* Dave Mills shifted some orphan processing.
* Fix typos in the [Bug 963] patch.
* bootstrap: squawk if genver fails.  Use -f with cp in case Dave does a chown.
* Remove obsolete simulator command-line options.
* ntp_request.c: [CID 36] zero sin_zero.
* [Bug 963] get_systime() is too noisy.
* [Bug 960] spurious syslog:crypto_setup:spurious crypto command
* [Bug 964] Change *-*-linux* to *-*-*linux* to allow for uclinux.
* Changes from Dave Mills:
  - ntp_util.c: cleanup.
  - ntp_timer.c: watch the non-burst packet rate.
  - ntp_request.c: cleanup.
  - ntp_restrict.c: RES_LIMITED cleanup.
  - ntp_proto.c: RES_LIMITED, rate bucktes, counters, overall cleanup.
  - ntp_peer.c: disallow peer_unconfig().
  - ntp_monitor.c: RES_LIMITED cleanup.
  - ntp_loopfilter.c: poll interval cleanup.
  - ntp_crypto.c: volley -> retry.  Cleanup TAI leap message.
  - ntp_config: average and minimum are ^2 values.
  - ntpdc: unknownversion is really "declined", not "bad version".
  - Packet retry cleanup.
* [Bug 961] refclock_tpro.c:tpro_poll() calls refclock_receive() twice.
* [Bug 957] Windows only: Let command line parameters from the Windows SCM GUI
  override the standard parameters from the ImagePath registry key.
* Added HAVE_INT32_T to the Windows config.h to avoid duplicate definitions.
* Work around a VPATH difference in FreeBSD's 'make' command.
* Update bugreport URL.
* Update -I documentation.
* [Bug 713] Fix bug reporting information.
* A bug in the application of the negative-sawtooth for 12 channel receivers.
* The removal of unneeded startup code used for the original LinuxPPS, it now
  conforms to the PPSAPI and does not need special code.
* ntp-keygen.c: Coverity fixes [CID 33,47].
* Volley cleanup from Dave Mills.
* Fuzz cleanup from Dave Mills.
* [Bug 861] Leap second cleanups from Dave Mills.
* ntpsim.c: add missing protypes and fix [CID 34], a nit.
* Upgraded bison at UDel.
* Update br-flock and flock-build machine lists.
* [Bug 752] QoS: add parse/config handling code.
* Fix the #include order in tickadj.c for picky machines.
* [Bug 752] QoS: On some systems, netinet/ip.h needs netinet/ip_systm.h.
* [Bug 752] Update the QoS tagging (code only - configuration to follow).
* Orphan mode and other protocol cleanup from Dave Mills.
* Documentation cleanup from Dave Mills.
* [Bug 940] ntp-keygen uses -v.  Disallow it as a shortcut for --version.
* more cleanup to ntp_lineeditlibs.m4.
* Documentation updates from Dave Mills.
* -ledit cleanup for ntpdc and ntpq.
* Association and other cleanup from Dave Mills.
* NTP_UNREACH changes from Dave Mills.
* Fix the readline history test.
* [Bug 931] Require -lreadline to be asked for explicitly.
* [Bug 764] When looking for -lreadline support, also try using -lncurses.
* [Bug 909] Fix int32_t errors for ntohl().
* [Bug 376/214] Enhancements to support multiple if names and IP addresses.
* [Bug 929] int32_t is undefined on Windows.  Casting wrong.
* [Bug 928] readlink missing braces.
* [Bug 788] Update macros to support VS 2005.
* ntpd/ntp_timer.c: add missing sys_tai parameter for debug printf
* [Bug 917] config parse leaves files open
* [Bug 912] detect conflicting enable/disable configuration on interfaces
  sharing an IP address
* [Bug 771] compare scopeid if available for IPv6 addresses
* Lose obsolete crypto subcommands (Dave Mills).
* WWV is an HF source, not an LF source (Dave Mills).
* [Bug 899] Only show -i/--jaildir -u/--user options if we HAVE_DROPROOT.
* [Bug 916] 'cryptosw' is undefined if built without OpenSSL.
* [Bug 891] 'restrict' config file keyword does not work (partial fix).
* [Bug 890] the crypto command seems to be required now.
* [Bug 915] ntpd cores during processing of x509 certificates.
* Crypto lint cleanup from Dave Mills.
* [Bug 897] Check RAND_status() - we may not need a .rnd file.
* Crypto cleanup from Dave Mills.
* [Bug 911] Fix error message in cmd_args.c.
* [Bug 895] Log assertion failures via syslog(), not stderr.
* Documentation updates from Dave Mills.
* Crypto cleanup from Dave Mills.
* [Bug 905] ntp_crypto.c fails to compile without -DDEBUG.
* Avoid double peer stats logging.
* ntp-keygen cleanup from Dave Mills.
* libopts needs to be built after ElectricFence.
* [Bug 894] Initialize keysdir before calling crypto_setup().
* Calysto cleanup for ntpq.
* ntp-keygen -i takes an arg.
* Cleanup and fixes from Dave Mills.
* [Bug 887] Fix error in ntp_types.h (for sizeof int != 4).
* Bug 880 bug fixes for Windows build
* Improve Calysto support.
* The "revoke" parameter is a crypto command.
* The driftfile wander threshold is a real number.
* [Bug 850] Fix the wander threshold parameter on the driftfile command.
* ntp_io.c: Dead code cleanup - Coverity View 19.
* Leap file related cleanup from Dave Mills.
* ntp_peer.c: Set peer->srcadr before (not after) calling set_peerdstadr().
* Initialize offset in leap_file() - Coverity View 17.
* Use the correct stratum on KISS codes.
* Fuzz bits cleanup.
* Show more digits in some debug printf's.
* Use drift_file_sw internally to control writing the drift file.
* Implement the wander_threshold option for the driftfile config keyword.
* reformat ntp_control.c; do not use c++ // comments.
* [Bug 629] Undo bug #629 fixes as they cause more problems than were  being
  solved
* Changes from Dave Mills: in/out-bound data rates, leapsecond cleanup,
  driftfile write cleanup, packet buffer length checks, documentation updates.
* More assertion checks and malloc()->emalloc(), courtesy of Calysto.
* [Bug 864] Place ntpd service in maintenance mode if using SMF on Solaris
* [Bug 862] includefile nesting; preserve phonelist on reconfig.
* [Bug 604] ntpd regularly dies on linux/alpha.
* more leap second infrastructure fixes from Dave Mills.
* [Bug 858] recent leapfile changes broke non-OpenSSL builds.
* Use emalloc() instead of malloc() in refclock_datum.c (Calysto).
* Start using 'design by contract' assertions.
* [Bug 767] Fast sync to refclocks wanted.
* Allow null driftfile.
* Use YYERROR_VERBOSE for the new parser, and fix related BUILT_SOURCES.
* [Bug 629] changes to ensure broadcast works including on wildcard addresses
* [Bug 853] get_node() must return a pointer to maximally-aligned memory.
* Initial leap file fixes from Dave Mills.
* [Bug 858] Recent leapfile changes broke without OPENSSL.
* Use a char for DIR_SEP, not a string.
* [Bug 850] driftfile parsing changes.
* driftfile maintenance changes from Dave Mills.  Use clock_phi instead of
  stats_write_tolerance.
* [Bug 828] refid string not being parsed correctly.
* [Bug 846] Correct includefile parsing.
* [Bug 827] New parsing code does not handle "fudge" correctly.
* Enable debugging capability in the config parser.
* [Bug 839] Crypto password not read from ntp.conf.
* Have autogen produce writable output files.
* [Bug 825] Correct logconfig -/+ keyword processing.
* [Bug 828] Correct parsing of " delimited strings.
* Cleanup FILE * usage after fclose() in ntp_filegen.c.
* [Bug 843] Windows Completion port code was incorrectly merged from -stable.
* [Bug 840] do fudge configuration AFTER peers (thus refclocks) have been
  configured.
* [Bug 824] Added new parser modules to the Windows project file.
* [Bug 832] Add libisc/log.c headers to the distribution.
* [Bug 808] Only write the drift file if we are in state 4.
* Initial import of libisc/log.c and friends.
* [Bug 826] Fix redefinition of PI.
* [Bug 825] ntp_scanner.c needs to #include <config.h> .
* [Bug 824] New parser code has some build problems with the SIM code.
* [Bug 817] Use longnames for setting ntp variables on the command-line;
  Allowing '-v' with and without an arg to disambiguate usage is error-prone.
* [Bug 822] set progname once, early.
* [Bug 819] remove erroneous #if 0 in Windows completion port code.
* The new config code missed an #ifdef for building without refclocks.
* Distribute some files needed by the new config parsing code.
* [Bug 819] Timeout for WaitForMultipleObjects was 500ms instead of INFINITE
* Use autogen 5.9.1.
* Fix clktest command-line arg processing.'
* Audio documentation updates from Dave Mills.
* New config file parsing code, from Sachin Kamboj.
* fuzz bit cleanup from Dave Mills.
* replay cleanup from Dave Mills.
* [Bug 542] Tolerate missing directory separator at EO statsdir.
* [Bug 812] ntpd should drop supplementary groups.
* [Bug 815] Fix warning compiling 4.2.5p22 under Windows with VC6.
* [Bug 740] Fix kernel/daemon startup drift anomaly.
* refclock_wwv.c fixes from Dave Mills.
* [Bug 810] Fix ntp-keygen documentation.
* [Bug 787] Bug fixes for 64-bit time_t on Windows.
* [Bug 796] Clean up duplicate #defines in ntp_control.c.
* [Bug 569] Use the correct precision for the Leitch CSD-5300.
* [Bug 795] Moved declaration of variable to top of function.
* [Bug 798] ntpq [p typo crashes ntpq/ntpdc.
* [Bug 786] Fix refclock_bancomm.c on Solaris.
* [Bug 774] parsesolaris.c does not compile under the new Solaris.
* [Bug 782] Remove P() macros from Windows files.
* [Bug 778] ntpd fails to lock with drift=+500 when started with drift=-500.
* [Bug 592] Trimble Thunderbolt GPS support.
* IRIG, CHU, WWV, WWVB refclock improvements from Dave Mills.
* [Bug 757] Lose ULONG_CONST().
* [Bug 756] Require ANSI C (function prototypes).
* codec (audio) and ICOM changes from Dave Mills.

---

* [Bug 450] Windows only: Under original Windows NT we must not discard the
  wildcard socket to workaround a bug in NT's getsockname().
* [Bug 1038] Built-in getpass() function also prompts for password if
  not built with DEBUG.
* [Bug 841] Obsolete the "dynamic" keyword and make deferred binding
  to local interfaces the default.
  Emit a warning if that keyword is used for configuration.
* [Bug 959] Refclock on Windows not properly releasing recvbuffs.
* [Bug 993] Fix memory leak when fetching system messages.
* [Bug 987] Wake up the resolver thread/process when a new interface has
  become available.
* Correctly apply negative-sawtooth for oncore 12 channel receiver.
* Startup code for original LinuxPPS removed.  LinuxPPS now conforms to
  the PPSAPI.
* [Bug 1000] allow implicit receive buffer allocation for Windows.
  fixes startup for windows systems with many interfaces.
  reduces dropped packets on network bursts.
  additionally fix timer() starvation during high load.
* [Bug 990] drop minimum time restriction for interface update interval.
* [Bug 977] Fix mismatching #ifdefs for builds without IPv6.
* Update the copyright year.
* Build system cleanup (make autogen-generated files writable).
* [Bug 957] Windows only: Let command line parameters from the Windows SCM GUI
  override the standard parameters from the ImagePath registry key.
* Fixes for ntpdate:
* [Bug 532] nptdate timeout is too long if several servers are supplied.
* [Bug 698] timeBeginPeriod is called without timeEndPeriod in some NTP tools.
* [Bug 857] ntpdate debug mode adjusts system clock when it shouldn't.
* [Bug 908] ntpdate crashes sometimes.
* [Bug 982] ntpdate(and ntptimeset) buffer overrun if HAVE_POLL_H isn't set
  (dup of 908).
* [Bug 997] ntpdate buffer too small and unsafe.
* ntpdate.c: Under Windows check whether NTP port in use under same conditions
  as under other OSs.
* ntpdate.c: Fixed some typos and indents (tabs/spaces).

(4.2.4p4) Released by Harlan Stenn <stenn@ntp.org>

* [Bug 902] Fix problems with the -6 flag.
* Updated include/copyright.def (owner and year).
* [Bug 878] Avoid ntpdc use of refid value as unterminated string.
* [Bug 881] Corrected display of pll offset on 64bit systems.
* [Bug 886] Corrected sign handling on 64bit in ntpdc loopinfo command.
* [Bug 889] avoid malloc() interrupted by SIGIO risk
* ntpd/refclock_parse.c: cleanup shutdown while the file descriptor is still
  open.
* [Bug 885] use emalloc() to get a message at the end of the memory
  unsigned types cannot be less than 0
